package archeopterix;

import archeopterix.algorithm.AlgorithmExecutor;
import archeopterix.conf.Conf;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.problem.generators.EmbeddedSystem;
import archeopterix.util.io.ProblemXMLParser;


public class Main {
    public static void main(String[] args) {
        System.out.println("*** Optimisation is starting  ***");
        if (args.length < 1 ){
            System.out.println( " -gen <hosts> <comps> <buses> <Servics>" );
            System.out.println( " -run <conffile>" );

        }
        else if (args[0].equals("-gen")){
            Integer iHosts = Integer.parseInt(args[1]);
            Integer iComps = Integer.parseInt(args[2]);
            Integer iBuses = Integer.parseInt(args[3]);
            Integer iService = 0;
            if (args.length >= 5)
                    iService = Integer.parseInt(args[4]);
            String sFileName = "./H"+ iHosts +"_C"+ iComps ;
            EmbeddedSystemProblem oContext = EmbeddedSystem.instance().generateInstance(iHosts, iComps, iBuses, iService);
            //ProblemToTextConverter.saveToText(oContext, sFileName + ".txt");
            ProblemXMLParser.saveProblem(oContext, sFileName + ".xml");       
        }

        else if (args[0].equals("-run")){
            Conf conf = Conf.instance();
            conf.loadFromXML(args[1]);
            conf.initLogging();
            AlgorithmExecutor algExec = new AlgorithmExecutor(Conf.instance());
            algExec.run();
        }

        System.out.println("*** DONE ***");
    }

}
