package archeopterix.algorithm;

//import java.text.DecimalFormat;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import archeopterix.util.CommonFormats;


public class Stats {
	private static final Log log = LogFactory.getLog(Stats.class);
	
	private static Stats instance = null;
	public long l_CntRnd; //Random Allocations
	public long l_CntRndD; //Counter Decion points 
	public long l_CntPPU; //Couter for Phermone probability usage
	public long l_CntMPU; //Counter for Max Phermone Usage
	public long l_CntTravel; //Counter for Max Phermone Usage
	private long l_CntEvalus;
	public long l_EvalTime; //To measure time spent at evaluation
	
	private Stats(){
		reset();
	}
	
	public void reset(){
		l_CntRndD = 0;
		l_CntRnd = 0;
		l_CntMPU = 0;
		l_CntPPU = 0;
		l_CntTravel = 0;
		l_CntEvalus = 0;
		l_EvalTime = 0;
	}
	public long getEvaluationCounter(){
            return l_CntEvalus;
        }
        public void incrementEvaluationCounter(){
            l_CntEvalus++;
        }
	public synchronized static Stats instance(){
		if (instance == null)
			instance = new Stats();
		return instance;
	}
	
	public void printStatistics(){
		if (log.isInfoEnabled()) {
			long lSum = l_CntRndD + l_CntMPU + l_CntPPU;
			lSum = (lSum==0)?1:lSum;

			log.info("STAT RandomD =" + l_CntRndD + "(" + CommonFormats.dFormatter.format(((double)l_CntRndD/lSum)*100 )+ "%) " + 
					"MaxPh =" + l_CntMPU + "(" + CommonFormats.dFormatter.format(((double)l_CntMPU/lSum)*100 )+ "%) " +
					"Ph Prob =" + l_CntPPU + "(" + CommonFormats.dFormatter.format(((double)l_CntPPU/lSum)*100) + "%)");

			lSum = l_CntRnd  + l_CntTravel;
			lSum = (lSum==0)?1:lSum;
			log.info("STAT Random=" + l_CntRnd + "(" + CommonFormats.dFormatter.format(((double)l_CntRnd/lSum)*100 )+ "%) " + 
					"Ph Travel=" + l_CntTravel + "(" + CommonFormats.dFormatter.format(((double)l_CntTravel/lSum)*100 )+ "%) " );
			//l_CntRnd = 0;
			//l_CntTravel = 0;
		}
	}
}
