/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.algorithm.aco;

import archeopterix.algorithm.Operators;
import archeopterix.problem.EmbeddedSystemProblem;

/** Generic operators for Simulated Annealing. These abstract methods should be
 * implemented in concrete classes for each solution representation
 * (Eg. ECUBasedDepSAOperators), and should be registered in SAOperatiorsFactory.
 * 
 * @author imeedeniya
 */

public abstract class ACOOperators implements Operators {
    public abstract Ant CreateAnt(ACO algorith, int iAnt);
    public abstract PheromoneMap createPheromoneMap(EmbeddedSystemProblem problem);
}
