package archeopterix.algorithm.aco;

import java.util.LinkedList;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.List;


public class PheromoneMap {
	private LinkedList<LinkedList<Double>> map_Pheromone ; // C x H
	private int i_Rows;
	//private int i_Cols;
	
	public PheromoneMap(int iRows, int iCols){
		i_Rows = iRows;
		map_Pheromone = new LinkedList<LinkedList<Double>>(); 
		for (int i=0; i<i_Rows; i++){
			LinkedList<Double> lstRow = new LinkedList<Double>();
			for (int j=0; j<iCols; j++){
				lstRow.add(1.0);
			}
			map_Pheromone.add(lstRow);
		}
	}
	
    //For variable number of options
    public PheromoneMap(int iRows, List<Integer> lstnumberofColumns){
        i_Rows = iRows;
        map_Pheromone = new LinkedList<LinkedList<Double>>();
		for (int i=0; i<i_Rows; i++){
			LinkedList<Double> lstRow = new LinkedList<Double>();
			for (int j=0; j< lstnumberofColumns.get(i); j++){
				lstRow.add(1.0);
			}
			map_Pheromone.add(lstRow);
		}
    }
	public void reset(){
		for (int i=0; i<i_Rows; i++){
			LinkedList<Double> lstRow = map_Pheromone.get(i);
			for (int j=0; j<lstRow.size(); j++){
				lstRow.set(j, 1.0);
			}
		}
	}
	
	public void UpdatePheromone(int iComp, int iHost, double dPM){
		LinkedList<Double> lstRow =  GetRow(iComp);
		//double dOldValue = lstRow.get(iHost).doubleValue();
		lstRow.set(iHost, dPM);
		map_Pheromone.set(iComp, lstRow);
	}
	
	public LinkedList<Double> GetRow(int iComp){
		return map_Pheromone.get(iComp);
	}
	
	public double GetPheromone(int iComp, int iHost){
		Double dRet = map_Pheromone.get(iComp).get(iHost);
		return dRet.doubleValue();
	}
	
    @Override
	public String toString(){
		String sRet = new String();
		sRet ="";
		NumberFormat formatter = new DecimalFormat("#0.00");
		for (int i=0; i<i_Rows; i++){
			sRet += "[ " ;
            List<Double> lstValues = map_Pheromone.get(i);
			for (int j=0; j<lstValues.size(); j++){
				sRet += formatter.format( GetPheromone(i,j) ) + "\t" ;
			}
			sRet += " ]" + "\n" ;
		}
		return  sRet;
	}
}