/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package archeopterix.algorithm.fitnessLandscapeCharacterisation;

import archeopterix.algorithm.localSearch.LocalSearch;
import archeopterix.problem.deployment.solution.GeneralDeploymentSolution;
import java.util.LinkedList;
import java.util.List;
import org.apache.commons.logging.Log;

/**
 *
 * @author Alda
 */
public class ConstraintPredictor extends LocalSearch{
    private List<Predictor> constraintPredictors;
    private double firstStepLength = 0.1; // as a percentage of total solution length
    
    public ConstraintPredictor(){
        constraintPredictors = new LinkedList<Predictor>();
    }
    
    @Override
    public void oneIteration() {
        oneOpt();
        incrementIteration();
    }
    
    public void oneOpt(){
        GeneralDeploymentSolution newSolution = new GeneralDeploymentSolution(problem, true);
        List<Double> fitnessSer = new LinkedList<Double>();
        List<Double> constraintSer = new LinkedList<Double>();
        problem.evaluateAttributes(newSolution);
        double initialFitness = newSolution.getAttributeValue(0);
        fitnessSer.add(initialFitness);
        newSolution.setConstraintViolation(problem);
        double initialConstraints = newSolution.getConstraintViolation();
        constraintSer.add(initialConstraints);
        int iComp = 0;
        while(iComp<i_Comps*firstStepLength){
            int host1= newSolution.getHostIndex(iComp);
            int host2=newSolution.getHostIndex(iComp+1);
            newSolution.set(iComp, host2, problem);
            newSolution.set(iComp+1, host1, problem);
            iComp++;
            problem.evaluateAttributes(newSolution);
            newSolution.setConstraintViolation(problem);
            fitnessSer.add(newSolution.getAttributeValue(0));
            constraintSer.add(newSolution.getConstraintViolation());
        }
        problem.evaluateAttributes(newSolution);
        double firstStepFitness = newSolution.getAttributeValue(0);
        newSolution.setConstraintViolation(problem);
        double firstStepConstraints = newSolution.getConstraintViolation();
        for(int jComp=iComp;jComp<i_Comps-1;jComp++){
            int host1= newSolution.getHostIndex(jComp);
            int host2=newSolution.getHostIndex(jComp+1);
            newSolution.set(jComp, host2, problem);
            newSolution.set(jComp+1, host1, problem);
            problem.evaluateAttributes(newSolution);
            newSolution.setConstraintViolation(problem);
            fitnessSer.add(newSolution.getAttributeValue(0));
            constraintSer.add(newSolution.getConstraintViolation());
        }
        problem.evaluateAttributes(newSolution);
        double secondStepFitness = newSolution.getAttributeValue(0);
        newSolution.setConstraintViolation(problem);
        double secondStepConstraints = newSolution.getConstraintViolation();
        Predictor consPred = new Predictor(firstStepConstraints-initialConstraints, secondStepConstraints-firstStepConstraints, firstStepFitness-initialFitness, secondStepFitness-firstStepFitness);
        //System.out.println(initialConstraints+":"+firstStepConstraints+":"+secondStepConstraints+":"+initialFitness+":"+firstStepFitness+":"+secondStepFitness);
        consPred.setConstraintSeries(constraintSer);
        consPred.setfitnessSeries(fitnessSer);
        constraintPredictors.add(consPred);
       // System.out.println(consPred.getConstraintStepCorrelation());      
    }
    public double getCanberraDistance(){
        double canberraDistance = 0.0;
        for(Predictor predA: constraintPredictors){
            for(Predictor predB: constraintPredictors){
                if(predA.getFirstStepConstraintDiff()!=0.0||predB.getFirstStepConstraintDiff()!=0.0)
                    canberraDistance+=(predA.getFirstStepConstraintDiff()-predB.getFirstStepConstraintDiff())/(predA.getFirstStepConstraintDiff() + predB.getFirstStepConstraintDiff());
                if(predA.getSecondStepConstraintDiff()!=0.0||predB.getSecondStepConstraintDiff()!=0.0){
                    canberraDistance+=(predA.getSecondStepConstraintDiff()-predB.getSecondStepConstraintDiff())/(predA.getSecondStepConstraintDiff() + predB.getSecondStepConstraintDiff());
                }
            }
        }
        return canberraDistance;    
    }
    
    @Override
    public void finalise(Log log) {
        log.debug("CanberraDistance:"+getCanberraDistance());
    }
    
}
