package archeopterix.algorithm.heuristic;

import java.util.LinkedList;
import java.text.DecimalFormat;
import java.text.NumberFormat;


public class ProbabilityTable {
	private LinkedList<LinkedList<Double>> map_PTapble ; // C x H
	private int i_Rows;
	private int i_Cols;
	
	public ProbabilityTable(int iRows, int iCols){
		i_Rows = iRows;
		i_Cols = iCols;
		 map_PTapble = new LinkedList<LinkedList<Double>>();
		for (int i=0; i<i_Rows; i++){
			LinkedList<Double> lstRow = new LinkedList<Double>();
			for (int j=0; j<i_Cols; j++){
				lstRow.add(1.0);
			}
			 map_PTapble.add(lstRow);
		}
	}
	
	public void reset(){
		for (int i=0; i<i_Rows; i++){
			LinkedList<Double> lstRow =  map_PTapble.get(i);
			for (int j=0; j<i_Cols; j++){
				lstRow.set(j, 1.0);
			}
		}
	}
	

    public void updateProbability(int iComp, int iHost, double dPM){
		 map_PTapble.get(iComp).set(iHost, dPM);
	}
	
	public LinkedList<Double> GetRow(int iComp){
		return  map_PTapble.get(iComp);
	}
	
   public double getProbability(int iComp, int iHost){
		Double dRet =  map_PTapble.get(iComp).get(iHost);
		return dRet.doubleValue();
	}
	
	public String toString(){
		String sRet = new String();
		sRet ="";
		NumberFormat formatter = new DecimalFormat("#0.00");
		for (int i=0; i<i_Rows; i++){
			sRet += "[ " ;
			for (int j=0; j<i_Cols; j++){
				sRet += formatter.format( getProbability(i,j) ) + "\t" ;
			}
			sRet += " ]" + "\n" ;
		}
		return  sRet;
	}
}
