/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.algorithm.heuristic;

/**
 *
 * @author aaleti
 */

import java.util.*;

import archeopterix.algorithm.Stats;
import archeopterix.conf.Conf;
import archeopterix.problem.Component;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.problem.deployment.solution.DeploymentSolution;
import archeopterix.problem.deployment.solution.OriginalDeploymentSolution;

public class Solution {

	public  LinkedList<Integer> m_CompsToAllocate;
	protected Component 		m_StartPoint;
    protected int i_ECUs;
    protected int i_Comps;
	private OriginalDeploymentSolution oDep;
	private EmbeddedSystemProblem problem;
	private BayesianHeuristic bh;


	public Solution(BayesianHeuristic bayesian, EmbeddedSystemProblem prob){
            bh = bayesian;
            problem = prob;
            i_ECUs = problem.getECUCount();
            i_Comps = problem.getComponentCount();
            oDep = new OriginalDeploymentSolution(problem);
	}

	public Solution(OriginalDeploymentSolution oDeployment){
		oDep = oDeployment;
	}

	public OriginalDeploymentSolution getArchitecture (){
		return oDep;
	}
	public boolean ConstructSolution(){
		((DeploymentSolution)oDep).reset();
		Random rnd = Conf.instance().random;
		for (int iCompIndex=0; iCompIndex < i_Comps; iCompIndex++){

			int iHostIndex = DecideHostIndex(iCompIndex);
			((OriginalDeploymentSolution)oDep).set(iCompIndex, iHostIndex);
		}
		return true;
	}

	protected int DecideHostIndex(int iCompIndex){
		LinkedList<Double> lstCum = new LinkedList<Double>();
		//Calculating Cumulative Values for probability
		double dTot=0.0;
		double dMax=0.0;
		int iMaxIndex=0;
		double dF = 0.0;
		for (int iHostIndex=0; iHostIndex < i_ECUs; iHostIndex++){
			
			dF+= bh.getProbabilityValue(iCompIndex, iHostIndex);
			
			//dF = m_Algo.arr_PhMap[0].GetPheromone(iCompIndex, iHostIndex);
			dTot+=dF;
			if(dF>dMax){
				dMax	= dF;
				iMaxIndex = iHostIndex;
			}
			lstCum.add(dTot);
		}
		Random rnd = Conf.instance().random;
		if ( dTot < 1E-4 ){
			Stats.instance().l_CntRndD++;
			return rnd.nextInt(i_ECUs);
		}

		else{
			double dTh = rnd.nextDouble()* dTot;
			int iHostIndex=0;
			//Selecting the host based on probability
			while( lstCum.get(iHostIndex)< dTh){
				iHostIndex++;
			}
			//System.out.println("Decide " + lstCum.toString() + "Rnd="+ dTh+ " =" + iHostIndex);
			Stats.instance().l_CntPPU++;
			return iHostIndex;
		}
	}


	@Override
	public String toString(){

		return  oDep.toString();
	}
}
