package archeopterix.algorithm.learning.benchmarks;

import archeopterix.algorithm.learning.utils.Bin;
import archeopterix.algorithm.learning.utils.Parameter;
import archeopterix.solution.Architecture;
import archeopterix.solution.comparator.GenericComparator;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;


public class APLearner<T extends Architecture> extends PMLearner<T>  {

    private HashMap<Object,AdaptPursuit> opSelector;
    double beta=0.8;
    @Override
     public void initialise(GenericComparator comp, List<Parameter> parameters) {
        super.initialise(comp, parameters);
        CreditAssignment crA;
        opSelector = new HashMap<Object,AdaptPursuit>();
         for(Map.Entry paramEntry : lstParametersToControl.entrySet()){
            Parameter param = (Parameter)paramEntry.getValue();
            AdaptPursuit opS= new AdaptPursuit(param.getNumberBins(), p_min, alpha, beta);
            opS.credit = new LinkedList<CreditAssignment>();
            List<Bin> lstBins = param.getListBins();
            for(Bin bin:lstBins){
                crA = new CreditAssignment(W, true, typeCAS, normalized);
                opS.credit.add(crA);
            }
            opSelector.put(param.getName(),opS);
        }
    }    

}