/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package archeopterix.algorithm.learning.benchmarks;


public class AdaptPursuit extends ProbMatching {

	double p_max;
	double beta;

	public AdaptPursuit(int N_operators, double P_min, double Alpha, double Beta) {
		super(N_operators, P_min, Alpha);
		p_max = 1.0 - (((double) n_operators - 1.0) * P_min);
		beta = Beta;
		alpha = Alpha;
	}

	@Override
	public void updateProbabilityVector() {
		int opmax = 0;
		double qualmax = 0.0;
		for (int i = 0; i < n_operators; i++) {
			if (quality[i] > qualmax) {
				qualmax = quality[i];
				opmax = i;
			}
		}
		prob[opmax] = prob[opmax] + (beta * (p_max - prob[opmax]));
		for (int i = 0; i < n_operators; i++) {
			if (i != opmax) {
				prob[i] = prob[i] + (beta * (p_min - prob[i]));
			}
		}
	}
}
