package archeopterix.algorithm.learning.benchmarks;


import archeopterix.algorithm.learning.utils.Bin;
import archeopterix.algorithm.learning.utils.Parameter;
import archeopterix.solution.Architecture;
import archeopterix.solution.comparator.GenericComparator;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class MABLearner<T extends Architecture> extends PMLearner<T>{
    protected double scalingC = 0.5, gamma = 100, decay = 0.5;
    protected boolean user = false;
    private Map<Object, BanditAlone> opSelector;

    @Override
     public void initialise(GenericComparator comp, List<Parameter> parameters) {
        super.initialise(comp, parameters);
        CreditAssignment crA;
        opSelector = new HashMap<Object,BanditAlone>();
         for(Map.Entry paramEntry : lstParametersToControl.entrySet()){
            Parameter param = (Parameter)paramEntry.getValue();
            BanditAlone opS= new BanditAlone(param.getNumberBins(), user, scalingC, 0, W);
            opS.credit = new LinkedList<CreditAssignment>();
            List<Bin> lstBins = param.getListBins();
            int inBins = lstBins.size();
            for(int i=0; i<inBins;i++){
                    crA = new CreditAssignment(W, true, typeCAS, normalized);
                    opS.credit.add(crA);
            }
            opSelector.put(param.getName(),opS);
        }
    }

}