package archeopterix.algorithm.learning.utils;

import java.util.LinkedList;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Alda
 */
public class Parameter {
    protected Object name;
    protected List<Bin> listBins;
    protected Bin currentBin;
    protected double[] cutPoints;
    protected int nBins;

    public Parameter(Object sName, int numberBins){
        nBins =numberBins;
        name = sName;
        listBins = new LinkedList<Bin>();
    }

    private Parameter() {}

    public double[] getCutPoints(){
        return cutPoints;
    }
    
    public void setCutPoints(double... cPoints){
        cutPoints = new double[cPoints.length];
        System.arraycopy(cPoints, 0, cutPoints, 0, cPoints.length);
    }

    public Bin getBin(int index){
        return listBins.get(index);
    }

    public void setName(Object newName){
        name=newName;
    }
    public void setListBins(List<Bin> newLstBins){
        listBins = new LinkedList<Bin>();
        for(Bin bin:newLstBins){
            listBins.add(bin);
        }
    }
    @Override
    public Parameter clone(){
        Parameter newParameter = new Parameter();
        newParameter.setName(name);
        if(currentBin!=null)
            newParameter.setCurrentBin(currentBin);    
        newParameter.setListBins(listBins);
        return newParameter;
    }
    public Object getName(){ return name;  }

    public void setCurrentBin(Bin newBin){
        if(newBin!=null)
            currentBin = newBin.clone();
    }
    public void setCurrentBin(int binIndex){
        currentBin = listBins.get(binIndex);
    }
    public Bin getCurrentBin(){ return currentBin;}
    public int getNumberBins(){return listBins.size();}

    public void initialiseBins(){
          listBins = new LinkedList<Bin>();
    }
    public List<Bin> getListBins(){
        return listBins;
    }
    public void initialiseRandomly(int iteration){
       Random random = new Random();
       int index = random.nextInt(listBins.size());
       currentBin = listBins.get(index).clone();
    }

    public String toString(){
        String st ="Parameter,"+name.toString()+",List of Bins";
        for(Bin bin: listBins){
            st+=","+bin.getValue()+",";
            
        }
        
        return st;
    }
}
