package archeopterix.algorithm.learning.utils;

import java.io.Serializable;
import java.util.Random;


public class ValueBin extends Bin implements Serializable{
    private double maxValue;
    private double minValue;

    public ValueBin ( double dMin, double dMax, int ind){
        super(ind);
        maxValue = dMax;
        minValue = dMin;
    }

    @Override
    public Bin clone(){
        Bin newBin = new ValueBin(minValue, maxValue, index);
        newBin.setValue(value);
        newBin.setBinPerformance(getBinPerformance().clone());
        return newBin;
    }
    public double getMin(){ 
        return minValue;
    }
    public double getMax(){ 
        return maxValue;
    }

    public void setMin(double min){
        minValue=min;
    }
    public void setMax(double max){
        maxValue=max;
    }
    public void setCurrentValueRandomly(){
        Random r = new Random();
        value = (Double) minValue + r.nextDouble() * ((Double)maxValue -(Double)minValue);
    }

}
