package archeopterix.algorithm.learning.utils;

import java.io.Serializable;
/*
 * @author aaleti
 */
public class ValueParameter extends Parameter implements Serializable {
    private double maxValue;
    private double minValue;

    public ValueParameter(Object sName, int numberBins, double dMin, double dMax){
        super(sName, numberBins);
        minValue = dMin;
        maxValue = dMax;
    }
    
    @Override
    public Parameter clone(){
        Parameter newParameter = new ValueParameter(name, nBins, minValue, maxValue);
        if(currentBin!=null)
            newParameter.setCurrentBin(currentBin);
        if(listBins!=null)
            newParameter.setListBins(listBins);
        return newParameter;
    }  

    public double getMinValue(){
        return minValue;
    }

    public double getMaxValue(){
        return maxValue;
    }
    @Override
    public void setCurrentBin(Bin newBin){
	super.setCurrentBin(newBin);
        ((ValueBin)currentBin).setCurrentValueRandomly();
    }
    @Override
    public void setCurrentBin(int binIndex){
        super.setCurrentBin(binIndex);
        ((ValueBin)currentBin).setCurrentValueRandomly();
    }
    
    @Override
    public void initialiseBins(){
        super.initialiseBins();
        double intervalLength = ((Double)maxValue - (Double)minValue) / nBins;
        for (int iLvl = 0; iLvl < nBins; iLvl++) {
            double mn = (double) minValue + iLvl * intervalLength;
            double mx = (double) minValue + (iLvl + 1) * intervalLength - intervalLength / 100000;
            Bin b = new ValueBin(mn, mx, iLvl);
            listBins.add(b);
        }
    }    
    
    @Override
    public String toString(){
        String st ="Parameter,"+name.toString()+",List of Bins";
        for(Bin bin: listBins){
            st+=","+((ValueBin)bin).getMin()+","+((ValueBin)bin).getMax()+",Performance,"+((ValueBin)bin).getBinPerformance().getAveragePerformance();           
        }       
        return st;
    }
}
