/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.algorithm.sa;

import archeopterix.algorithm.Operators;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.solution.Architecture;
import archeopterix.solution.OutOfOptionsException;

/** Generic operators for Simulated Annealing. These abstract methods should be
 * implemented in concrete classes for each solution representation
 * (Eg. ECUBasedDepSAOperators), and should be registered in SAOperatiorsFactory.
 * 
 * @author imeedeniya
 */

public abstract class SAOperators implements Operators {
	public abstract Architecture mutationMove(Architecture oArch, EmbeddedSystemProblem oProblem) throws OutOfOptionsException;//Default Mutation
}
