/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.constraints;

import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.solution.Architecture;

/**
 *
 * @author indika
 */
public abstract class ConstraintHandler {

    public static int CONSTRAINT_DEP_BANDWIDTH    = 0;
    public static int CONSTRAINT_DEP_MEMORY     = 1;
    //public static int CONSTRAINT_DEP_COLOCATION = 2;
    //public static int CONSTRAINT_DEP_LOCALIZATION = 3;
    

    public static int MAX_CONSTRAINTS = 2;

    /**
     * Validate whether an architecture satisfiyes a given constraint
     */
    protected EmbeddedSystemProblem m_Problem;
    protected boolean b_Enabled;
    
    public ConstraintHandler(EmbeddedSystemProblem oProblem){
        m_Problem = oProblem;
        b_Enabled = true;
    }
    public void setEnabled(boolean bEnabled){
        b_Enabled = bEnabled;
    }
    /**
     *
     * @param oArch
     * @return If disabled, return true. Otherwise, evaluate the constraint
     */
    public boolean checkConstraint(Architecture oArch){
         if ( !b_Enabled )
            return true;
         else
             return Validate(oArch);
    }
    
    protected abstract boolean Validate(Architecture oArch);
    public abstract int quantifySatisfaction(Architecture oArch);


}
