/**
 * 
 */
package archeopterix.constraints;

import cern.jet.stat.Probability;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.problem.deployment.solution.OriginalDeploymentSolution;

/**
 * FIXME Consider if an Algorithm interface should be created and the current contents of Algorithm be moved to some base class that is not used here; since it's not a solver.
 * FIXME Currently only works with Deployments; should work with any solutions; should make use of the PopulationGenerator (or some part of it that's responsible for creating an initial solution)
 */


public class FeasibilityCheck  {

	private EmbeddedSystemProblem problem;

	public FeasibilityCheck(EmbeddedSystemProblem problem) {

	this.problem = problem;
	}
	
	
	public void checkFeasibility() {
		OriginalDeploymentSolution oArch = new OriginalDeploymentSolution(problem.getECUCount(), problem.getComponentCount());
		double dE = 0.002; //Confidance Interval
		double dAlpha = 0.05; //Alpha
		double dP = 0;
		double dError = 0;
		double dWCN = Math.pow( Probability.normalInverse(dAlpha/2)/dE, 2)* 0.25;
		int iSuccess = 0;
		System.out.println("Worst Case Tests for Alpa="+dAlpha+" E="+dE+" :"+ dWCN);
		for(int iN=0; iN<dWCN; iN++){
			oArch.reset();
			oArch.randomlyAllocate(problem.getCompsSortedByPossibleAssignments());
			if ( problem.validate(oArch) ){
				iSuccess++;
				//System.out.print("1");
			}
			//else{
				//System.out.print("0");
				//}
			dP = (double)iSuccess / (double)iN;
			dError = Probability.normalInverse(dAlpha/2) * Math.sqrt( dP * (1-dP)/(double)iN);
			if (iN%1000 == 0){
				System.out.println("N="+ iN+ " Feasible="+iSuccess+ " P="+ dP + " Er=" + dError);
			}

		}
                //while(Math.abs(dError) > dE);
		
		
	}

}
