package archeopterix.evaluation;

//import java.util.*;

import archeopterix.problem.Component;
import archeopterix.problem.Host;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.problem.deployment.solution.DeploymentSolution;
import archeopterix.solution.Architecture;
import java.io.Serializable;
import java.util.List;

public class AvailabilityEvaluator extends ArchitectureEvaluator implements Serializable{

	public AvailabilityEvaluator(){
		super("Aval",false);
	}
	
	
	@Override
	public double evaluate(EmbeddedSystemProblem oProblem, Architecture oArch){
		double dAval = 1.0;
		List<Host> ecus = oProblem.getECUs();
                if (oArch instanceof DeploymentSolution){
                    DeploymentSolution oDep = (DeploymentSolution)oArch;
			
                    for(int iCompi=0; iCompi < oProblem.getComponentCount(); iCompi++){
                        int iHosti = oDep.getHostIndex(iCompi);
                        Host ecu = ecus.get(iHosti);
			double dLi  = ecu.getDoubleProperty(Host.FAILURE_RATE)*1000;
			double dRr	= ecu.getDoubleProperty(Host.REPAIR_RATE)*1000;
                        double dTime	= ecu.getDoubleProperty(Host.SOJOURN_TIME)/(3.6E5); //L for Lamda
				//int iRA = oRA.GetRALevel(iCompi);				
				dAval *= 1 - (double)(dLi/(dRr + dLi));
		
			}
		}
                //return Math.exp(dRet);
		//return Math.pow(dRet, oContext.d_ArrivalRate);
                //return Math.exp(dRet*oContext.d_ArrivalRate);
                return dAval;
	}

}
