/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.experiments;

import archeopterix.algorithm.Algorithm;
import archeopterix.algorithm.DefaultPopulationGenerator;
import archeopterix.algorithm.PopulationGenerator;
import archeopterix.conf.Conf;
import archeopterix.gui.ChartViewer;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.solution.Architecture;
import archeopterix.util.PropertyMap;
import archeopterix.util.probability.MyStatistics;
import archeopterix.util.probability.UncertaintyHandler;
import java.io.IOException;
import java.util.Collection;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 *
 * @author indika
 */
public class MCTestAlgorithm extends Algorithm{
    private final static Log log = LogFactory.getLog(MCTestAlgorithm.class);
    
    public MCTestAlgorithm(){
        super();
    }
    
@Override
	public void initialise(EmbeddedSystemProblem problem, PropertyMap externalParams, Collection<Architecture> partialInitPop, PopulationGenerator popGenerator) {
		super.initialise(problem, externalParams, partialInitPop, popGenerator);
        String populationFile = "./Population.txt";
        try {
            //population = popGenerator.generatePopulation(100, problem,ConstraintHandling.REPAIR);
            //DefaultPopulationGenerator.dumpPopulationToFile(population, populationFile);
            population = DefaultPopulationGenerator.ExtractPopulationFromFile(problem, populationFile, Conf.instance().getSolutionRepresentation().getName());
        } catch (IOException ex) {
            String msg = "Error reading the population file " + populationFile;
            if (log.isErrorEnabled()) {
                log.error(msg, ex);
            }

        }
	}

    @Override
    public void oneIteration() {
        //throw new UnsupportedOperationException("Not supported yet.");
        Architecture arch = population.get(4);
        
        UncertaintyHandler.instance().setMCRuns(10);
        problem.evaluateAttributes(arch);
        System.out.println("ARCH =" + arch.toString());
        System.out.println("ARCH BUF =" + arch.getSerializedString());
        
        String sAttrName = arch.getAttributeList().get(0).getName();
        MyStatistics oStat = (MyStatistics) arch.getProperty(sAttrName);
        ChartViewer.Ins().View();
        //for (int i =0; i<10000; i++){
        //    problem.evaluateAttributes(arch);
        //    oStat.update(arch.getAttributeList().get(0).getValue());
            //System.out.println("Run i= " + CommonFormats.dFormatter.format(arch.getAttributeList().get(0).getValue()));

        ChartViewer oChart = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
        oChart.SetData("Min" + oStat.getMinimum() + " MAx=" + oStat.getMaximum() + "Var=" + oStat.getVariance(), oStat.getFreqDistribution(100));
        //oChart.saveChart(".", "FD_FullRandom");
        oChart.View();
        oChart.saveChart("./", "Histogram");
        ChartViewer.Ins().saveChart("./", "Estimation");
        incrementIteration();
    }
}
