/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package archeopterix.experiments;

import archeopterix.util.statistics.BetaDistribution;
import archeopterix.util.statistics.ExponentialDistribution;
import archeopterix.util.statistics.NormalDistribution;
import archeopterix.util.statistics.ProbabilityDistribution;
import archeopterix.util.probability.DiscreteDistribution;
import archeopterix.util.probability.TriangularDistribution;
import java.util.Random;

/**
 *
 * @author indika
 */
public class RandomUtils {

    private Random m_Rnd = new Random();

    public ProbabilityDistribution getRandomPDF() {
        ProbabilityDistribution pdf = null;
        int iType = m_Rnd.nextInt(6);
        switch (iType) {
            case 0: //NORMAL
                double dMean = m_Rnd.nextDouble();
                double dVar = m_Rnd.nextDouble();
                dMean += 4* dVar; //to avoid negative range
                pdf = new NormalDistribution(dMean, dVar);
                break;
            case 1: //Shifted to one side
                pdf = new BetaDistribution(2, 10);
                break;
            case 2: //Shifted to other side
                pdf = new BetaDistribution(10, 2);
                break;
            case 3:
                pdf = new ExponentialDistribution(m_Rnd.nextDouble());
                break;
            case 4:
                pdf = new TriangularDistribution(0, m_Rnd.nextDouble(), 1);
                break;
            case 5:
                pdf = getRandomDiscretePDF(0,1);
                break;
        }
        return pdf;
    }

    public DiscreteDistribution getRandomDiscretePDF(double dMin, double dMax){
        int iLevels = m_Rnd.nextInt(10)+1;// 1~10
        int iArrSize =(iLevels +1) *2;
        double[] params = new double[iArrSize];

        double dSum = 0.0;
        double dNextDataPoint = dMin ;
        for (int i=0; i<iArrSize; i+=2 ){
            params[i] = dNextDataPoint  ;
            dNextDataPoint +=  ((dMax-dMin) / (double)iLevels);
            params[i+1] = m_Rnd.nextDouble();
            dSum += params[i+1];
        }
        //Normalizing
        for (int i=0; i<iArrSize; i+=2){
            params[i+1] = params[i+1]/dSum;
        }
        return new DiscreteDistribution(params);
    }

}