/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.experiments;

/**
 * Abstraction of sliding window of doubles.
 * @author Indika Meedeniya
 * email : indikamee@gmail.com
 */
public class SlidingWindow {

    private int i_Size = 0;
    private int i_NextIndex = 0;
    private boolean b_IsFilled = false;
    private double[] ad_Values = null;
    public SlidingWindow(int iSize){
        i_Size = iSize;
        ad_Values = new double[i_Size];
        i_NextIndex = 0;
        b_IsFilled = false;
    }

    public void add(double dVal){
        ad_Values[i_NextIndex] = dVal;
        i_NextIndex++;
        if (i_NextIndex >= i_Size){
            i_NextIndex = 0;
            b_IsFilled = true;
        }
    }
    /**
     * get the internal array
     * @return
     */
    public double[] getValues(){
        if (!b_IsFilled){ //Array has not filled yet. then patial array will be returnd
            double[] arrTemp = new double[i_NextIndex];
            for (int i=0; i<i_NextIndex; i++)
                arrTemp[i] = ad_Values[i];
            return arrTemp;
        }
        return ad_Values;
    }

    /**
     * W_r = 1.645 * VAR / (SQRT(N) * AVG)
     * @return relative error within the window
     */
    public double getRelativeError(){
        double[] arr = getValues();
        double n = arr.length;
        double dSumX = 0.0;
        double dSumX2 = 0.0;
        for (int i=0; i<n; i++){
            dSumX += arr[i];
            dSumX2 += (arr[i]*arr[i]);
        }
        double dMean = dSumX / n;
        double dSD = Math.sqrt( (dSumX2/n) -  (dMean*dMean));
        return 3.92 * dSD / ( Math.sqrt(n) * dMean);
    }
    
}
