/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package archeopterix.experiments;

import archeopterix.util.statistics.ProbabilityDistribution;
import archeopterix.gui.ChartViewer;
import archeopterix.util.CommonFormats;
import archeopterix.util.CommonFunctions;
import archeopterix.util.probability.DiscreteDistribution;
import archeopterix.util.probability.Distribution;
import archeopterix.util.probability.MonteCarlo;
import archeopterix.util.probability.MyStatistics;
import archeopterix.util.probability.ShiftedBetaDistribution;
import archeopterix.util.probability.UniformDistribution;
import archeopterix.util.statistics.BetaDistribution;
import archeopterix.util.statistics.ChiSqrDistribution;
import archeopterix.util.statistics.EWMA;
import archeopterix.util.statistics.ExponentialDistribution;
import archeopterix.util.statistics.GammaDistribution;
import archeopterix.util.statistics.NormalDistribution;
import archeopterix.util.statistics.WeibullDistribution;
import archeopterix.util.statistics.timeseries.ARIMA.AutoARIMA;
import com.numericalmethod.suanshu.stats.timeseries.univariate.stationaryprocess.arima.arma.ArmaModel;
import com.numericalmethod.suanshu.stats.timeseries.univariate.realtime.SimpleTimeSeries;
import com.numericalmethod.suanshu.stats.timeseries.univariate.realtime.TimeSeries;
import com.numericalmethod.suanshu.stats.timeseries.univariate.stationaryprocess.arima.arma.ConditionalSumOfSquares;
import com.numericalmethod.suanshu.stats.timeseries.univariate.stationaryprocess.arima.ArimaSim;


import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import java.util.Vector;
import jsc.datastructures.PairedData;
import jsc.regression.PearsonCorrelation;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 *
 * @author indika
 */
public class TestUtil {

    private static final Log log = LogFactory.getLog(TestUtil.class);
    private static final DecimalFormat df = CommonFormats.shortDecimal;
    private int i_MatrixSize = 10;
    private int i_nParams = 10;
    
   // private UncertaintyHandler uh = UncertaintyHandler.instance();

    private int i_MCStoppedAt = 0 ; // A temporary variable
    
    public static void main(String[] args) {
        System.out.println("*** Starting Archeopterix TEST UTIL *** " );
        TestUtil oTest = new TestUtil();
        oTest. runExperiment();
        oTest.logTest();
        System.out.println("*** Archeopterix TEST UTIL :DONE ***");
    }

    private void logTest(){
        System.out.println ("DEBUG :" + log.isDebugEnabled() );
        System.out.println ("TACE :" + log.isTraceEnabled() );
        System.out.println ("INFO :" + log.isInfoEnabled() );
        log.debug("THIS IS DEBUG");
        log.trace("THIS IS TRACE");
        log.info("THIS IS INFO");
    }
    /**
     * main function of the test util.
     */
    private void runExperiment() {
        //ProbabilisticDTMC oDTMC = new ProbabilisticDTMC(i_MatrixSize, createPDFs());
        //writeDTMC(oDTMC, "1.dat");
        //ProbabilisticDTMC oDTMC = readProbDTMC("1.dat");
        //runExperiment6(oDTMC , 1000,100);
        //runExperiment5(oDTMC , 1000);

        //runExperiment1(new ProbabilisticDTMC(i_MatrixSize, createPDFs()) , 10000);
        //runExperiment2(new ProbabilisticDTMC(i_MatrixSize, createPDFs()) , 1000);
        //runExperiment3(new ProbabilisticDTMC(i_MatrixSize, createPDFs()), 1000);
        //runExperiment4(200, 1000);
        //runExperiment7(10,1000);
        //runExperiment8(10,200);
		//plotSamplePDFs();
        //Experiment9();
		//Experiment10();
		Experiment11();
		//double[] adTS = {0.25,0.5,0.625,0.625,0.625,0.5,0.5,0.375,0.375,0.25,0.5,0.375,0.375,0.375,0.375,0.5,0.5,0.625,0.625,0.625,0.5,0.5,0.5,0.5,0.5,0.625,0.625,0.5,0.625,0.5,0.75,0.625,0.75,0.75,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.75,0.875,0.75,0.875,0.75};
		//compareForecastMethods(adTS, "1");
		//Exprriment11();
     }


	private void Experiment11(){
		double[][] matTS = {
			{0.375,0.5,0.5,0.625,0.375,0.375,0.375,0.25,0.375,0.5,0.25,0.25,0.375,0.625,0.75,0.75,0.5,0.5,0.5,0.5},
			{0.25,0.5,0.625,0.625,0.625,0.5,0.5,0.375,0.375,0.25,0.5,0.375,0.375,0.375,0.375,0.5,0.5,0.625,0.625,0.625,0.5,0.5,0.5,0.5,0.5,0.625,0.625,0.5,0.625,0.5,0.75,0.625,0.75,0.75,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.75,0.875,0.75,0.875,0.75},
			{0.125,0.125,0.125,0.375,0.375,0.25,0.125,0.375,0.375,0.375,0.375,0.25,0.125,0.25,0.375,0.375,0.375,0.25,0.25,0.25,0.25,0.25,0.375,0.5,0.5,0.375,0.375,0.375,0.375,0.375,0.375,0.5,0.5,0.5,0.5,0.375,0.5,0.5,0.5,0.5,0.5,0.5,0.5,0.375,0.5,0.5,0.5,0.375,0.5,0.375},
			{0.428571429,0.5,0.428571429,0.428571429,0.428571429,0.571428571,0.571428571,0.642857143,0.5,0.571428571,0.642857143,0.642857143,0.428571429,0.571428571,0.5,0.5,0.5,0.571428571,0.5,0.642857143,0.5,0.5,0.571428571,0.5,0.5,0.571428571,0.5,0.357142857,0.428571429,0.357142857,0.428571429,0.428571429,0.428571429,0.428571429,0.428571429,0.5,0.5,0.642857143,0.571428571,0.571428571,0.642857143,0.642857143,0.642857143,0.642857143,0.571428571,0.571428571,0.571428571,0.5,0.5,0.5},
			{0.444444444,0.444444444,0.444444444,0.333333333,0.555555556,0.555555556,0.555555556,0.444444444,0.666666667,0.777777778,0.444444444,0.555555556,0.333333333,0.555555556,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.444444444,0.555555556,0.444444444,0.444444444,0.444444444,0.444444444,0.555555556,0.666666667,0.555555556,0.444444444,0.333333333,0.333333333,0.333333333,0.555555556,0.555555556,0.444444444,0.444444444,0.444444444,0.444444444,0.555555556,0.444444444,0.444444444,0.555555556,0.555555556,0.444444444},
			{0.888888889,0.777777778,0.666666667,0.666666667,0.666666667,0.777777778,0.666666667,0.666666667,0.666666667,0.555555556,0.555555556,0.555555556,0.666666667,0.777777778,0.666666667,0.777777778,0.777777778,0.888888889,0.888888889,0.666666667,0.666666667,0.777777778,0.666666667,0.777777778,0.777777778,0.777777778,0.777777778,0.777777778,0.777777778,0.777777778,0.777777778,0.666666667,0.555555556,0.666666667,0.666666667,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.666666667,0.666666667,0.666666667,0.666666667,0.666666667,0.555555556,0.555555556,0.777777778,0.666666667,0.666666667},
			{0.538461538,0.615384615,0.538461538,0.384615385,0.461538462,0.384615385,0.615384615,0.692307692,0.461538462,0.461538462,0.615384615,0.615384615,0.461538462,0.538461538,0.461538462,0.461538462,0.461538462,0.461538462,0.615384615,0.615384615,0.615384615,0.538461538,0.615384615,0.615384615,0.538461538,0.538461538,0.538461538,0.538461538,0.615384615,0.538461538,0.538461538,0.538461538,0.461538462,0.461538462,0.538461538,0.538461538,0.538461538,0.538461538,0.538461538,0.461538462,0.538461538,0.538461538,0.538461538,0.538461538,0.461538462,0.461538462,0.384615385,0.538461538,0.538461538,0.538461538},
			{0.555555556,0.555555556,0.444444444,0.555555556,0.444444444,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.666666667,0.666666667,0.555555556,0.555555556,0.555555556,0.666666667,0.555555556,0.444444444,0.444444444,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.555555556,0.444444444,0.444444444,0.444444444,0.444444444,0.555555556,0.555555556,0.555555556,0.555555556,0.666666667,0.555555556,0.555555556,0.666666667,0.666666667,0.666666667,0.666666667,0.666666667,0.777777778,0.666666667,0.666666667},
			{0.4,0.5,0.6,0.5,0.6,0.5,0.5,0.4,0.4,0.6,0.7,0.6,0.6,0.5,0.6,0.5,0.4,0.5,0.4,0.5,0.6,0.6,0.6,0.5,0.5,0.5,0.5,0.5,0.4,0.4,0.5,0.4,0.5,0.5,0.5,0.5,0.5,0.5,0.6,0.6,0.6,0.6,0.6,0.5,0.4,0.5,0.6,0.5,0.6,0.4},
			{0.625,0.75,0.375,0.25,0.375,0.5,0.625,0.625,0.5,0.5,0.25,0.25,0.125,0.25,0.125,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.25,0.375,0.125,0.125,0.25,0.25,0.125,0.25,0.25,0.375,0.125,0.125,0.125,0.125,0.125,0.125,0.125,0.125,0.125,0.25,0.25,0.125,0.125,0.125,0.125},
			{0.5,0.125,0.5,0.375,0.625,0.625,0.625,0.25,0.375,0.5,0.625,0.75,0.625,0.625,0.625,0.625,0.375,0.5,0.375,0.5,0.625,0.625,0.625,0.5,0.5,0.5,0.5,0.625,0.5,0.625,0.625,0.625,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.75,0.625,0.75,0.75,0.75,0.75,0.5},
			{0.636363636,0.545454545,0.454545455,0.363636364,0.363636364,0.545454545,0.454545455,0.636363636,0.545454545,0.727272727,0.727272727,0.727272727,0.636363636,0.545454545,0.636363636,0.545454545,0.545454545,0.545454545,0.545454545,0.545454545,0.454545455,0.636363636,0.545454545,0.545454545,0.545454545,0.545454545,0.636363636,0.636363636,0.454545455,0.454545455,0.545454545,0.545454545,0.545454545,0.545454545,0.454545455,0.454545455,0.454545455,0.454545455,0.636363636,0.636363636,0.636363636,0.636363636,0.636363636,0.454545455,0.454545455,0.545454545,0.636363636,0.636363636,0.727272727,0.545454545},
		};
		
		for (int i=0; i< matTS.length; i++){
			compareForecastMethods(matTS[i], String.valueOf(i));
		}

	}
	private void compareForecastMethods(double[] adTimeSeries, String sID){
		int iSeriesLength = adTimeSeries.length;
		ChartViewer oValueChart = new ChartViewer("ForecastingMethods_" + sID, ChartViewer.CHART_TYPE_XY_LINE, false, false);
		ChartViewer oErrorChart = new ChartViewer("ForecastingERROR_" + sID, ChartViewer.CHART_TYPE_XY_LINE, false, false);
		int iMinLength =2;
		double dCumErrPearson = 0.0;
		double dCumErrEWMA = 0.0;
		double dCumErrARIMA = 0.0;
		double dCumErrRnd = 0.0;

		for (int t=0; t< iSeriesLength; t++ ){
			oValueChart.UpdateXY("DATA", String.valueOf(t), (t+1),adTimeSeries[t]);
			if (t < iMinLength )
				continue;
			double[] adHistory = Arrays.copyOf(adTimeSeries, t+1);
			double[] adIndexSet = CommonFunctions.getIndexSet(adHistory);
			//Pearsons prediction of Next value
			double dPearson = 0.0;
			try {
				PairedData pairedData = new PairedData(adIndexSet, adHistory);
				PearsonCorrelation pearsonCorrellation = new PearsonCorrelation(pairedData);
				double dA = pearsonCorrellation.getA();
				double dB = pearsonCorrellation.getB();
				double dr = pearsonCorrellation.getR();
				dPearson = dA + dB * (t+2);
				oValueChart.UpdateXY("PEARSON", String.valueOf(t+1), (t+2),dPearson);

			} catch (Exception ex) {
				System.err.println("Error Occured in Pearson method :"+ ex.toString());
			}



			

			//EWMA Prediction
			EWMA ewmaModel = new EWMA(adHistory,0.3);
			double dEWMAPrediction = ewmaModel.getNextPrediction();
			oValueChart.UpdateXY("EWMA", String.valueOf(t+1), (t+2), dEWMAPrediction);


			//Random Algorithm
			//double dMin = CommonFunctions.getMin(adHistory);
			//double dMax = CommonFunctions.getMax(adHistory);
			//double dRandomPrediction = dMin + Conf.instance().random.nextDouble()* (dMax-dMin);
			//oValueChart.UpdateXY("RANDOM", String.valueOf(t+1), (t+2), dRandomPrediction);
			

			//ARIMA Prediction
			double[] adArimaTS = new double[adHistory.length];
			for (int i=0; i< adHistory.length; i++)
				adArimaTS[i] = adHistory[i]*10;
			TimeSeries timeData = new SimpleTimeSeries(adArimaTS);
			ConditionalSumOfSquares arimaFitting = new ConditionalSumOfSquares(timeData, 1,1,0);
			ArmaModel model = arimaFitting.getFittedARMA();
			ArimaSim simModel = new ArimaSim(t+2, model);
			double adMean = CommonFunctions.getAverage(adArimaTS);
			double dArimaPrediction = (simModel.get(t+2)+adMean) / 10.0;
			oValueChart.UpdateXY("ARIMA", String.valueOf(t+1), (t+2),dArimaPrediction);


			//
			
			if ((t+2) < iSeriesLength){
				dCumErrPearson += Math.abs(adTimeSeries[t+1] - dPearson);
				dCumErrEWMA += Math.abs(adTimeSeries[t+1] - dEWMAPrediction);
				dCumErrARIMA += Math.abs(adTimeSeries[t+1] - dArimaPrediction);
				//dCumErrRnd += Math.abs(adTimeSeries[t+1] - dRandomPrediction);
				oErrorChart.UpdateXY("PEARSON", String.valueOf(t+1), (t+2),dCumErrPearson);
				oErrorChart.UpdateXY("EWMA", String.valueOf(t+1), (t+2),dCumErrEWMA);
				oErrorChart.UpdateXY("ARIMA", String.valueOf(t+1), (t+2),dCumErrARIMA);
				//oErrorChart.UpdateXY("RANDOM", String.valueOf(t+1), (t+2),dCumErrRnd);
			}
		}
		oValueChart.saveChart("./", "FORECAST_" + sID);
		oErrorChart.saveChart("./", "ERR_" + sID);
		//oValueChart.View();
		//oErrorChart.View();
	}

	
	//FOR ARIMA TESTING
	private void Experiment10(){
		//double[] adHistory = {0.25,0.5,0.625,0.625,0.625,0.5,0.5,0.375,0.375,0.25,0.5,0.375,0.375,0.375,0.375,0.5,0.5,0.625,0.625,0.625,0.5,0.5,0.5,0.5,0.5,0.625,0.625,0.5,0.625,0.5,0.75,0.625,0.75,0.75,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.75,0.875,0.75,0.875,0.75};
		ChartViewer oChart = new ChartViewer("TEST", ChartViewer.CHART_TYPE_XY_LINE, false, false);
		double[] adHistory= {12.8, 12.2, 11.9, 10.9, 10.6, 11.3, 11.1, 10.4, 10.0, 9.7, 9.7, 9.7, 11.1, 10.5, 10.3, 9.8, 9.8, 10.4, 10.4, 10.0, 9.7, 9.3, 9.6, 9.7, 10.8, 10.7, 10.3, 9.7, 9.5, 10.0, 10.0, 9.3, 9.0, 8.8, 8.9, 9.2, 10.4, 10.0, 9.6, 9.0, 8.5, 9.2, 9.0, 8.6, 8.3, 7.9, 8.0, 8.2, 9.3, 8.9, 8.9, 7.7, 7.6, 8.4, 8.5, 7.8, 7.6, 7.3, 7.2, 7.3,8.5, 8.2, 7.9, 7.4, 7.1, 7.9, 7.7, 7.2, 7.0, 6.7, 6.8, 6.9, 7.8, 7.6, 7.4, 6.6, 6.8, 7.2, 7.2, 7.0, 6.6, 6.3, 6.8, 6.7, 8.1, 7.9, 7.6, 7.1, 7.2, 8.2, 8.1, 8.1, 8.2, 8.7, 9.0, 9.3, 10.5, 10.1,9.9, 9.4, 9.2, 9.8, 9.9, 9.5, 9.0, 9.0, 9.4, 9.6, 11.0, 10.8, 10.4, 9.8, 9.7, 10.6, 10.5, 10.0, 9.8, 9.5, 9.7, 9.6, 10.9, 10.3,10.4, 9.3, 9.3, 9.8, 9.8, 9.3, 8.9, 9.1, 9.1, 9.1, 10.2, 9.9, 9.4};
		//double[] adHistory= {12.8, 12.2, 11.9,10.9, 10.6, 11.3, 11.1,10.4,10.0,9.7,9.7, 9.7, 11.1, 10.5};
		double[] exactForecast = {8.7, 8.6, 9.3, 9.1, 8.8, 8.5 };
		for (int i=0; i< adHistory.length; i++)
			adHistory[i] = 0.0;

		double[] adIndexSet = CommonFunctions.getIndexSet(adHistory);
		int[] adIntIndexSet = CommonFunctions.getIntIndexSet(adHistory);
		//Pearson

		PairedData o_PairedData = new PairedData(adIndexSet, adHistory);
		PearsonCorrelation o_PearsonCorrelation = null;
		try {
			o_PearsonCorrelation = new PearsonCorrelation(o_PairedData);
		} catch (Exception ex) {
			System.out.println(ex.toString());
		}
		try{
		double A = o_PearsonCorrelation.getA();
		double B = o_PearsonCorrelation.getB();
		double r = o_PearsonCorrelation.getR();



		for(int s=adIndexSet.length; s<adIndexSet.length+exactForecast.length;s++){
			double next = A + B * (s);
			oChart.UpdateXY("Pearson", String.valueOf(s),s-adIndexSet.length,next);
		}


		}catch(Exception ex){System.out.println(ex.toString());}

		//ARIMA suanshu
		TimeSeries timeData = new SimpleTimeSeries(adHistory);
		ConditionalSumOfSquares arimaFitting = new ConditionalSumOfSquares(timeData, 1,0,0);
		ArmaModel model = arimaFitting.getFittedARMA();

		//EWMA

		EWMA ewmaModel = new EWMA(adHistory,0.3);
		int iNPredictions = exactForecast.length;

		ArimaSim simModel = new ArimaSim(adHistory.length+iNPredictions, model);
		double adMean = CommonFunctions.getAverage(adHistory);

		double[] adTimeSeries = ewmaModel.getTimeSeries(adHistory.length+iNPredictions);

		// imsl ARIMA

        AutoARIMA autoArima = new AutoARIMA(adIntIndexSet,adHistory);
		autoArima.setCriticalValue(3.8);


		try {
			autoArima.compute(iNPredictions);
		} catch (Exception ex) {
			System.out.println(ex.toString());
		}
		
	    autoArima.forecast(iNPredictions+1);
		double[] outlierForecast = autoArima.getForecast();


		for (int i=adIndexSet.length; i<adIndexSet.length+iNPredictions;i++){
			oChart.UpdateXY("ARIMAsuanshu", String.valueOf(i), i-adIndexSet.length+1,(simModel.get(i+1)+adMean));
			oChart.UpdateXY("EWMA", String.valueOf(i), i-adIndexSet.length+1,adTimeSeries[i]);
		}
		for (int i=0; i<iNPredictions;i++){
		oChart.UpdateXY("ARIMA", String.valueOf(i), i+1, outlierForecast[i]);
		oChart.UpdateXY("DATA", String.valueOf(i),i+1,exactForecast[i]);
		}
		//adProbValues[i] = arma.getForecast()[0]; // Get the next forecast for roulette wheel seleciton.		
		//System.out.println (" Predicted : " + (simModel.get(adHistory.length+1)+ adMean) );
		oChart.View();
	
	}

private void Experiment12(){
		//double[] adHistory = {0.25,0.5,0.625,0.625,0.625,0.5,0.5,0.375,0.375,0.25,0.5,0.375,0.375,0.375,0.375,0.5,0.5,0.625,0.625,0.625,0.5,0.5,0.5,0.5,0.5,0.625,0.625,0.5,0.625,0.5,0.75,0.625,0.75,0.75,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.875,0.75,0.875,0.75,0.875,0.75};
		ChartViewer oChart = new ChartViewer("TEST", ChartViewer.CHART_TYPE_XY_LINE, false, false);
		//double[] adHistory= {12.8, 12.2, 11.9, 10.9, 10.6, 11.3, 11.1, 10.4, 10.0, 9.7, 9.7, 9.7, 11.1, 10.5, 10.3, 9.8, 9.8, 10.4, 10.4, 10.0, 9.7, 9.3, 9.6, 9.7, 10.8, 10.7, 10.3, 9.7, 9.5, 10.0, 10.0, 9.3, 9.0, 8.8, 8.9, 9.2, 10.4, 10.0, 9.6, 9.0, 8.5, 9.2, 9.0, 8.6, 8.3, 7.9, 8.0, 8.2, 9.3, 8.9, 8.9, 7.7, 7.6, 8.4, 8.5, 7.8, 7.6, 7.3, 7.2, 7.3,8.5, 8.2, 7.9, 7.4, 7.1, 7.9, 7.7, 7.2, 7.0, 6.7, 6.8, 6.9, 7.8, 7.6, 7.4, 6.6, 6.8, 7.2, 7.2, 7.0, 6.6, 6.3, 6.8, 6.7, 8.1, 7.9, 7.6, 7.1, 7.2, 8.2, 8.1, 8.1, 8.2, 8.7, 9.0, 9.3, 10.5, 10.1,9.9, 9.4, 9.2, 9.8, 9.9, 9.5, 9.0, 9.0, 9.4, 9.6, 11.0, 10.8, 10.4, 9.8, 9.7, 10.6, 10.5, 10.0, 9.8, 9.5, 9.7, 9.6, 10.9, 10.3,10.4, 9.3, 9.3, 9.8, 9.8, 9.3, 8.9, 9.1, 9.1, 9.1, 10.2, 9.9, 9.4};
		//double[] adHistory= {12.8, 12.2, 11.9,10.9, 10.6, 11.3, 11.1,10.4,10.0,9.7,9.7, 9.7, 11.1, 10.5};
		double[] exactForecast = {0.333333333,0.5,0.4,0.333333333,0.333333333,0.5,0.5,1.0,0.5,0.6};

		//for (int i=0; i< adHistory.length; i++)
		//	adHistory[i] = 0.0;

	
		Random rnd = new Random();
		// imsl ARIMA

		
		//double[] adHistory = {0.25,0.5,0.25,0.5,1.0,0.75,0.75,1.0,0.625,0.5,0.5,0.714,0.5,0.5,0.5,0.571,0.66666,0.25,0.4285,0.8571,0.8,0.285714286,0.5,0.5,0.6,0.5,0.5,0.333333333,0.0,0.666666667};
         double[] adHistory = {0.3,0.4,0.3,0.5,0.6,0.6,0.6,0.166666667,0.5,0.777777778,0.333333333,0.4,0.666666667,0.75,0.333333333,0.5,0.5,0.6,0.5,0.0,0.25,0.75,0.4,0.333333333,0.333333333,0.83333333,0.5,0.444444444,0.75,0.666666667,0.4,0.4,0.375,0.5,0.666666667,0.75,0.375,0.333333333,0.25,0.8};

		/*for(int i=0;i<adHistory.length; i++){
			adHistory[i]= rnd.nextFloat();
		}*/

		double [] series;
		double[] forecast = new double[adHistory.length];
		forecast[0]=adHistory[0];
		forecast[1]=adHistory[1];
		for(int j=2; j<adHistory.length; j++){

			series = new double[j];
			System.arraycopy(adHistory, 0, series, 0, j);

			double [] diffSeries = new double[series.length];
			diffSeries[0]=0;
			for(int s=1;s<series.length;s++){
				diffSeries[s]=series[s]-series[s-1];
			}
			int[] adIntIndexSet = CommonFunctions.getIntIndexSet(diffSeries);

			AutoARIMA autoArima = new AutoARIMA(adIntIndexSet,diffSeries);
			//autoArima.setCriticalValue(3.8);
			//compute(int p, int q, int s, int d)
			//int[] modelOrder= autoArima.getOptimumModelOrder();
			System.out.println("history length:" +j);
			try {
				autoArima.compute(4);
			} catch (Exception ex) {
				System.out.println(ex.toString());
			}
			try{
				autoArima.forecast(1);
			}catch (Exception ex) {
				System.out.println(series.toString());
				System.out.println(ex.toString());
			}
			double average = CommonFunctions.getAverage(series);
			double[] outlierForecast = autoArima.getForecast();
			forecast[j]=outlierForecast[0]+average;
		}
		for (int i=0; i<adHistory.length;i++){
		oChart.UpdateXY("ARIMA", String.valueOf(i), i+1, forecast[i]);
		oChart.UpdateXY("DATA", String.valueOf(i),i+1,adHistory[i]);
		}
		oChart.View();

	}



    /**
     * Chapter 4 Expeirments, random
     */
    private void Experiment9(){
        //ChartViewer.Ins().View();
        //for(int i=0; i<adV.length; i++)
        //    System.out.println("EXP V["+i+"]=" + adV[i]);
        int[] aiSizes = {10,20,50,100};
        int[] aiAdditionalParams = {1,2,5,10};
        int iID = 1;
        for( int iS = 0;  iS< aiSizes.length; iS++){
            for ( int iP=0; iP<aiAdditionalParams.length; iP++){
                doTest(iID, aiSizes[iS], aiAdditionalParams[iP]);
                iID++;
            }
        }
        doTest(1,10,2);
    }

    /**
     * Create a random DTMC of the given size and additional random params
     * Component reliabilities will be created from PDFs
     * @param iMatrixSize
     * @param iAdditionalParams
     */
    private void doTest (int iID, int iMatrixSize, int iAdditionalParams){
        i_MatrixSize = iMatrixSize;
        i_nParams = iAdditionalParams;

        double[] adGoals = {0.5, 0.70, 0.80};
        double[] adDyn = new double[adGoals.length];
        int aiMCStoped[] = new int[adGoals.length];
        double[] adFn = new double[adGoals.length];
        DTMCKubat oDTMC = new DTMCKubat(i_MatrixSize, createPDFs());
        ProbabilityDistribution[] aPDFRel = createReliabilityPDFs();
        String sOut = "";
        for (int iGoal =0 ;iGoal< adGoals.length; iGoal++){
            adDyn[iGoal] = RunDynamic(oDTMC, aPDFRel, adGoals[iGoal], 40, 0.005);
            aiMCStoped[iGoal] = i_MCStoppedAt;
            adFn[iGoal] = RunFixedMC(oDTMC, aPDFRel, adGoals[iGoal], 4000);
            sOut += (adGoals[iGoal] + ";" + aiMCStoped[iGoal] + ";" + adDyn[iGoal] + ";" + adFn[iGoal] + ";");
        }
        //Format ID, Percentile, MC Stop Size, Dynamic estimate, Fixed estimate, .. same
        System.out.println(iID + ";" + sOut);

    }
    private double RunDynamic(DTMCKubat oDTMC, ProbabilityDistribution[] aPDFRel,
            double dConfidence, int iEpochSize, double dMCTh){
         //uh.setMCStopCriteria(MCStopCriteria.DYNAMIC);
       // uh.setMCEpochSize(iEpochSize);
       // uh.setMCErrorTh(dMCTh);
       // uh.setRobustnessConfidance(dConfidence);

        MonteCarlo oMC = new MonteCarlo();
        MyStatistics oStat = new MyStatistics();
        int i=0;
        while(oMC.hasMoreRuns(oStat)){
            oDTMC.getRandom();
            double[] adRel = getReliabilitySamples(aPDFRel);
            double dRel = oDTMC.Compute(adRel);
            oStat.update(dRel);
            i++;
        }
        i_MCStoppedAt = i;
        return oStat.getEstimate();
    }

    private double RunFixedMC(DTMCKubat oDTMC, ProbabilityDistribution[] aPDFRel,
            double dConfidence, int iMCRuns){
       // uh.setMCStopCriteria(MCStopCriteria.FIXED_RUNS);
      //  uh.setMCRuns(iMCRuns);
       // uh.setRobustnessConfidance(dConfidence);

        MonteCarlo oMC = new MonteCarlo();
        MyStatistics oStat = new MyStatistics();
        int i=0;
        while(oMC.hasMoreRuns(oStat)){
            oDTMC.getRandom();
            double[] adRel = getReliabilitySamples(aPDFRel);
            double dRel = oDTMC.Compute(adRel);
            oStat.update(dRel);
            i++;
        }
        return oStat.getEstimate();
    }


    /**
     * Create random PDFs for component reliability values
     * @return
     */
    private ProbabilityDistribution[] createReliabilityPDFs(){
        RandomUtils oUtil = new RandomUtils();
        ProbabilityDistribution[] adPDFRel = new ProbabilityDistribution[i_MatrixSize];
        for (int i=0; i< i_MatrixSize; i++){
            adPDFRel[i] = oUtil.getRandomDiscretePDF(0.99, 0.999999);
            //System.out.println("PDF ["+ i +"]=" + adPDFRel[i].toString());
        }
        return adPDFRel;
    }

    /** Temporay method to obtain component reliabilities.
     *
     * @return
     */
    private double[] getReliabilitySamples(ProbabilityDistribution[] aPDFRel){
        MonteCarlo oMC = new MonteCarlo();
        double[] adRel = new double[i_MatrixSize];
        for(int i=0; i<i_MatrixSize; i++){
            adRel[i] = oMC.Sample(aPDFRel[i]);
        }
        return adRel;
    }

    /**
     * Read from a text file and initialize a DTMC object
     * @param sFileName
     * @return
     */
    private DTMCCheung80 readProbDTMC(String sFileName){
        FileInputStream fis = null;
        ObjectInputStream in = null;
        try {
            fis = new FileInputStream(sFileName);
            in = new ObjectInputStream(fis);
            DTMCCheung80 oDTMC = (DTMCCheung80) in.readObject();
            in.close();
            System.out.println("READ "+ oDTMC.toString());
            return oDTMC;
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        catch(ClassNotFoundException ex)
        {
            ex.printStackTrace();
        }
        return null;
    }

    /**
     * Write the DTMC structure to a file, using Java serialization
     * @param oDTMC
     * @param sFileName
     */
    private void writeDTMC(DTMCCheung80 oDTMC, String sFileName){
        FileOutputStream fos = null;
        try
        {
            fos = new FileOutputStream(sFileName);
            ObjectOutputStream out = new ObjectOutputStream(fos);
            out.writeObject(oDTMC);
            out.close();
        }
        catch(IOException ex)
        {
            ex.printStackTrace();
        }
    }
    /**
     * Experiment 8 : 
     * Create a DTMC and plot the non parametric percentile estimate for different no of MC runs
     */

    private void runExperiment8(int iMCBlockSize, int iBlocks){
        ProbabilityDistribution[] arrPDFs =  createPDFs();
        for (int iExp=0; iExp<4; iExp++){
            DTMCCheung80 oDTMC = new DTMCCheung80(i_MatrixSize, arrPDFs);
            MyStatistics oAllStats = new MyStatistics();
            ChartViewer oChart = new ChartViewer("Damping of the estimate", ChartViewer.CHART_TYPE_XY_LINE, true, false);
            //oChart.View();
            SlidingWindow oWindow = new SlidingWindow(10);
            for (int iBlock=0; iBlock<iBlocks; iBlock++){
                MyStatistics oStat = getFullRandomStats(oDTMC, iMCBlockSize);
                oAllStats.update(oStat);
                double dEstimate = oAllStats.getNonParametricEstimate(0.95);
                oChart.UpdateXY("MC Estimate", null, iBlock*iMCBlockSize, dEstimate);

                oWindow.add(dEstimate);
                if (oWindow.getValues().length > 3){
                    double dGiniValue = calcGiniCoefficient(oWindow.getValues());
                    oChart.UpdateXY("GINI", null, iBlock*iMCBlockSize, dGiniValue);
                }
            }
            oChart.saveChart(".", "DampingPlot[" + iExp+ "]");
        }
    }

    /**
     * Create Number of DTMC cases, and plot the Frequency distributions
     * of the output using full Monte Carlo runs.
     * @param iTests : Number of test cases
     * @param iMCRuns : Number of MC Runs for Each case
     */
    private void runExperiment7(int iTests, int iMCRuns) {
        ProbabilityDistribution[] arrPDFs =  createPDFs();
        for (int iRun=0; iRun<iTests; iRun++){
            DTMCCheung80 oDTMC = new DTMCCheung80(i_MatrixSize, arrPDFs);
            MyStatistics oStat = getFullRandomStats(oDTMC, iMCRuns);
            double dPE = oDTMC.getPointEstimate();
            if (log.isDebugEnabled()) {
                log.debug("Stats MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + " PE=" + dPE);
            }
            ChartViewer oChart = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
            oChart.SetData("X (MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + ") PE=" + dPE, oStat.getFreqDistribution(100));
            oChart.saveChart(".", "FreqDistribution[" + iRun+ "]");
            //oChart.View();
        }
    }

    /**
     * Monte Carlo simulation experiment
     * @param oDTMC
     * @param iMCRuns
     */
    private void runExperiment5(DTMCCheung80 oDTMC, int iMCRuns) {
        MyStatistics oStat = getFullRandomStats(oDTMC, iMCRuns);
        double dPE = oDTMC.getPointEstimate();
        double dMode = oStat.getMode(100);
        double dMedian = oStat.getMedian();
        double dMean = oStat.getMean();
        if (log.isDebugEnabled()) {
            log.debug("Stats MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + " PE=" + dPE);
            log.debug("Median =" + dMedian);
            log.debug("Mode = " + dMode);
        }

        //Weibull Params
        double dTemp = (Math.log(dMode)* Math.log(Math.log(2.0))/ Math.log(dMedian));
        double dK = 1.0/ (1 - Math.exp(dTemp)) ;//Weibull Shape Parameter

        //Beta Params
        double dAlpha = (1 - 2* dMode)* dMean/(dMean - dMode);
        double dBeta = dAlpha* (1-dMean)/ dMean;

        //Chi-Squre Parsm
        double dKChiSQ = Math.max(dMode+2,0.0);

        int iDists = 5;
        ProbabilityDistribution[] arrDist = new ProbabilityDistribution[iDists];
        arrDist[0] = new NormalDistribution( oStat.getMean(), oStat.getVariance());
        arrDist[1] = new ShiftedBetaDistribution(oStat.getMinimum(),oStat.getMaximum(), 2,10);
        arrDist[2] = new WeibullDistribution(dK);
        arrDist[3] = new GammaDistribution((dMode+1 + dMean)/2.0);
        arrDist[4] = new ChiSqrDistribution(dKChiSQ);

        ChartViewer oChart = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
        oChart.SetData("X (Mean=" + df.format(oStat.getMean()) + ",VAR=" + df.format(oStat.getVariance()) +
                " Mode=" + df.format(dMode) + " Median=" + df.format(dMedian) +
                ") PE=" + df.format(dPE), oStat.getFreqDistribution(100));
        oChart.saveChart(".", "FreqDistribution");
        oChart.View();

        oChart = new ChartViewer("Prob Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
        oChart.SetData("X (Mean=" + df.format(oStat.getMean()) + ",Var=" + df.format(oStat.getVariance()) + ") PE=" + df.format(dPE), oStat.getFreqDistribution(100));
        for (int i=0; i< iDists; i++){
             oChart.SetData(arrDist[i].toString(), arrDist[i].getPDF(oStat.getMinimum(), oStat.getMaximum(), 100));
        }
        oChart.saveChart(".", "ProbDistributions");
        oChart.View();
        
        oChart = new ChartViewer("Cum Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
        //oChart.SetData("X (MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + ") PE=" + dPE, oStat.getCumulativeDistribution(100));
        oChart.SetData("X", oStat.getCumulativeDistribution(100));
        for (int i=0; i< iDists; i++){
             oChart.SetData(arrDist[i].toString(), arrDist[i].getCDF(oStat.getMinimum(), oStat.getMaximum(), 100));
        }
        oChart.saveChart(".", "CumDistribution");

        oChart.View();
    }


    /**
     * Experiment 6 : Run MC runs in chunks. At each chunk, save graphs of FD, PDFs, and CDFs
     * @param oDTMC
     * @param iMCRuns
     */
    private void runExperiment6(DTMCCheung80 oDTMC, int iMCRuns, int iRunsPerBlock) {
        MyStatistics oStat = new MyStatistics();
        for (int iChunk = 0; iChunk < (iMCRuns / iRunsPerBlock); iChunk++) {
            int iRuns = iRunsPerBlock * (iChunk + 1) ;
            oStat.update(getFullRandomStats(oDTMC, iRunsPerBlock));
            double dPE = oDTMC.getPointEstimate();
            double dMode = oStat.getMode(100);
            double dMedian = oStat.getMedian();
            double dMean = oStat.getMean();
            if (log.isDebugEnabled()) {
                log.debug("Stats AT" + iRuns + " MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + " PE=" + dPE);
                log.debug("Median =" + dMedian);
                log.debug("Mode = " + dMode);

            }

            //Weibull Params
            double dTemp = (Math.log(dMode) * Math.log(Math.log(2.0)) / Math.log(dMedian));
            double dK = 1.0 / (1 - Math.exp(dTemp));//Weibull Shape Parameter

            //Beta Params
            double dAlpha = (1 - 2 * dMode) * dMean / (dMean - dMode);
            double dBeta = dAlpha * (1 - dMean) / dMean;

            //Chi-Squre Parsm
            double dKChiSQ = Math.max(dMode + 2, 0.0);

            int iDists = 5;
            ProbabilityDistribution[] arrDist = new ProbabilityDistribution[iDists];
            arrDist[0] = new NormalDistribution(oStat.getMean(), oStat.getVariance());
            arrDist[1] = new ShiftedBetaDistribution(oStat.getMinimum(), oStat.getMaximum(), 2, 10);
            arrDist[2] = new WeibullDistribution(dK);
            arrDist[3] = new GammaDistribution((dMode + 1 + dMean) / 2.0);
            arrDist[4] = new ChiSqrDistribution(dKChiSQ);

            ChartViewer oChart = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
            oChart.SetData("X (μ=" + df.format(oStat.getMean()) + ",σ²=" + df.format(oStat.getVariance())
                    + " Mode=" + df.format(dMode) + " Median=" + df.format(dMedian)
                    + ") PE=" + df.format(dPE), oStat.getFreqDistribution(100));
            oChart.saveChart(".", "FreqDistribution["+ iRuns +"]");
    
            oChart = new ChartViewer("Prob Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
            oChart.SetData("X (μ=" + df.format(oStat.getMean()) + ",σ²=" + df.format(oStat.getVariance()) + ") PE=" + df.format(dPE), oStat.getFreqDistribution(100));
            for (int i = 0; i < iDists; i++) {
                oChart.SetData(arrDist[i].toString(), arrDist[i].getPDF(oStat.getMinimum(), oStat.getMaximum(), 100));
            }
            oChart.saveChart(".", "ProbDistributions["+ iRuns +"]");
    
            oChart = new ChartViewer("Cum Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
            //oChart.SetData("X (MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + ") PE=" + dPE, oStat.getCumulativeDistribution(100));
            oChart.SetData("X", oStat.getCumulativeDistribution(100));
            for (int i = 0; i < iDists; i++) {
                oChart.SetData(arrDist[i].toString(), arrDist[i].getCDF(oStat.getMinimum(), oStat.getMaximum(), 100));
            }
            oChart.saveChart(".", "CumDistribution["+ iRuns +"]");

        }




    }


    /**
     * Case 1 : See the difference of point estimated mean, and statistical values of output
     */
    private void runExperiment1(DTMCCheung80 oDTMC, int iMCRuns) {
        MyStatistics oStat = getFullRandomStats(oDTMC, iMCRuns);
        double dPE = oDTMC.getPointEstimate();
        if (log.isDebugEnabled()) {
            log.debug("Stats MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + " PE=" + dPE);
        }

        ChartViewer oChart = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
        oChart.SetData("X (MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + ") PE=" + dPE, oStat.getFreqDistribution(100));
        oChart.saveChart(".", "FreqDistribution");
        oChart.View();
    }

    /**
     * Case 2 : Analyze the sensitivity to each parameter.
     * Graphs needs to be created with respect to change in each parameter
     */
    private void runExperiment2(DTMCCheung80 oDTMC, int iMCRuns) {
        double dPE = oDTMC.getPointEstimate();
        for (int iParam = 0; iParam < i_nParams; iParam++) {
            MyStatistics oStat = getDeltaStats(oDTMC, iParam, iMCRuns, true);
            if (log.isDebugEnabled()) {
                log.debug("Param=" + iParam + " Sample MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + "), PE=" + dPE);
            }
            ChartViewer oChart = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
            oChart.SetData("X (MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + "), PE=" + dPE, oStat.getFreqDistribution(100));
            oChart.saveChart(".", "Sensitivity_PARAM[" + iParam + "]");
        }
    }

    /**
     * Case3 : Comparision of metrics, PE, full random and parital random.
     * @param oDTMC
     * @param iMCRuns
     */
    private void runExperiment3(DTMCCheung80 oDTMC, int iMCRuns) {
        oDTMC.resetToMeans();
        double dPE = oDTMC.getPointEstimate();

        MyStatistics oStat = getFullRandomStats(oDTMC, iMCRuns);
        if (log.isDebugEnabled()) {
            log.debug("FullRandom MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + " PE=" + dPE);
        }

        ChartViewer oChart = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
        oChart.SetData("Full Rnd (MEAN=" + oStat.getMean() + " Var=" + oStat.getVariance() + ") PE=" + dPE, oStat.getFreqDistribution(100));
        oChart.saveChart(".", "FD_FullRandom");
        oChart.View();

        MyStatistics oConstrainedStats = new MyStatistics();
        for (int iParam = 0; iParam < i_nParams; iParam++) {
            MyStatistics oPartial = getDeltaStats(oDTMC, iParam, iMCRuns / i_nParams, false);
            oConstrainedStats.update(oPartial);
        }

        if (log.isDebugEnabled()) {
            log.debug("Constraind Random MEAN=" + oConstrainedStats.getMean() + " Var=" + oConstrainedStats.getVariance() + " PE=" + dPE);
        }

        ChartViewer oChart2 = new ChartViewer("Freq Dist", ChartViewer.CHART_TYPE_XY_LINE, true, false);
        oChart2.SetData("Constrained Rnd (MEAN=" + oConstrainedStats.getMean() + " Var=" + oConstrainedStats.getVariance() + ") PE=" + dPE, oConstrainedStats.getFreqDistribution(100));
        oChart2.saveChart(".", "FD_ConstrainedRandom");
        oChart2.View();

    }

    /**
     * CASE 4
     * Confidance value needs to be set at the conf object, which will be used in Mystats.estimate
     * @param iCases Number of problem instances i.e. random DTMCs to be compared
     * @param iMCRuns Monte-Carlo Runs.
     */
    private void runExperiment4(int iCases, int iMCRuns) {
        ProbabilityDistribution[] arrPDFs = createPDFs();
        List<CaseStatistics> lstCaseStats = new Vector<CaseStatistics>();
        List<CaseStatistics> lstCaseStatsPE = new Vector<CaseStatistics>();
        for (int iC = 0; iC < iCases; iC++) {
            DTMCCheung80 oDTMC = new DTMCCheung80(i_MatrixSize, arrPDFs);
            //Obtaining Full Random Statistics
            MyStatistics oFRStat = getFullRandomStats(oDTMC, iMCRuns);

            //Constrained Random Statistics
            MyStatistics oConstrainedStats = new MyStatistics();
            for (int iParam = 0; iParam < i_nParams; iParam++) {
                MyStatistics oPartial = getDeltaStats(oDTMC, iParam, iMCRuns / i_nParams, false);
                oConstrainedStats.update(oPartial);
            }
            double dEst1 = oFRStat.getEstimate();
            double dEst2 = oConstrainedStats.getEstimate();
            double dPE = oDTMC.getPointEstimate();
            lstCaseStats.add(new CaseStatistics(iC, dEst1, dEst2));
            lstCaseStatsPE.add(new CaseStatistics(iC, dEst1, dPE));
            if (log.isDebugEnabled()) {
                log.debug("CASE [" + iC + "]; FR;" + dEst1 + "; CR;" + dEst2);
            }
        }
        analyzeAndReport(lstCaseStats);
        analyzeAndReport(lstCaseStatsPE);

    }

    /**
     *  Take random sample from each distribution and compute the matrix, do it iRuns times and return statistics
     * @param oDTMC
     * @param iRuns
     * @return Statistics object
     */
    private MyStatistics getFullRandomStats(DTMCCheung80 oDTMC, int iRuns) {
        MyStatistics oStat = new MyStatistics();
        String sSamples = "";
        for (int i = 0; i < iRuns; i++) {
            //System.out.println("Random =" + oDTMC.getRandom().toString());
            oDTMC.getRandom();
            double dRnd = oDTMC.Compute();
            oStat.update(dRnd);
            if (log.isDebugEnabled()) {
                sSamples += (CommonFormats.dFormatter.format(dRnd) + ",");
            }
        }
        if (log.isTraceEnabled()) {
            log.debug("Random Samples= [" + sSamples + "]");
        }
        return oStat;
    }

    /**
     * Reset to means, and do iRuns only varying the specified parameter.
     * @param oDTMC
     * @param iParam
     * @param iRuns
     * @param bPlotResponse : Whether to plot funciton graph
     * @return Statistics
     *
     */
    private MyStatistics getDeltaStats(DTMCCheung80 oDTMC, int iParam, int iRuns, boolean bPlotResponse) {
        MyStatistics oStat = new MyStatistics();
        oDTMC.resetToMeans();
        String sSamples = "";
        ChartViewer oChart = null;
        if (bPlotResponse){
            oChart = new ChartViewer("Response Function for Param "+ iParam, ChartViewer.CHART_TYPE_XY_SCATTER, false, false);
        }
        for (int iRun = 0; iRun < iRuns; iRun++) {
            double dInput = oDTMC.getDelta(iParam);
            double dVal = oDTMC.Compute();
            if (bPlotResponse)
                oChart.UpdateXY("Resp. Param["+iParam+"]:" + oDTMC.getSubscribersList(iParam) , null, dInput, dVal);
            oStat.update(dVal);
            if (log.isDebugEnabled()) {
                sSamples += ("[" + CommonFormats.dFormatter.format(dInput) + "," + CommonFormats.dFormatter.format(dVal) + "],");
            }

        }
        
        if (bPlotResponse)
            oChart.saveChart(".","Response_PARAM[" + iParam + "]");
        if (log.isTraceEnabled()) {
            log.trace("Conditional Samples of Param[" + iParam + "]= [" + sSamples + "]");
        }
        return oStat;
    }
	/** Plot some graphs of PDFs for illustrations
	 *
	 */
	private void plotSamplePDFs(){
		ProbabilityDistribution[] arrPDFs = new ProbabilityDistribution[7];
		arrPDFs[0] = new NormalDistribution(3.75,0.5);
		Distribution.plotPDF(arrPDFs[0], arrPDFs[0].getBufString(), 0.75, 6.75, 100, "Normal");
		
		arrPDFs[1] = new BetaDistribution(10,2);
		Distribution.plotPDF(arrPDFs[1], arrPDFs[1].getBufString(), 0, 1, 100,"Beta");
		
		arrPDFs[2] = new ShiftedBetaDistribution(0.85,0.95,2,10);
		Distribution.plotPDF(arrPDFs[2], arrPDFs[2].getBufString(), 0.84, 0.96, 100, "BetaSft");
		
		arrPDFs[3] = new ExponentialDistribution(7.5E-6);
		Distribution.plotPDF(arrPDFs[3], arrPDFs[3].getBufString(), 0, 1E6, 100, "Exp");
		
		arrPDFs[4] = new WeibullDistribution(1.5);
		Distribution.plotPDF(arrPDFs[4], arrPDFs[4].getBufString(), 0,4, 100, "Weibull");

		double[] adArr= {2,0.4,2.1,0.5,2.3,0.1};
		arrPDFs[5] = new DiscreteDistribution(adArr);
		Distribution.plotPDF(arrPDFs[5], arrPDFs[5].getBufString(), 1.8, 2.4, 100, "Discrete");

		arrPDFs[6] = new UniformDistribution(0.3, 0.5);
		Distribution.plotPDF(arrPDFs[6], arrPDFs[6].getBufString(), 0.25, 0.55, 100, "Uniform");


	}
    /**
     * Create Random PDFs
     * @return array of random probability distributions
     */
    private ProbabilityDistribution[] createPDFs() {
        ProbabilityDistribution[] arrPDFs = new ProbabilityDistribution[i_nParams];
        RandomUtils oUtil = new RandomUtils();
        for (int i = 0; i < i_nParams; i++) {
            ProbabilityDistribution oDist = oUtil.getRandomPDF();
            arrPDFs[i] = oDist;
            //Distribution.plotPDF(oDist, oDist.getBufString(), 0, 1, 100, "DIST[" + i + "]");
            //Distribution.plotCDF(oDist, Distribution.getDistributionAsString(oDist), 0, 1, 100, "CDIST[" + i + "]");
            if (log.isTraceEnabled()) {
                log.debug("DIST[" + i + "] =" + oDist.getBufString() + " Th. Mean=" + Distribution.getAnalyticalMean(oDist));
            }
        }
        return arrPDFs;
    }

    /** Analyze and report equivalance of comparision metrics in the given cases
     *
     * @param lstCaseStats
     */
    private void analyzeAndReport(List<CaseStatistics> lstCaseStats) {
        //Analyze case statistics
        int iCases = lstCaseStats.size();
        int iEquals = 0;
        int iTotal = 0;
        for (int i = 0; i < iCases; i++) {
            CaseStatistics oStati = lstCaseStats.get(i);
            for (int j = 0; j < iCases; j++) {
                if (i == j) //Igonre self checks of stats
                {
                    continue;
                }
                CaseStatistics oStatj = lstCaseStats.get(j);
                // ! (A.1>B.1) XOR (A.2>B.2)
                if (!((oStati.d_Estimate1 > oStatj.d_Estimate1) ^ (oStati.d_Estimate2 > oStatj.d_Estimate2))) {
                    iEquals++;
                }
                iTotal++;
            }
        }
        double dSR = (double) iEquals * 100 / (double) iTotal;
        if (log.isDebugEnabled()) {
            log.debug("Success =" + iEquals + " outof " + iTotal + " (" + CommonFormats.shortDecimal.format(dSR) + "%) of Cases");
        }
    }

    /**
     * Temporary inner class to keep statistics of the case experiments
     */
    private class CaseStatistics {

        public int i_Case;
        public double d_Estimate1;
        public double d_Estimate2;

        public CaseStatistics(int iCase, double dEst1, double dEst2) {
            i_Case = iCase;
            d_Estimate1 = dEst1;
            d_Estimate2 = dEst2;
        }
    }


    /**
    * Calculate Gini value using a nested loop -- not optimised
    * @param values
    * @return
    */
    public static double calcGiniCoefficient(double[] values) {
        if (values.length < 1) {
            return 0; //not computable
        }
        if (values.length == 1) {
            return 0;
        }
        double relVars = 0;

        double descMean = mean(values);
        if (descMean == 0.0) {
            return 0; // only possible if all data is zero
        }
        for (int i = 0; i < values.length; i++) {
            for (int j = 0; j < values.length; j++) {
                if (i == j) {
                    continue;
                }
                relVars += (Math.abs(values[i] - values[j]));
            }
        }
        relVars = relVars / (2.0 * values.length * values.length);
        return (relVars / descMean); // return gini value
    }

    public static double mean(double[] p) {
        double sum = 0;  // sum of all the elements
        for (int i = 0; i < p.length; i++) {
            sum += p[i];
        }
        return sum / p.length;
    }//end method mean

}
