/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.problem.componentselection.algorithm.aco;

import archeopterix.algorithm.aco.ACO;
import archeopterix.algorithm.aco.ACOOperators;
import archeopterix.algorithm.aco.Ant;
import archeopterix.algorithm.aco.PheromoneMap;
import archeopterix.problem.Component;
import archeopterix.problem.EmbeddedSystemProblem;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author indika
 */
public class CSACOOperators extends ACOOperators{

    @Override
    public Ant CreateAnt(ACO algorith, int iAnt) {
        return new ComponentSelectionAnt(algorith, iAnt);
    }

    @Override
    public PheromoneMap createPheromoneMap(EmbeddedSystemProblem problem) {
        List<Integer> lstNColumns = new ArrayList<Integer>();
        int iComps = problem.getComponentCount();
        for (int i=0; i<iComps; i++)
            lstNColumns.add ( problem.getComponent(i).getNumberOptions());

        return new PheromoneMap(problem.getComponentCount(), lstNColumns);
    }

    public boolean canOperateOn(Class<?> solRepClass) {
        return  solRepClass.equals(ComponentSelectionAnt.class) ;
    }

}
