/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.problem.componentselection.algorithm.nsga;

import archeopterix.algorithm.ea.EAOperators;
import archeopterix.conf.Conf;
import archeopterix.problem.Component;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.problem.componentselection.solution.ComponentSelectionSolution;
import archeopterix.solution.Architecture;
import archeopterix.solution.OutOfOptionsException;
import java.util.List;
import java.util.Random;

/**
 *
 * @author indika
 */
public class CSEAOperators extends EAOperators{

  
    public Architecture mutate(Architecture oArch, EmbeddedSystemProblem context) throws OutOfOptionsException {
        return singlePointMutation(oArch, context);
    }


        public boolean canOperateOn(Class<?> solRepClass) {
        return solRepClass.equals(ComponentSelectionSolution.class);
    }

    @Override
    public Architecture uniformMutation(Architecture oArch, EmbeddedSystemProblem context, double prob) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public Architecture[] uniformCrossover(Architecture oParent1, Architecture oParent2, EmbeddedSystemProblem context, double prob) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public Architecture singlePointMutation(Architecture oArch, EmbeddedSystemProblem context) throws OutOfOptionsException {
        ComponentSelectionSolution oNew = new ComponentSelectionSolution((ComponentSelectionSolution)oArch);
        Random random = Conf.instance().random;
        int indx1 = random.nextInt(context.getComponentCount());
        int iNewOption = random.nextInt(oNew.getNOptions(indx1)) ;
        oNew.changeSelection(indx1, iNewOption);
        return oNew;
    }

    @Override
    public Architecture swapMutation(Architecture oArch, EmbeddedSystemProblem context) throws OutOfOptionsException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * Sligtly modified from OriginalDepEAOpertor's Crossover. Double Check
     * @param oParent1
     * @param oParent2
     * @param context
     * @return
     * @throws OutOfOptionsException
     */
    @Override
    public Architecture[] singlePointCrossover(Architecture oParent1, Architecture oParent2, EmbeddedSystemProblem context) throws OutOfOptionsException {
        int iIndex ;
		ComponentSelectionSolution[] parents = {(ComponentSelectionSolution)oParent1, (ComponentSelectionSolution) oParent2};
		ComponentSelectionSolution[] oOffspring = { new ComponentSelectionSolution( parents[0] ), new ComponentSelectionSolution( parents[1] ) };
		int[] parentHosts = new int[2];

		boolean choiceIsFixed = false;
		boolean outOfOptions = false;
		boolean swap ;

		Random rand = Conf.instance().random;
		int nComponents = context.getComponentCount();
		List<Component> comps = context.getComponents();


		//FIXME Returns a solution during first iteration; should it do something different?
		for(int timeout = 0; timeout < nComponents*2; timeout++)
		{
			do
			{
				iIndex = rand.nextInt(nComponents);
			}while (iIndex == 0 || iIndex == (nComponents-1));
			for (int i=iIndex; i<nComponents;i++)
			{
				swap = true;
				Component currentComp = comps.get(i);
				parentHosts[0] = (parents[0].getCurrentSelection(i));
				parentHosts[1] = (parents[1].getCurrentSelection(i));
				if (currentComp.mustColocate())
				{
					List<Component> colocationGroup = currentComp.getMustColocateWith(); // see if any of the buddies is already assigned
					for (Component component : colocationGroup)
					{
						if (component.index < i)//we have already assigned it
						{
							choiceIsFixed = true;

							if (oOffspring[0].getCurrentSelection(component.index) == parentHosts[0])
								swap = false;
						}
					}
				}
				List<Component> enemies = currentComp.getMustNotColocateWith();
				for (Component component : enemies)
				{
					if (component.index < i)//we have already assigned it
					{
						if (swap)
						{
							if (oOffspring[0].getCurrentSelection(component.index) == parentHosts[1]
								|| oOffspring[1].getCurrentSelection(component.index) == parentHosts[0])
							{
								if (choiceIsFixed)
									outOfOptions = true;
								else
								{
									swap = !swap;
									choiceIsFixed = true;
								}
							}
						}
						if(!swap)
						{
							if (oOffspring[0].getCurrentSelection(component.index) == parentHosts[0]
								|| oOffspring[1].getCurrentSelection(component.index) == parentHosts[1])
							{
								if (choiceIsFixed)
									outOfOptions = true;
								else
									swap = !swap;
							}
						}
					}
				}
				if (outOfOptions)
				{
					outOfOptions = false;
					timeout++;
					continue;
				}
				if (swap)
				{
					oOffspring[0].changeSelection(i, parentHosts[1]);
					oOffspring[1].changeSelection(i, parentHosts[0]);
				}
				else
				{
					oOffspring[0].changeSelection(i, parentHosts[0]);
					oOffspring[1].changeSelection(i, parentHosts[1]);
				}
			}
			return oOffspring;
		}
		throw new OutOfOptionsException("Could not find suitable crossover using " + context.getComponentCount() + " attempts.");
    }



}
