/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package archeopterix.problem.componentselection.algorithm.sa;

import archeopterix.algorithm.sa.SAOperators;
import archeopterix.conf.Conf;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.problem.componentselection.solution.ComponentSelectionSolution;
import archeopterix.solution.Architecture;
import archeopterix.solution.OutOfOptionsException;
import java.util.Random;

/**
 *
 * @author indika
 */
public class CSSAOperators extends SAOperators {

    public boolean canOperateOn(Class<?> solRepClass) {
        return solRepClass.equals(ComponentSelectionSolution.class);
    }

    @Override
    public Architecture mutationMove(Architecture oArch, EmbeddedSystemProblem oProblem) throws OutOfOptionsException {
        return pointMutate(oArch, oProblem);
    }

    public Architecture pointMutate(Architecture oArch, EmbeddedSystemProblem context) throws OutOfOptionsException {
        ComponentSelectionSolution oNew = new ComponentSelectionSolution((ComponentSelectionSolution)oArch);
        Random random = Conf.instance().random;
        int indx1 = random.nextInt(context.getComponentCount());
        int iNewOption = random.nextInt(oNew.getNOptions(indx1)) ;
        oNew.changeSelection(indx1, iNewOption);
        return oNew;
    }

}
