/**
 * 
 */
package archeopterix.problem.deployment;

import java.util.List;

import archeopterix.problem.Component;
import archeopterix.problem.Host;
import archeopterix.problem.EmbeddedSystemProblem;
import archeopterix.problem.deployment.constraints.DeploymentBandwidthConstraint;
import archeopterix.problem.deployment.constraints.DeploymentColocationConstraint;
import archeopterix.problem.deployment.constraints.DeploymentMemoryConstraint;
import archeopterix.problem.deployment.solution.DeploymentSolution;
import archeopterix.util.PropertyMap;

/**
 * FIXME Currently empty; what distinguishes a Deployment problem from a generic EmbeddedSystemProblem?
 */
public class Deployment extends EmbeddedSystemProblem {

    public Deployment(List<Host> oHostList, List<Component> oCompList, List<List<PropertyMap>> matNetwork, List<List<PropertyMap>> matInteractions) {
        super(oHostList, oCompList, matNetwork, matInteractions);
        addConstraint(new DeploymentMemoryConstraint(this));
        //addConstraint(new DeploymentColocationConstraint(this));
        addConstraint(new DeploymentBandwidthConstraint(this));
    }


    public int getMemoryAvailabilityForHost(int iHost, DeploymentSolution arch){
        Host oHost = lst_ECUs.get(iHost);
        int iRemainingHM = oHost.getIntProperty(Host.MEMORY);
        List<Component> lstComps = arch.getComponentListForHost(iHost, this);
        for (int i=0; i<lstComps.size(); i++){
            Component oComp = lstComps.get(i);
            iRemainingHM-= oComp.getIntProperty(Component.MEMORY);
        }
        return iRemainingHM;
    }
}
