package archeopterix.problem.deployment.algorithm.aco;

import java.util.*;


import archeopterix.algorithm.aco.ACO;
import archeopterix.algorithm.aco.Ant;
import archeopterix.algorithm.aco.PheromoneMap;
import archeopterix.conf.Conf;
import archeopterix.evaluation.Attribute;
import archeopterix.solution.Architecture;
import archeopterix.solution.FitnessComparator;

public class DepFitnessACO extends ACO {
    @Override
    protected void ReinitLocalObjects(){
        arr_PhMap[0].reset();
    }
   
    protected void ProcessNewSolution(Ant oAnt){
            checkDominance(oAnt.m_Memory);//Check and add to Elite Set
            //lstBatch.add(oAnt.m_Memory);
            List<Attribute> lstAttributes = oAnt.m_Memory.getAttributeList();
            for ( int j=0; j<lstAttributes.size(); j++ ){
                    Attribute oAtt = lstAttributes.get(j);
                    if ( updateMaxAttributeValues(oAtt, j) == true )
                            ReCalculateBatchFitness();
            }
            calculateFitness(oAnt.m_Memory);
    }

    //In case of change of max attributes, call this method
    private void ReCalculateBatchFitness(){
            for( int i=0; i<this.population.size(); i++){
                    Architecture oArch = population.get(i);
                    calculateFitness(oArch);
            }
    }


    public Ant CreateAnt(int iAnt) {
            // TODO Auto-generated method stub
            return new DepFitnessAnt(this, iAnt, i_Ants);
    }

    public void CreateObjects() {
            //Only one pheromone Map
            arr_PhMap[0] = new PheromoneMap(i_Comps, i_ECUs);
            arr_Comparator[0] = new FitnessComparator();
    }

    @Override
    protected void CallUpdateTrack(){
        Random rnd = Conf.instance().random;
        if (population.size() >= 1){
            for (int iupdates=0; iupdates<2; iupdates++){
                int iIndex = rnd.nextInt(population.size());
                Ant oAnt = (Ant)(population.get(iIndex)).m_UserData ;
                oAnt.UpdateTrack(0,10);
            }
        }

    }

	

}
