package archeopterix.problem.deployment.algorithm.aco;

import java.util.*;

import archeopterix.algorithm.Stats;
import archeopterix.algorithm.aco.ACO;
import archeopterix.conf.Conf;
import archeopterix.solution.Architecture;

//import common.Logger;

public class DepFitnessAnt extends DeploymentAnt {
	
	public DepFitnessAnt(ACO oAlgo, int iIndex, int iMax){
		super(oAlgo, iIndex, iMax);
	}
	
	public DepFitnessAnt(Architecture oDep, ACO oAlgo, int iIndex, int iMax){
		super(oDep, oAlgo, iIndex, iMax);
	}
	
	
	@Override
	protected void DoLocalPheromoneUpdate(int iCompIndex, int iHostIndex){
		int iAtt = 0;
		//for( int iAtt=0; iAtt<Conf.Ins().i_Attributes; iAtt++){
			double dPM = m_Algo.getPheromoneValue(iAtt, iCompIndex, iHostIndex);
			dPM = m_Algo.evaporatePheromone(dPM);
			m_Algo.setPheromeneValue(iAtt,iCompIndex, iHostIndex, dPM );
		//}
	}
	
	@Override
	protected int DecideHostIndex(int iCompIndex){
		LinkedList<Double> lstCum = new LinkedList<Double>();
		//Calculating Cumulative Values for probability
		double dTot=0.0;
		double dMax=0.0;
		int iMaxIndex=0;
 		for (int iHostIndex=0; iHostIndex < i_ECUs; iHostIndex++){
			double dF = m_Algo.getPheromoneValue(0,iCompIndex, iHostIndex);
			dTot+=dF;		
			if(dF>dMax){
				dMax	= dF;
				iMaxIndex = iHostIndex;
			}
			lstCum.add(dTot);
		}
		Random rnd = Conf.instance().random;
		if ( dTot < 1E-4 ){
			Stats.instance().l_CntRndD++;
			return rnd.nextInt(i_ECUs);
		}
		double dQ = rnd.nextDouble();
		if(dQ <= m_Algo.getThPheormone()){
			Stats.instance().l_CntMPU++;
			return iMaxIndex;
		}
		else{
			double dTh = rnd.nextDouble()* dTot;
			int iHostIndex=0;
			//Selecting the host based on probability
			while( lstCum.get(iHostIndex)< dTh){
				iHostIndex++;
			}
			//System.out.println("Decide " + lstCum.toString() + "Rnd="+ dTh+ " =" + iHostIndex);
			Stats.instance().l_CntPPU++;
			return iHostIndex;
		}
	}
}
	

