/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.problem.deployment.constraints;

import archeopterix.constraints.ConstraintHandler;
import archeopterix.problem.Component;
import archeopterix.problem.Host;
import archeopterix.problem.deployment.Deployment;
import archeopterix.problem.deployment.solution.DeploymentSolution;
import archeopterix.solution.Architecture;
import java.util.List;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 *
 * @author indika
 */
public class DeploymentColocationConstraint extends ConstraintHandler{

    private static final Log log = LogFactory.getLog(DeploymentColocationConstraint.class);

    public DeploymentColocationConstraint(Deployment oProblem){
        super(oProblem);
    }
    @Override
    protected boolean Validate(Architecture oArch) {
        DeploymentSolution oDep = (DeploymentSolution) oArch;
        int iECUs = m_Problem.getECUCount();
        int iComps = m_Problem.getComponentCount();
        Deployment oDepProblem = (Deployment)m_Problem;
        List<Host> lstECUs = m_Problem.getECUs();
        boolean valid = true;
        for ( int iHost =0; iHost< iECUs; iHost++){
            Host oECU = lstECUs.get(iHost);
            List<Integer> lstLoc = oECU.getIntListProperty(Host.LOC_LIST);
            for ( int iCompIndex =0; iCompIndex<iComps; iCompIndex++){
                int iLoc = (lstLoc.get(iCompIndex)).intValue();
                if ( iLoc == 0 ){
                    if (oDep.getHostIndex(iCompIndex) == iHost ){
                        if (log.isTraceEnabled()){
                            log.debug("Loc violated. C[" + iCompIndex+"] , H[" + iHost + "] =" + iLoc);
                            log.debug("We have an Ecu list of ");
                            List<Component> lstComps = m_Problem.getComponents();
                            for (int x = 0; x < lstComps.get(iCompIndex).getCanUseHostListLength(); x++)
                                log.debug(lstComps.get(iCompIndex).getHostOption(x).index + ", ");
                            log.debug("\n");
                        }
                        valid = false;
                    }
                }
            }
        }
        return valid;
    }

    @Override
    public int quantifySatisfaction(Architecture oArch) {
        int violations = 0;
        DeploymentSolution oDep = (DeploymentSolution) oArch;
        int iECUs = m_Problem.getECUCount();
        int iComps = m_Problem.getComponentCount();
        List<Host> lstECUs = m_Problem.getECUs();
        for ( int iHost =0; iHost< iECUs; iHost++){
            Host oECU = lstECUs.get(iHost);
            List<Integer> lstLoc = oECU.getIntListProperty(Host.LOC_LIST);
            for ( int iCompIndex =0; iCompIndex<iComps; iCompIndex++){
                if ( (lstLoc.get(iCompIndex)).intValue() == 0 ){
                    if (oDep.getHostIndex(iCompIndex) == iHost ){
                        violations++;
                     }
                }
            }
        }
        return violations;
    }

}
