/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.problem.deployment.constraints;

import archeopterix.constraints.ConstraintHandler;
import archeopterix.problem.Component;
import archeopterix.problem.Host;
import archeopterix.problem.deployment.Deployment;
import archeopterix.problem.deployment.solution.DeploymentSolution;
import archeopterix.solution.Architecture;
import java.io.Serializable;
import java.util.List;

public class DeploymentMemoryConstraint extends ConstraintHandler implements Serializable{

    public DeploymentMemoryConstraint(Deployment oProblem){
        super(oProblem);
    }
    @Override
    protected boolean Validate(Architecture oArch) {
        DeploymentSolution oDep = (DeploymentSolution) oArch;
        int iECUs = m_Problem.getECUCount();
        int iComps = m_Problem.getComponentCount();
        Deployment oDepProblem = (Deployment)m_Problem;
        //Memory Constraint
        List<Host> lstECUS = m_Problem.getECUs();
        for ( int iHost = 0; iHost< iECUs; iHost++ ){
            Host oHost =  lstECUS.get(iHost);
            int iRemainingHM = oHost.getIntProperty(Host.MEMORY);

                //NOTE: Neither of these is defined in the top-level Architecture class; may need to provide some guarantee of their existence (also, assert will only be checked in debug mode or if specifically requested when running program)
                //      assert (arch instanceof IndexBasedAllocation) || (arch instanceof ObjectBasedAllocation);
                //      List<Integer> lstCompIndices = (arch instanceof IndexBasedAllocation) ? ((IndexBasedAllocation) arch).GetComponentsIndexList(iHost) : null;
                //     List<Component> lstComps = (arch instanceof ObjectBasedAllocation) ? ((ObjectBasedAllocation) arch).GetComponentsList(iHost) : null;
            List<Component> lstComps = oDep.getComponentListForHost(iHost, oDepProblem);
            for (int i=0; i<lstComps.size(); i++)
            {
                Component oComp = lstComps.get(i);
                iRemainingHM-= oComp.getIntProperty(Component.MEMORY);
                if ( iRemainingHM < 0 )
                {
                                
                    return false;
                }
            }
        }
        return true;
    }

    @Override
    public int quantifySatisfaction(Architecture oArch) {
        int violations=0;
        DeploymentSolution oDep = (DeploymentSolution) oArch;
        int iECUs = m_Problem.getECUCount();
        List<Host> lstECUs = m_Problem.getECUs();
        for ( int iHost = 0; iHost< iECUs; iHost++ ){
            Host oHost = lstECUs.get(iHost);
            int iRemainingHM = oHost.getIntProperty(Host.MEMORY);
            List<Component> lstComps = oDep.getComponentListForHost(iHost, m_Problem);
            for (int i=0; i<lstComps.size(); i++){
                Component oComp = lstComps.get(i);
                iRemainingHM-= oComp.getIntProperty(Component.MEMORY);
            }
            if(iRemainingHM < 0){
                violations = -iRemainingHM;

            }
        }
        return violations;
    }

}
