package archeopterix.problem.redundancy.algorithm.aco;

import archeopterix.algorithm.aco.ACO;
import archeopterix.algorithm.aco.Ant;
import archeopterix.algorithm.aco.PheromoneMap;
import archeopterix.conf.Conf;
import archeopterix.solution.ArchitectureComparator;

public class RedundancyACO extends ACO {
	
	public Ant CreateAnt(int iAnt){
		return new RedundancyAnt(this, iAnt, i_Ants);
	}
	
	public void CreateObjects(Conf cnf){
                int iAttributes = Conf.instance().getNEvaluators();
		for ( int i=0; i< iAttributes; i++){
			arr_PhMap[i] = new PheromoneMap(i_Comps, cnf.getMaxRedundancyLevel());
			arr_Comparator[i] = new ArchitectureComparator(i);
		}
	}
}
