package archeopterix.util;

/**
 * A pair of items of the the same or different types.
 * @author  JMontgomery
 */
public class MixedPair<E1,E2> implements Cloneable {
	private E1 a;
	private E2 b;
	
	public MixedPair(E1 a, E2 b) {
		setA(a);
		setB(b);
	}
	
	public E1 getA() { return a; }
	
	public void setA(E1 a) { this.a = a; }
	
	public E2 getB() { return b; }
	
	public void setB(E2 b) { this.b = b; }
	
	/**
	 * Returns a shallow clone of this MixedPair.
	 */
	public Object clone() {
		//Inherited clone is fine as copies fields (i.e., does a shallow clone).
		try {
			return super.clone();
		} catch (CloneNotSupportedException cnse) {
			throw new RuntimeException(cnse);
		}
	}
	

}
