/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package archeopterix.util.probability;

import archeopterix.util.statistics.ProbabilityDistribution;

/**
 *
 * @author indika
 */
public class UniformDistribution extends ProbabilityDistribution{

    private double a,b,h;

    public UniformDistribution(double lowerBound, double upperBound){
        s_Name = PD_UNIFORM;
        a= lowerBound;
        b = upperBound;
        h = 1.0/(b-a);
    }
    
    @Override
    public double probability(double dX) {
        if (( dX< a) || (dX > b))
                return 0.0;
        else
            return h;
    }

    public double getMin() {
        return a;
    }

    public double getMax() {
        return b;
    }
    @Override
    public double cumulative(double dX) {
        checkRange(dX);
        if (dX < a )
            return 0.0;
        else if (dX > b)
            return 1.0;
        else
            return (dX-a)/ (b-a);
    }

    @Override
    public double inverse(double probability) {
        checkRange(probability);
        if (probability == 0.0) {
            return 0.0;
        }
        if (probability == 1.0) {
            return 1.0;
        }
        return findRoot(probability, 0.5, a, b);
    }

    @Override
    public String getBufString() {
        return PD_UNIFORM + "," + a + "," + b ;
    }

    @Override
    public String toString(){
        return getName() + "(" + df.format(a) + ","+ df.format(b) + ")";
    }

}
