
package archeopterix.util.statistics.timeseries.ARIMA;


import java.io.Serializable;

// Referenced classes of package
//            ARAutoUnivariate, ARMA, ARMAMaxLikelihood, Summary

public class ARMAEstimateMissing
    implements Serializable
{
    private static final String NEWLINE = System.getProperty("line.separator");
    public static final int MEDIAN = 0;
    public static final int CUBIC_SPLINE = 1;
    public static final int AR_1 = 2;
    public static final int AR_P = 3;
    public static final int METHOD_OF_MOMENTS = 0;
    public static final int LEAST_SQUARES = 1;
    public static final int MAX_LIKELIHOOD = 2;
    private boolean init_mean;
    private int l_nobs;
    private int l_maxIteration;
    private int l_maxlag;
    private int l_method;
    private int ntimes;
    private int ner;
    private int init_conv_tol;
    private int l_ar_method;
    private int init_rel_error;
    private int init_max_iter;
    private int n_missing;
    private double constant;
    private double npar;
    private double z_mean;
    private double l_relative_error;
    private double l_convergence_tolerance;
    private int l_tpoints[];
    private int l_times[];
    private int miss_index[];
    private double l_z[];
    private double l_series[];
    private double resx[];
    private double l_ar[];
    private double l_ma[] = {
        0.0D
    };
    private double index[];
    private double p_x[];
    private double temp_ptr[];
	
    public ARMAEstimateMissing(int ai[], double ad[])
    {
        init_mean = false;
        l_nobs = 0;
        l_maxIteration = 200;
        l_maxlag = 10;
        l_method = 3;
        ntimes = 0;
        ner = 0;
        init_conv_tol = 0;
        l_ar_method = 1;
        init_rel_error = 0;
        init_max_iter = 0;
        n_missing = 0;
        constant = 0.0D;
        l_tpoints = null;
        l_times = null;
        miss_index = null;
        l_z = null;
        l_series = null;
        resx = null;
        l_ar = null;
        index = null;
        p_x = null;
        temp_ptr = null;
        int l = -1;
        int i1 = -1;
        boolean flag = false;
        if(ai == null)
        {
            Object aobj[] = {
                "Times", "null"
            };
            System.out.println("com.imsl.stat CannotBe"+ aobj);
        }
        if(ad == null)
        {
            Object aobj1[] = {
                "Time series", "null"
            };
            System.out.println("com.imsl.stat CannotBe"+ aobj1);
        }
        if(ad.length != ai.length)
        {
            Object aobj2[] = {
                "times.length", new Integer(ai.length), "z.length"
            };
            System.out.println("com.imsl.stat NotEqual"+ aobj2);
        }
        if(ad.length < 1)
        {
            Object aobj3[] = {
                "z.length", new Integer(ad.length), new Integer(1)
            };
            System.out.println("com.imsl.stat NotLargeEnough"+ aobj3);
        } else
        if(l_isanan(ad.length, ad, 1) != 0)
        {
            Object aobj4[] = {
                (new StringBuilder()).append("z[").append(l_isanan(ad.length, ad, 1) - 1).append("]").toString(), "NaN"
            };
            System.out.println("com.imsl.stat CannotBe"+ aobj4);
        }
        l = -1;
        i1 = -1;
        for(int i = 1; i < ai.length; i++)
        {
            if(ai[i - 1] >= ai[i])
                l = i - 1;
            int j1 = ai[i] - ai[i - 1] - 1;
            if(j1 > 3 && i1 < 0)
                i1 = i - 1;
        }

        if(l >= 0)
        {
            Object aobj5[] = {
                new Integer(l), new Integer(ai[l]), new Integer(l + 1), new Integer(ai[l + 1])
            };
            System.out.println("com.imsl.stat ARMAEstimateMissing.InvalidTimePoints"+ aobj5);
        }
        if(i1 >= 0)
        {
            int k1 = ai[i1 + 1] - ai[i1] - 1;
            Object aobj6[] = {
                new Integer(k1), new Integer(ai[i1])
            };
            System.out.println("com.imsl.stat ARMAEstimateMissing.LargeGap"+ aobj6);
        }
        l_nobs = ad.length;
        l_z = (double[])(double[])ad.clone();
        l_tpoints = (int[])(int[])ai.clone();
        l_convergence_tolerance = 1.0000000000000001E-009D;
        l_relative_error = 2.22045E-014D;
        l_maxIteration = 200;
        l_method = 3;
        l_ar_method = 1;
        ntimes = (ai[ad.length - 1] - ai[0]) + 1;
        l_times = new int[ntimes];
        resx = new double[ntimes];
        l_series = new double[ntimes];
        for(int j = 0; j < ntimes; j++)
        {
            l_times[j] = j + ai[0];
            resx[j] = (0.0D / 0.0D);
            l_series[j] = resx[j];
        }

        for(int k = 0; k < ad.length; k++)
            l_series[ai[k] - ai[0]] = ad[k];

        n_missing = ntimes - l_nobs;
        init_mean = false;
        index = new double[ntimes];
        resx = new double[ntimes];
        l_maxlag = 10;
        l_ar = new double[l_maxlag];
        miss_index = new int[n_missing];
    }

    private int l_isanan(int i, double ad[], int j)
    {
        int l = 0;
        int i1 = 1;
        int k = 1;
        do
        {
            if(i1 > i)
                break;
            if(Double.isNaN(ad[k - 1]))
            {
                l = i1;
                break;
            }
            k += j;
            i1++;
        } while(true);
        return l;
    }

    public int getMissingValueMethod()
    {
        return l_method;
    }

    public void setMissingValueMethod(int i)
    {
        if(i < 0 || i > 3)
        {
            Object aobj[] = {
                "method", new Integer(i), "0", "3"
            };
            System.out.println("com.imsl.stat OutOfRange"+ aobj);
        } else
        {
            l_method = i;
        }
    }

    public void setEstimationMethod(int i)
    {
        if(i < 0 || i > 2)
        {
            Object aobj[] = {
                "arEstimationMethod", new Integer(i), "0", "2"
            };
            System.out.println("com.imsl.stat OutOfRange"+ aobj);
        } else
        {
            l_ar_method = i;
        }
    }

    public int getEstimationMethod()
    {
        return l_ar_method;
    }

    public int getMaxIterations()
    {
        return l_maxIteration;
    }

    public double getConvergenceTolerance()
    {
        return l_convergence_tolerance;
    }

    public void setConvergenceTolerance(double d)
    {
        if(d <= 0.0D)
        {
            Object aobj[] = {
                "convergence_tolerance", new Double(d)
            };
            System.out.println("com.imsl.stat NotPositive"+ aobj);
        } else
        {
            l_convergence_tolerance = d;
        }
    }

    public double getRelativeError()
    {
        return l_relative_error;
    }

    public void setRelativeError(double d)
    {
        if(d <= 0.0D)
        {
            Object aobj[] = {
                "relative_error", new Double(d)
            };
            System.out.println("com.imsl.stat NotPositive"+ aobj);
        } else
        {
            l_relative_error = d;
        }
    }

    public void setMaxIterations(int i)
    {
        if(i <= 0)
        {
            Object aobj[] = {
                "maxIterations", new Integer(i)
            };
            System.out.println("com.imsl.stat NotPositive"+ aobj);
        } else
        {
            l_maxIteration = i;
        }
    }

    public int getMaxlag()
    {
        return l_maxlag;
    }

    public void setMaxlag(int i)
    {
        if(i < 0 || i > l_z.length)
        {
            Object aobj[] = {
                "maxlag", new Integer(i), "0", new Integer(l_z.length)
            };
            System.out.println("com.imsl.stat OutOfRange"+ aobj);
        } else
        {
            l_maxlag = i;
            l_ar = new double[i];
        }
    }

    public double getMean()
    {
        return z_mean;
    }

    public void setMean(double d)
    {
        z_mean = d;
        init_mean = true;
    }

    public int getNumberMissing()
    {
        return n_missing;
    }

    public int[] getMissingTimes()
    {
        return miss_index;
    }

    public int[] getCompleteTimes()
    {
        return l_times;
    }

    public double[] getCompleteTimeSeries()
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.InitialMAException
    {
        l_estimatemissingdriver(l_tpoints);
        return l_series;
    }

    private void l_estimatemissingdriver(int ai[])
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.InitialMAException
    {
        int ai1[] = null;
        int ai2[] = null;
        int i8 = 0;
        Object obj = null;
        Object obj1 = null;
        double ad4[] = null;
        int j7 = l_nobs;
        int k6 = j7;
        int l6 = j7;
        int i6 = l_maxlag;
        int j6 = l_method;
        index = new double[ntimes];
        ad4 = new double[l_z.length];
        for(int j = 0; j < l_z.length; j++)
            ad4[j] = l_z[j];

        for(int k = 0; k < ntimes; k++)
            resx[k] = 0.0D;

        index[0] = ai[0];
        resx[0] = ad4[0];
        int i = 1;
        for(int l = 1; l < ntimes; l++)
        {
            index[l] = index[l - 1] + 1.0D;
            if(index[l] == (double)ai[i])
            {
                resx[l] = ad4[i];
                i++;
            }
        }

        int l3 = 0;
        for(int i1 = 0; i1 < k6 - 1; i1++)
        {
            int k7 = ai[i1 + 1] - ai[i1];
            if(k7 > 1)
                l3++;
        }

        if(l3 > 0)
        {
            ai1 = new int[l3];
            ai2 = new int[l3];
            int i4 = 0;
            int i7 = 0;
            for(int j1 = 0; j1 < k6 - 1; j1++)
            {
                int l7 = ai[j1 + 1] - ai[j1];
                if(l7 > 1)
                {
                    ai1[i4] = i7;
                    ai2[i4] = ai[j1 + 1] - ai[j1] - 1;
                    i7 += ai2[i4] + 1;
                    i4++;
                } else
                {
                    i7++;
                }
            }

            i8 = ai1[0];
        }
label0:
        switch(j6)
        {
        default:
            break;

        case 0: // '\0'
        case 1: // '\001'
            for(int k1 = 0; k1 < l3; k1++)
            {
                int j8 = 0;
                if(j8 < ai1[k1] - 3)
                    j8 = ai1[k1] - 3;
                int i9;
                if(k1 == l3 - 1)
                    i9 = ntimes - 1;
                else
                    i9 = ai1[k1 + 1];
                if(i9 > ai1[k1] + ai2[k1] + 4)
                    i9 = ai1[k1] + ai2[k1] + 4;
                int l9 = (i9 - j8 - ai2[k1]) + 1;
                double ad[] = new double[l9];
                double ad3[] = new double[l9];
                int j4 = 0;
                for(int l2 = j8; l2 <= i9; l2++)
                    if(l2 <= ai1[k1] || l2 >= ai1[k1] + ai2[k1] + 1)
                    {
                        ad[j4] = resx[l2];
                        ad3[j4] = index[l2];
                        j4++;
                    }

                if(j6 == 0)
                {
                    l_median(ad, resx, ai2[k1], i8);
                    i8 += ai2[k1];
                }
                if(j6 == 1)
                {
                    l_cub_interpol(l9, ad3, ad, resx, index, i8, ai2[k1]);
                    i8 += ai2[k1];
                }
                if(k1 < l3 - 1)
                    i8 += ai1[k1 + 1] - ai1[k1] - ai2[k1];
            }

            break;

        case 2: // '\002'
            int l1 = 0;
            do
            {
                if(l1 >= l3)
                    break label0;
                if(ai1[l1] <= 1)
                {
                    int k8 = 0;
                    if(k8 < ai1[l1] - 3)
                        k8 = ai1[l1] - 3;
                    int j9;
                    if(l1 == l3 - 1)
                        j9 = ntimes - 1;
                    else
                        j9 = ai1[l1 + 1];
                    if(j9 > ai1[l1] + ai2[l1] + 4)
                        j9 = ai1[l1] + ai2[l1] + 4;
                    int i10 = (j9 - k8 - ai2[l1]) + 1;
                    double ad1[] = new double[i10];
                    int k4 = 0;
                    for(int i3 = k8; i3 <= j9; i3++)
                        if(i3 <= ai1[l1] || i3 >= ai1[l1] + ai2[l1] + 1)
                        {
                            ad1[k4] = resx[i3];
                            k4++;
                        }

                    l_median(ad1, resx, ai2[l1], i8);
                    i8 += ai2[l1];
                    if(l1 < l3 - 1)
                        i8 += ai1[l1 + 1] - ai1[l1] - ai2[l1];
                } else
                {
                    for(int l4 = 0; l4 < ai2[l1]; l4++)
                        l_ar_1(i8 + l4 + 1);

                    if(l1 < l3 - 1)
                        i8 += ai1[l1 + 1] - ai1[l1];
                }
                l1++;
            } while(true);

        case 3: // '\003'
            for(int i2 = 0; i2 < l3; i2++)
            {
                if(ai1[i2] + 1 >= 2 * i6)
                {
                    for(int i5 = 0; i5 < ai2[i2]; i5++)
                        l_auto_ar(i8 + i5 + 1, i6);

                    if(i2 < l3 - 1)
                        i8 += ai1[i2 + 1] - ai1[i2];
                    continue;
                }
                if(ai1[i2] == 0)
                {
                    int l8 = 0;
                    if(l8 < ai1[i2] - 3)
                        l8 = ai1[i2] - 3;
                    int k9;
                    if(i2 == l3 - 1)
                        k9 = ntimes - 1;
                    else
                        k9 = ai1[i2 + 1];
                    if(k9 > ai1[i2] + ai2[i2] + 4)
                        k9 = ai1[i2] + ai2[i2] + 4;
                    int j10 = (k9 - l8 - ai2[i2]) + 1;
                    double ad2[] = new double[j10];
                    int j5 = 0;
                    for(int j3 = l8; j3 <= k9; j3++)
                        if(j3 <= ai1[i2] || j3 >= ai1[i2] + ai2[i2] + 1)
                        {
                            ad2[j5] = resx[j3];
                            j5++;
                        }

                    l_median(ad2, resx, ai2[i2], i8);
                    i8 += ai2[i2];
                    if(i2 < l3 - 1)
                        i8 += ai1[i2 + 1] - ai1[i2] - ai2[i2];
                    continue;
                }
                for(int k5 = 0; k5 < ai2[i2]; k5++)
                    l_auto_ar(i8 + k5 + 1, (ai1[i2] + 1) / 2);

                if(i2 < l3 - 1)
                    i8 += ai1[i2 + 1] - ai1[i2];
            }

            break;
        }
        int l5 = 0;
        for(int j2 = 0; j2 < l3; j2++)
        {
            for(int k3 = 1; k3 <= ai2[j2]; k3++)
            {
                miss_index[l5] = ai1[j2] + k3;
                l5++;
            }

        }

        l_series[0] = resx[0];
        for(int k2 = 1; k2 < ntimes; k2++)
            l_series[k2] = resx[k2];

    }

    private void l_auto_ar(int i, int j)
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.InitialMAException
    {
        double ad[] = null;
        double ad1[] = null;
        double d1 = 0.0D;
        int k = 1;
        ad = new double[i];
        for(int l = 0; l < i; l++)
            ad[l] = resx[l];

        ARAutoUnivariate arautounivariate = new ARAutoUnivariate(j, ad);
        switch(l_ar_method)
        {
        case 0: // '\0'
            arautounivariate.setEstimationMethod(0);
            break;

        case 1: // '\001'
            arautounivariate.setEstimationMethod(1);
            arautounivariate.setConvergenceTolerance(l_convergence_tolerance);
            break;

        case 2: // '\002'
            arautounivariate.setEstimationMethod(2);
            arautounivariate.setConvergenceTolerance(l_convergence_tolerance);
            break;
        }
        if(init_mean)
            arautounivariate.setMean(z_mean);
        arautounivariate.setMaxIterations(l_maxIteration);
        arautounivariate.compute();
        ad1 = arautounivariate.getAR();
        d1 = arautounivariate.getConstant();
        k = ad1.length;
        if(k == 0)
        {
            l_ar = null;
            resx[i] = d1;
        } else
        {
            l_ar = new double[k];
            double d = 0.0D;
            for(int i1 = 1; i1 <= k; i1++)
            {
                d += ad1[i1 - 1] * resx[i - i1];
                l_ar[i1 - 1] = ad1[i1 - 1];
            }

            resx[i] = d1 + d;
        }
    }

    private void l_ar_1(int i)
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.InitialMAException
    {
        double ad[] = null;
        double ad1[] = {
            0.0D
        };
        double d = 0.0D;
        ad = new double[i];
        for(int j = 0; j < i; j++)
            ad[j] = resx[j];

        switch(l_ar_method)
        {
        default:
            break;

        case 0: // '\0'
            ARMA arma = new ARMA(1, 0, ad);
            arma.setMethod(0);
            if(init_mean)
                arma.setMean(z_mean);
            arma.setMaxIterations(l_maxIteration);
            arma.setRelativeError(l_relative_error);
            arma.compute();
            ad1 = arma.getAR();
            d = arma.getConstant();
            break;

        case 1: // '\001'
            ARMA arma1 = new ARMA(1, 0, ad);
            arma1.setMethod(1);
            arma1.setConvergenceTolerance(l_convergence_tolerance);
            if(init_mean)
                arma1.setMean(z_mean);
            arma1.setMaxIterations(l_maxIteration);
            arma1.setRelativeError(l_relative_error);
            arma1.compute();
            ad1 = arma1.getAR();
            d = arma1.getConstant();
            break;

        case 2: // '\002'
            ARMAMaxLikelihood armamaxlikelihood = new ARMAMaxLikelihood(1, 0, ad);
            armamaxlikelihood.setMaxIterations(l_maxIteration);
            armamaxlikelihood.setTolerance(l_convergence_tolerance);
            if(init_mean)
                armamaxlikelihood.setMean(z_mean);
            armamaxlikelihood.compute();
            ad1 = armamaxlikelihood.getAR();
            d = armamaxlikelihood.getConstant();
            break;
        }
        resx[i] = d + ad1[0] * resx[i - 1];
        l_ar[0] = ad1[0];
    }

    private void l_median(double ad[], double ad1[], int i, int j)
    {
        Summary summary = new Summary();
        double d = Summary.median(ad);
        for(int k = 0; k < i; k++)
        {
            j++;
            ad1[j] = d;
        }

    }

    private void l_cub_interpol(int i, double ad[], double ad1[], double ad2[], double ad3[], int j, int k)
    {
        CsInterpolate csinterpolate = new CsInterpolate(ad, ad1);
        for(int l = 0; l < k; l++)
        {
            j++;
            ad2[j] = csinterpolate.value(ad3[j]);
        }

    }



}