
package archeopterix.util.statistics.timeseries.ARIMA;
import java.io.Serializable;

//            Difference, Summary, ARAutoUnivariate, ARMA, 
//            ARMAMaxLikelihood

public class ARSeasonalFit
    implements Serializable
{

	    private static final long serialVersionUID = 0x521ba9728a01b0b0L;
    private double z[];
    private double aic;
    private double aicc;
    private double bic;
    private int l_infoCriterion;
    private double ar[];
    private int optD[];
    private int optS[];
    private double y[];
    private double ts[];
    private double par[];
    private int sInit[][];
    private int dInit[][];
    private int center;
    private int nDifferences;
    private int nLost;
    private int maxlag;
    private int arOrder;
    private boolean exclude;
    private boolean notComputed;
    public static final int NO_CENTER = 0;
    public static final int CENTER_MEAN = 1;
    public static final int CENTER_MEDIAN = 2;
    public static final int AIC = 0;
    public static final int AICC = 1;
    public static final int BIC = 2;
    public ARSeasonalFit(int i, int ai[][], double ad[])
    {
        l_infoCriterion = 0;
        ar = null;
        optD = null;
        optS = null;
        y = null;
        ts = null;
        par = null;
        sInit = (int[][])null;
        dInit = (int[][])null;
        center = 1;
        nDifferences = 0;
        nLost = 0;
        arOrder = 0;
        exclude = false;
        notComputed = true;
        z = new double[ad.length];
        sInit = new int[ai.length][ai[0].length];
        System.arraycopy(ad, 0, z, 0, ad.length);
        System.arraycopy(ai, 0, sInit, 0, ai.length);
        maxlag = i;
        if(i < 1 || i > ad.length / 2)
        {
            Object aobj[] = {
                "maxlag", new Integer(i), new Integer(0), new Integer(ad.length / 2)
            };
            System.out.println("GreaterLess"+ aobj);
        }
        for(int j = 0; j < ad.length; j++)
            if(Double.isNaN(ad[j]))
            {
                Object aobj1[] = {
                    (new StringBuilder()).append("z[").append(j).append("]").toString(), "Double.NaN"
                };
                System.out.println("CannotBe"+ aobj1);
            }

        for(int k = 0; k < ai.length; k++)
        {
            for(int j1 = 0; j1 < ai[0].length; j1++)
                if(ai[k][j1] < 1)
                {
                    Object aobj2[] = {
                        (new StringBuilder()).append("sInitial[").append(k).append("][").append(j1).append("]").toString(), new Integer(ai[k][j1]), new Integer(0)
                    };
                    System.out.println("NotLargeEnough"+ aobj2);
                }

        }

        dInit = new int[1][ai[0].length];
        for(int l = 0; l < ai[0].length; l++)
            dInit[0][l] = 1;

        int i1 = ai[0].length;
        optD = new int[i1];
        notComputed = true;
    }

    public void compute()
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.InitialMAException
    {
        boolean flag = false;
        boolean flag1 = false;
        boolean flag2 = true;
        boolean flag4 = false;
        boolean flag6 = false;
        double d7 = 0.0D;
        Object obj = null;
        double ad1[] = null;
        double ad2[] = new double[z.length];
        int l4 = z.length;
        int i5 = sInit[0].length;
        int j5 = sInit.length;
        int k5 = dInit.length;
        ad1 = new double[maxlag];
        int ai[] = new int[i5];
        optS = new int[i5];
        int ai1[] = new int[i5];
        optD = new int[i5];
        nLost = 0;
        boolean flag5 = true;
        int k4 = -1;
        int j4 = 0;
        boolean flag3 = false;
        double d4 = (1.0D / 0.0D);
        double d5 = (1.0D / 0.0D);
        double d6 = (1.0D / 0.0D);
        double d = 0.0D;
        double d1 = 0.0D;
        double d2 = 0.0D;
        BLAS.copy(l4, z, ad2);
        BLAS.set(i5, 0, ai, 0);
        BLAS.set(i5, 0, optS, 0);
        BLAS.set(i5, 0, ai1, 0);
        BLAS.set(i5, 0, optD, 0);
        for(int i = 0; i < k5; i++)
        {
            for(int i1 = 0; i1 < j5; i1++)
            {
                int l3 = l4;
                for(int j1 = 0; j1 < i5; j1++)
                {
                    ai[j1] = sInit[i1][j1];
                    ai1[j1] = dInit[i][j1];
                }

                Difference difference = new Difference();
                difference.setOrders(ai1);
                difference.excludeFirst(true);
                double ad[];
                try
                {
                    ad = difference.compute(z, ai);
                }
                catch(Exception exception)
                {
                    continue;
                }
                nLost = difference.getObservationsLost();
                l3 = l4 - nLost;
                if(maxlag > l3 / 2)
                {
                    Object aobj[] = {
                        new Integer(i1), new Integer(2 * maxlag)
                    };
                    System.out.println (this+"ARSeasonalFit.IgnoreSeason2"+ aobj);
                    continue;
                }
                double d3;
                if(center == 0)
                    d3 = 0.0D;
                else
                if(center == 1)
                    d3 = BLAS.sum(l3, ad, 0, 1) / (double)l3;
                else
                    try
                    {
                        Summary summary = new Summary();
                        summary.update(ad);
                        d3 = Summary.median(ad);
                    }
                    catch(Exception exception1)
                    {
						System.out.println(exception1.toString());
                        continue;
                    }

                ARAutoUnivariate arautounivariate = new ARAutoUnivariate(maxlag, ad);
                arautounivariate.setEstimationMethod(1);
                arautounivariate.setModelSelectionCriterion(l_infoCriterion);
                arautounivariate.setMean(d3);
                try
                {
                    arautounivariate.compute();
                }
                catch(Exception exception2)
                {
                    Object aobj1[] = {
                        new Integer(i1)
                    };
                    System.out.println (exception2.toString()+ "ARSeasonalFit.IgnoreSeason3"+ aobj1);
                    continue;
                }

                d3 = arautounivariate.getMean();
                double d8 = arautounivariate.getConstant();
                ar = arautounivariate.getAR();
                aic = arautounivariate.getAIC();
                aicc = arautounivariate.getAICC();
                bic = arautounivariate.getBIC();
                int i4 = ar.length;
                if(l_infoCriterion == 0)
                {
                    if(aic < d4)
                    {
                        d4 = aic;
                        d5 = aicc;
                        d6 = bic;
                        j4 = nLost;
                        k4 = i4;
                        for(int k1 = 0; k1 < i5; k1++)
                        {
                            optS[k1] = ai[k1];
                            optD[k1] = ai1[k1];
                        }

                        for(int l1 = j4; l1 < l4; l1++)
                        {
                            int i3 = l1 - j4;
                            ad2[l1] = ad[i3];
                        }

                    }
                } else
                if(l_infoCriterion == 1)
                {
                    if(aicc < d5)
                    {
                        d5 = aicc;
                        d4 = aic;
                        d6 = bic;
                        j4 = nLost;
                        k4 = i4;
                        for(int i2 = 0; i2 < i5; i2++)
                        {
                            optS[i2] = ai[i2];
                            optD[i2] = ai1[i2];
                        }

                        for(int j2 = j4; j2 < l4; j2++)
                        {
                            int j3 = j2 - j4;
                            ad2[j2] = ad[j3];
                        }

                    }
                } else
                if(bic < d6)
                {
                    d6 = bic;
                    d4 = aic;
                    d5 = aicc;
                    j4 = nLost;
                    k4 = i4;
                    for(int k2 = 0; k2 < i5; k2++)
                    {
                        optS[k2] = ai[k2];
                        optD[k2] = ai1[k2];
                    }

                    for(int l2 = j4; l2 < l4; l2++)
                    {
                        int k3 = l2 - j4;
                        ad2[l2] = ad[k3];
                    }

                }
                flag6 = true;
                if(i5 == 1 && ai1[0] == 0 && j5 > 1)
                    break;
            }

        }

        if(flag6)
        {
            arOrder = k4;
            nLost = j4;
            aic = d4;
            aicc = d5;
            bic = d6;
            if(exclude)
            {
                ts = new double[z.length - j4];
                if(j4 > 0)
                {
                    for(int j = 0; j < l4 - j4; j++)
                        ts[j] = ad2[j4 + j];

                }
            } else
            {
                ts = new double[z.length];
                for(int k = 0; k < j4; k++)
                    ts[k] = (0.0D / 0.0D);

                for(int l = j4; l < l4; l++)
                    ts[l] = ad2[l];

            }
        } else
        {
            System.out.println("Compute was not successful");
        }
        notComputed = false;
    }

    public double getAIC()
    {
        return aic;
    }

    public double getAICC()
    {
        return aicc;
    }

    public double getBIC()
    {
        return bic;
    }

    public void setModelSelectionCriterion(int i)
    {
        if(i < 0 || i > 2)
        {
            Object aobj[] = {
                "infoCriterion", new Integer(i), "0", "2"
            };
            System.out.println("GreaterEqual"+ aobj);
        }
        l_infoCriterion = i;
    }

    public int getAROrder()
    {
        return arOrder;
    }

    public double[] getAR()
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.InitialMAException
    {
        if(notComputed)
            compute();
        return ar;
    }

    public int getCenter()
    {
        return center;
    }

    public int[][] getSInitial()
    {
        return sInit;
    }

    public int[][] getDInitial()
    {
        return dInit;
    }

    public int getMaxlag()
    {
        return maxlag;
    }

    public int getNLost()
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.InitialMAException
    {
        if(notComputed)
            compute();
        return nLost;
    }

    public int[] getOptimumD()
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.InitialMAException
    {
        if(notComputed)
            compute();
        return optD;
    }

    public int[] getOptimumS()
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.InitialMAException
    {
        if(notComputed)
            compute();
        return optS;
    }

    public double[] getTimeSeries()
    {
        return z;
    }

    public double[] getTransformedTimeSeries()
        throws ARMA.MatrixSingularException, ARMA.TooManyCallsException, ARMA.IncreaseErrRelException, ARMA.NewInitialGuessException, ARMA.IllConditionedException, ARMA.TooManyITNException, ARMA.TooManyFcnEvalException, ARMA.TooManyJacobianEvalException, ARMA.NoProgressException, ARAutoUnivariate.TriangularMatrixSingularException, ARMAMaxLikelihood.NonInvertibleException, ARMAMaxLikelihood.NonStationaryException, ARMAMaxLikelihood.InitialMAException
    {
        if(notComputed)
            compute();
        return ts;
    }

    public void setCenter(int i)
    {
        if(i < 0 || i > 2)
        {
            Object aobj[] = {
                "center", new Integer(i), new Integer(0), new Integer(2)
            };
            System.out.println("GreaterEqual"+ aobj);
        } else
        {
            center = i;
        }
        notComputed = true;
    }

    public void setDInitial(int ai[][])
    {
        for(int i = 0; i < ai.length; i++)
        {
            for(int j = 0; j < ai[0].length; j++)
                if(ai[i][j] < 0)
                {
                    Object aobj1[] = {
                        (new StringBuilder()).append("dInitial[").append(i).append("][").append(j).append("]").toString(), new Integer(ai[i][j])
                    };
                    System.out.println("Negative"+ aobj1);
                }

        }

        if(sInit[0].length != ai[0].length)
        {
            Object aobj[] = {
                "dInitial[0].length", new Integer(ai[0].length), "sInitial[0].length", new Integer(sInit[0].length)
            };
            System.out.println("VariableInequality"+ aobj);
        }
        dInit = new int[ai.length][ai[0].length];
        System.arraycopy(ai, 0, dInit, 0, ai.length);
        notComputed = true;
    }

    public void setExclude(boolean flag)
    {
        exclude = flag;
        notComputed = true;
    }

    public boolean getExclude()
    {
        return exclude;
    }



}