

package archeopterix.util.statistics.timeseries.ARIMA;


// Referenced classes of package
//            Spline

public class CsInterpolate extends Spline
{

    private static final long serialVersionUID = 0x5a5692572cdd49a5L;
    public static final int NOT_A_KNOT = 0;
    public static final int FIRST_DERIVATIVE = 1;
    public static final int SECOND_DERIVATIVE = 2;

    public CsInterpolate(double ad[], double ad1[])
    {
        this(ad, ad1, 0, 0.0D, 0, 0.0D);
    }

    public CsInterpolate(double ad[], double ad1[], int i, double d, int j, double d1)
    {
        int l1 = ad1.length;
        double d5 = 0.0D;
        if(l1 < 2)
        {
            Object aobj[] = {
                "xData", new Integer(l1), new Integer(2)
            };
            System.out.println("TooFewPoints"+ aobj);
        }
        copyAndSortData(ad, ad1);
        int i1 = l1 - 1;
        for(int j1 = 1; j1 < l1; j1++)
        {
            super.coef[j1][2] = super.breakPoint[j1] - super.breakPoint[j1 - 1];
            super.coef[j1][3] = (super.coef[j1][0] - super.coef[j1 - 1][0]) / super.coef[j1][2];
        }

        switch(i)
        {
        case 0: // '\0'
            if(l1 == 2)
            {
                super.coef[0][3] = 1.0D;
                super.coef[0][2] = 1.0D;
                super.coef[0][1] = 2D * super.coef[1][3];
            } else
            {
                super.coef[0][3] = super.coef[2][2];
                super.coef[0][2] = super.coef[1][2] + super.coef[2][2];
                super.coef[0][1] = ((super.coef[1][2] + 2D * super.coef[0][2]) * super.coef[1][3] * super.coef[2][2] + Math.pow(super.coef[1][2], 2D) * super.coef[2][3]) / super.coef[0][2];
            }
            break;

        case 1: // '\001'
            super.coef[0][3] = 1.0D;
            super.coef[0][2] = 0.0D;
            super.coef[0][1] = d;
            break;

        case 2: // '\002'
            super.coef[0][3] = 2D;
            super.coef[0][2] = 1.0D;
            super.coef[0][1] = 3D * super.coef[1][3] - (super.coef[1][2] / 2D) * d;
            break;
        }
        if(l1 > 2)
        {
            for(int k1 = 1; k1 < i1; k1++)
            {
                d5 = -super.coef[k1 + 1][2] / super.coef[k1 - 1][3];
                super.coef[k1][1] = d5 * super.coef[k1 - 1][1] + 3D * (super.coef[k1][2] * super.coef[k1 + 1][3] + super.coef[k1 + 1][2] * super.coef[k1][3]);
                super.coef[k1][3] = d5 * super.coef[k1 - 1][2] + 2D * (super.coef[k1][2] + super.coef[k1 + 1][2]);
            }

            switch(j)
            {
            case 0: // '\0'
                if(l1 == 3 && i == 0)
                {
                    super.coef[l1 - 1][1] = 2D * super.coef[l1 - 1][3];
                    super.coef[l1 - 1][3] = 1.0D;
                    d5 = -1D / super.coef[l1 - 2][3];
                }
                break;

            case 1: // '\001'
                super.coef[l1 - 1][1] = d1;
                break;

            case 2: // '\002'
                super.coef[l1 - 1][1] = 3D * super.coef[l1 - 1][3] + (super.coef[l1 - 1][2] / 2D) * d1;
                super.coef[l1 - 1][3] = 2D;
                d5 = -1D / super.coef[l1 - 2][3];
                break;
            }
            if(j == 0 && (l1 != 3 || i != 0))
            {
                d5 = super.coef[l1 - 2][2] + super.coef[l1 - 1][2];
                super.coef[l1 - 1][1] = ((super.coef[l1 - 1][2] + 2D * d5) * super.coef[l1 - 1][3] * super.coef[l1 - 2][2] + (Math.pow(super.coef[l1 - 1][2], 2D) * (super.coef[l1 - 2][0] - super.coef[l1 - 3][0])) / super.coef[l1 - 2][2]) / d5;
                d5 = -d5 / super.coef[l1 - 2][3];
                super.coef[l1 - 1][3] = super.coef[l1 - 2][2];
            }
        } else
        {
            switch(j)
            {
            default:
                break;

            case 0: // '\0'
                if(i > 0)
                {
                    super.coef[l1 - 1][1] = 2D * super.coef[l1 - 1][3];
                    super.coef[l1 - 1][3] = 1.0D;
                } else
                {
                    super.coef[l1 - 1][1] = super.coef[l1 - 1][3];
                }
                break;

            case 1: // '\001'
                super.coef[l1 - 1][1] = d1;
                break;

            case 2: // '\002'
                super.coef[l1 - 1][1] = 3D * super.coef[l1 - 1][3] + (super.coef[l1 - 1][2] / 2D) * d1;
                super.coef[l1 - 1][3] = 2D;
                break;
            }
            d5 = -1D / super.coef[l1 - 2][3];
        }
        if(j != 1 && (l1 > 2 || j != 0 || i != 0))
        {
            super.coef[l1 - 1][3] += d5 * super.coef[l1 - 2][2];
            super.coef[l1 - 1][1] = (d5 * super.coef[l1 - 2][1] + super.coef[l1 - 1][1]) / super.coef[l1 - 1][3];
        }
        for(int l = i1 - 1; l >= 0; l--)
            super.coef[l][1] = (super.coef[l][1] - super.coef[l][2] * super.coef[l + 1][1]) / super.coef[l][3];

        for(int k = 1; k < l1; k++)
        {
            double ad2[] = super.coef[k];
            double ad3[] = super.coef[k - 1];
            double d4 = ad2[2];
            double d2 = (ad2[0] - ad3[0]) / d4;
            double d3 = (ad3[1] + ad2[1]) - 2D * d2;
            ad3[2] = (2D * (d2 - ad3[1] - d3)) / d4;
            ad3[3] = (d3 / d4) * (6D / d4);
        }

    }


}
