
package archeopterix.util.statistics.timeseries.ARIMA;


public class IEEE
{

    private static final double huge = 1.0000000000000001E+300D;
    private static final double tiny = 1E-300D;
    private static final double two54 = Double.longBitsToDouble(0x4350000000000000L);
    private static final double twom54 = Double.longBitsToDouble(0x3c90000000000000L);
    private static final double scale[];
    private IEEE()
    {
    }

    public static double copysign(double d, double d1)
    {
        long l = Double.doubleToLongBits(d);
        long l1 = Double.doubleToLongBits(d1);
        l = 0x7fffffffffffffffL & l | 0x8000000000000000L & l1;
        return Double.longBitsToDouble(l);
    }

    public static boolean finite(double d)
    {
        return !Double.isNaN(d) && !Double.isInfinite(d);
    }

    public static boolean isNaN(double d)
    {
        return Double.isNaN(d);
    }

    private static boolean isNaN(long l)
    {
        return (l & 0x7ff0000000000000L) == 0x7ff0000000000000L && (l & 0xfffffffffffffL) != 0L;
    }

    public static boolean unordered(double d, double d1)
    {
        return Double.isNaN(d) || Double.isNaN(d1);
    }

    public static double nextAfter(double d, double d1)
    {
        long l = Double.doubleToLongBits(d);
        long l1 = Double.doubleToLongBits(d1);
        if(isNaN(l) || isNaN(l1))
            return d + d1;
        if(d == d1)
            return d;
        if((l & 0x7fffffffffffffffL) == 0L)
        {
            d = Double.longBitsToDouble(l1 & 0x8000000000000000L | 1L);
            d1 = d * d;
            return d1 != d ? d : d1;
        }
        if(l >= 0L)
        {
            if(l > l1)
                l--;
            else
                l++;
        } else
        if(l1 >= 0L || l > l1)
            l--;
        else
            l++;
        l1 = l & 0x7ff0000000000000L;
        if(l1 >= 0x7ff0000000000000L)
            return d + d;
        else
            return Double.longBitsToDouble(l);
    }

    public static double scalbn(double d, int i)
    {
        if(Math.abs(i) < 100)
            return scale[100 + i] * d;
        long l = Double.doubleToLongBits(d);
        int j = (int)(l >> 32);
        int i1 = (int)l;
        int j1 = (j & 0x7ff00000) >> 20;
        if(j1 == 0)
        {
            if((l & 0x7fffffffffffffffL) == 0L)
                return d;
            d *= two54;
            l = Double.doubleToLongBits(d);
            int k = (int)(l >> 32);
            j1 = ((k & 0x7ff00000) >> 20) - 54;
            if(i < -50000)
                return 1E-300D * d;
        }
        if(j1 == 2047)
            return d + d;
        j1 += i;
        if(j1 > 2046)
            return 1.0000000000000001E+300D * copysign(1.0000000000000001E+300D, d);
        if(j1 > 0)
        {
            l &= 0x800fffffffffffffL;
            l |= (long)j1 << 52;
            return Double.longBitsToDouble(l);
        }
        if(j1 <= -54)
        {
            if(i > 50000)
                return 1.0000000000000001E+300D * copysign(1.0000000000000001E+300D, d);
            else
                return 1E-300D * copysign(1E-300D, d);
        } else
        {
            j1 += 54;
            l &= 0x800fffffffffffffL;
            l |= (long)j1 << 52;
            return twom54 * Double.longBitsToDouble(l);
        }
    }

    public static int ilogb(double d)
    {
        long l = Double.doubleToLongBits(d);
        int i = (int)(l >> 32) & 0x7fffffff;
        if(i < 0x100000)
        {
            int j = (int)l;
            if((long)(i | j) == 0L)
                return 0x80000001;
            int k;
            if(i == 0)
            {
                k = -1043;
                for(; j > 0; j <<= 1)
                    k--;

            } else
            {
                k = -1022;
                for(i <<= 11; i > 0; i <<= 1)
                    k--;

            }
            return k;
        }
        if(i < 0x7ff00000)
            return (i >> 20) - 1023;
        else
            return 0x7fffffff;
    }

    public static double hypot(double d, double d1)
    {
        long l = Double.doubleToLongBits(d);
        long l1 = Double.doubleToLongBits(d1);
        int j = 0x7fffffff & (int)(l >> 32);
        int k = 0x7fffffff & (int)(l1 >> 32);
        double d2;
        double d3;
        if(k > j)
        {
            d2 = d1;
            d3 = d;
            int i1 = j;
            j = k;
            k = i1;
        } else
        {
            d2 = d;
            d3 = d1;
        }
        d2 = d2 > 0.0D ? d2 : 0.0D - d2;
        d3 = d3 > 0.0D ? d3 : 0.0D - d3;
        if(j - k > 0x3c00000)
            return d2 + d3;
        int i = 0;
        if(j > 0x5f300000)
        {
            if(j >= 0x7ff00000)
            {
                double d11 = d2 + d3;
                if((j & 0xfffff | __LO(d2)) == 0)
                    d11 = d2;
                if((k ^ 0x7ff00000 | __LO(d3)) == 0)
                    d11 = d3;
                return d11;
            }
            j -= 0x25800000;
            k -= 0x25800000;
            i += 600;
            d2 = setHI(d2, j);
            d3 = setHI(d3, k);
        }
        if(k < 0x20b00000)
            if(k <= 0xfffff)
            {
                if((k | __LO(d3)) == 0)
                    return d2;
                double d4 = Double.longBitsToDouble(0x7fd0000000000000L);
                d3 *= d4;
                d2 *= d4;
                i -= 1022;
            } else
            {
                j += 0x25800000;
                k += 0x25800000;
                i -= 600;
                d2 = setHI(d2, j);
                d3 = setHI(d3, k);
            }
        double d12 = d2 - d3;
        if(d12 > d3)
        {
            double d5 = Double.longBitsToDouble((long)j << 32);
            double d7 = d2 - d5;
            d12 = Math.sqrt(d5 * d5 - (d3 * -d3 - d7 * (d2 + d5)));
        } else
        {
            d2 += d2;
            double d9 = Double.longBitsToDouble((long)k << 32);
            double d10 = d3 - d9;
            double d6 = Double.longBitsToDouble((long)(j + 0x100000) << 32);
            double d8 = d2 - d6;
            d12 = Math.sqrt(d6 * d9 - (d12 * -d12 - (d6 * d10 + d8 * d3)));
        }
        if(i != 0)
        {
            int j1 = 0x3ff00000 + (i << 20);
            return d12 * Double.longBitsToDouble((long)j1 << 32);
        } else
        {
            return d12;
        }
    }

    private static double setLO(double d, int i)
    {
        long l = Double.doubleToLongBits(d);
        l &= 0xffffffff00000000L;
        l |= i;
        return Double.longBitsToDouble(l);
    }

    private static double setHI(double d, int i)
    {
        long l = Double.doubleToLongBits(d);
        l &= 0xffffffffL;
        l |= (long)i << 32;
        return Double.longBitsToDouble(l);
    }

    private static int __HI(double d)
    {
        return (int)(-1L & Double.doubleToLongBits(d) >> 32);
    }

    private static int __LO(double d)
    {
        return (int)(-1L & Double.doubleToLongBits(d));
    }




    static 
    {
        scale = new double[200];
        scale[100] = 1.0D;
        for(int i = 1; i < 100; i++)
        {
            scale[100 + i] = 2D * scale[99 + i];
            scale[100 - i] = scale[101 - i] / 2D;
        }

    }
}
