
package archeopterix.util.statistics.timeseries.ARIMA;

import java.io.Serializable;

// Referenced classes of package
//            ANOVA, Girts, Cdf

public class LinearRegression
    implements Serializable, Cloneable
{
    public class CaseStatistics
    {

        private double[] solveForCase(double ad[], double d, double d1, int i)
        {
            int ai[] = new int[1];
            int ai1[] = new int[1];
            if(beta == null)
                getCoefficients();
            ncoef = beta.length;
            double ad1[] = new double[ncoef + 1];
            double ad2[] = new double[1];
            if(i == -1)
                i = 1;
            double d5 = 0.0D;
            double d6 = 0.0D;
            if(hasIntercept)
                setEffects(-ncoef + 1);
            else
                setEffects(-ncoef);
            if(!initialized)
            {
                initialized = true;
                intcep = 0;
                int k1 = ncoef;
                if(hasIntercept)
                    intcep = 1;
                rank = (double)getRank();
                if(anova == null)
                {
                    dfe = (double)nObservations - rank;
                    double d11 = 0.0D;
                    for(int l1 = 0; l1 < nVariables; l1++)
                        d11 += beta[l1] * rhs[l1];

                    sse = sst - d11;
                    sse = Math.max(0.0D, sse);
                } else
                {
                    dfe = anova.getArray()[1];
                    sse = anova.getArray()[4];
                }
                dfesv = dfe;
                pcmsv = CONPCM;
                pcpsv = CONPCP;
                if(dfe > 0.0D)
                {
                    tmsv = (100D + CONPCM * 100D) / 200D;
                    tmsv = Cdf.inverseStudentsT(tmsv, dfe);
                    tpsv = Cdf.inverseStudentsT((100D + CONPCP * 100D) / 200D, dfe);
                }
            }
            double d2 = (0.0D / 0.0D);
            int j = nVariables;
            double d3;
            if(dfe == 0.0D)
                d3 = d2;
            else
                d3 = sse / dfe;
            double d4;
            if(dfe + rank == 0.0D)
                d4 = 0.0D;
            else
                d4 = (2D * rank) / (dfe + rank);
            if(dfe > 0.0D)
            {
                if(dfe == dfesv && CONPCM == pcmsv)
                    d5 = tmsv;
                else
                    d5 = Cdf.inverseStudentsT((100D + CONPCM * 100D) / 200D, dfe);
                if(dfe == dfesv && CONPCP == pcpsv)
                    d6 = tpsv;
                else
                    d6 = Cdf.inverseStudentsT((100D + CONPCP * 100D) / 200D, dfe);
            }
            BLAS.set(12, d2, kase, 0);
            kase[0] = d;
            if(hasIntercept)
                ad1[0] = 1.0D;
            for(int k = 0; k < -IEF; k++)
                ad1[intcep + k] = ad[k];

            boolean flag1 = false;
            for(int l = 0; l < ncoef; l++)
                if(Double.isNaN(ad1[l]))
                    flag1 = true;

            double d7;
            if(!flag1)
                d7 = BLAS.dot(ncoef, beta, 0, ad1, 0);
            else
                d7 = d2;
            kase[1] = d7;
            if(Double.isNaN(d) || Double.isNaN(d7))
                ad2[0] = d2;
            else
                ad2[0] = d - d7;
            int i1 = ncoef - intcep;
            if(d1 > 0.0D)
            {
                ad1[ncoef] = d1;
                i1++;
            } else
            {
                d1 = 1.0D;
            }
            int j1 = -(ncoef - intcep);
            boolean flag = r2tin(1, i1, ad, 1, intcep, j1, ai, d1, matrixR, nVariables, dfe, sse, ad2, kase, 1, ai1, ad1);
            if(!Double.isNaN(d1) && d1 != 0.0D && !Double.isNaN(d7) && !Double.isNaN(d3))
            {
                double d8 = (d3 * kase[3]) / d1;
                double d9 = d5 * Math.sqrt(d8);
                kase[8] = d7 - d9;
                kase[9] = d7 + d9;
                if(Double.isNaN(i))
                    return kase;
                double d10 = d6 * Math.sqrt(d3 / (d1 * (double)i) + d8);
                kase[10] = d7 - d10;
                kase[11] = d7 + d10;
            }
            caseSolved = true;
            return kase;
        }

        /**
         * @deprecated Method getCaseStatistics is deprecated
         */

        public double[] getCaseStatistics()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            double ad[] = new double[kase.length];
            System.arraycopy(kase, 0, ad, 0, kase.length);
            return ad;
        }

        public double getObservedResponse()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[0];
        }

        public double getPredictedResponse()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[1];
        }

        public double getResidual()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[2];
        }

        public double getLeverage()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[3];
        }

        public double getStandardizedResidual()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[4];
        }

        public double getJackknifeResidual()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[5];
        }

        public double getCooksDistance()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[6];
        }

        public double getDFFITS()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            return kase[7];
        }

        public double[] getConfidenceInterval()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            confInt[0] = kase[8];
            confInt[1] = kase[9];
            return confInt;
        }

        public double[] getPredictionInterval()
        {
            if(!caseSolved)
                kase = solveForCase(x, y, conw, conpred);
            predInt[0] = kase[10];
            predInt[1] = kase[11];
            return predInt;
        }

        public void setConLevelPred(double d)
        {
            if(d < 0.0D || d > 1.0D)
            {
                Object aobj[] = {
                    "ConLevelPred", new Double(d), new Double(0.0D), new Double(1.0D)
                };
                System.out.println("GreaterEqual"+ aobj);
            } else
            {
                CONPCP = d;
            }
        }

        public void setConLevelMean(double d)
        {
            if(d < 0.0D || d > 1.0D)
            {
                Object aobj[] = {
                    "ConLevelMean", new Double(d), new Double(0.0D), new Double(1.0D)
                };
                System.out.println("GreaterEqual"+ aobj);
            } else
            {
                CONPCM = d;
            }
        }

        /**
         * @deprecated Method setEffects is deprecated
         */

        public void setEffects(int i)
        {
            if(i > 0)
            {
                Object aobj[] = {
                    new Integer(i)
                };
                System.out.println("LinearRegression.Effects"+ aobj);
            }
            if(beta == null)
                getCoefficients();
            ncoef = beta.length;
            if(hasIntercept && ncoef != 1 - i)
            {
                Object aobj1[] = {
                    new Integer(ncoef - 1), new Integer(ncoef), new Integer(-i), new Integer(ncoef - 1)
                };
                System.out.println("LinearRegression.Effects1"+ aobj1);
            } else
            if(!hasIntercept && ncoef != -i)
            {
                Object aobj2[] = {
                    new Integer(ncoef), new Integer(-i), new Integer(ncoef)
                };
                System.out.println("LinearRegression.Effects2"+ aobj2);
            }
            IEF = i;
        }

        private double kase[];
        private double confInt[];
        private double predInt[];
        private double x[];
        private double y;
        private boolean caseSolved;
        private double CONPCP;
        private double CONPCM;
        private double conw;
        private int conpred;
        private int IEF;
        public final LinearRegression this$0;

        /**
         * @deprecated Method CaseStatistics is deprecated
         */

        public CaseStatistics(double ad[], double d)
        {
			 super();
            this$0 = LinearRegression.this;
           
            kase = new double[12];
            confInt = new double[2];
            predInt = new double[2];
            int i = hasIntercept ? 1 : 0;
            if(ad.length != nVariables - i)
            {
                Object aobj[] = {
                    new Integer(0), new Integer(ad.length), new Integer(nVariables - i)
                };
                System.out.println("LinearRegression.updateXYrow"+ aobj);
            }
            caseSolved = false;
            x = new double[ad.length];
            System.arraycopy(ad, 0, x, 0, ad.length);
            y = d;
            conw = -1D;
            conpred = -1;
            CONPCP = 0.94999999999999996D;
            CONPCM = 0.94999999999999996D;
            IEF = ad.length;
        }

        /**
         * @deprecated Method CaseStatistics is deprecated
         */

        public CaseStatistics(double ad[], double d, double d1)
        {
			super();
            this$0 = LinearRegression.this;
            
            kase = new double[12];
            confInt = new double[2];
            predInt = new double[2];
            int i = hasIntercept ? 1 : 0;
            if(ad.length != nVariables - i)
            {
                Object aobj[] = {
                    new Integer(0), new Integer(ad.length), new Integer(nVariables - i)
                };
                System.out.println("LinearRegression.updateXYrow"+ aobj);
            }
            if(d1 < 0.0D)
            {
                Object aobj1[] = {
                    new Integer(0), new Double(d1)
                };
                System.out.println("NegativeWeight"+ aobj1);
            }
            caseSolved = false;
            x = new double[ad.length];
            System.arraycopy(ad, 0, x, 0, ad.length);
            y = d;
            conw = d1;
            conpred = -1;
            CONPCP = 0.94999999999999996D;
            CONPCM = 0.94999999999999996D;
            IEF = ad.length;
        }

        /**
         * @deprecated Method CaseStatistics is deprecated
         */

        public CaseStatistics(double ad[], double d, double d1, int i)
        {
			  super();
            this$0 = LinearRegression.this;
          
            kase = new double[12];
            confInt = new double[2];
            predInt = new double[2];
            int j = hasIntercept ? 1 : 0;
            if(ad.length != nVariables - j)
            {
                Object aobj[] = {
                    new Integer(0), new Integer(ad.length), new Integer(nVariables - j)
                };
                System.out.println("LinearRegression.updateXYrow"+ aobj);
            }
            if(d1 < 0.0D)
            {
                Object aobj1[] = {
                    new Integer(0), new Double(d1)
                };
                System.out.println("NegativeWeight"+ aobj1);
            }
            if((double)i < 0.0D)
            {
                Object aobj2[] = {
                    new Integer(0), new Double(i)
                };
                System.out.println("LinearRegression.FutureObservation"+ aobj2);
            }
            caseSolved = false;
            x = new double[ad.length];
            System.arraycopy(ad, 0, x, 0, ad.length);
            y = d;
            conw = d1;
            conpred = i;
            CONPCP = 0.94999999999999996D;
            CONPCM = 0.94999999999999996D;
            IEF = ad.length;
        }

        /**
         * @deprecated Method CaseStatistics is deprecated
         */

        public CaseStatistics(double ad[], double d, int i)
        {
			 super();
            this$0 = LinearRegression.this;
           
            kase = new double[12];
            confInt = new double[2];
            predInt = new double[2];
            int j = hasIntercept ? 1 : 0;
            if(ad.length != nVariables - j)
            {
                Object aobj[] = {
                    new Integer(0), new Integer(ad.length), new Integer(nVariables - j)
                };
                System.out.println("LinearRegression.updateXYrow"+ aobj);
            }
            if((double)i < 0.0D)
            {
                Object aobj1[] = {
                    new Integer(0), new Double(i)
                };
                System.out.println("LinearRegression.FutureObservation"+ aobj1);
            }
            caseSolved = false;
            x = new double[ad.length];
            System.arraycopy(ad, 0, x, 0, ad.length);
            y = d;
            conw = -1D;
            conpred = i;
            CONPCP = 0.94999999999999996D;
            CONPCM = 0.94999999999999996D;
            IEF = ad.length;
        }
    }

    public class CoefficientTTests
        implements Serializable
    {

        public double getCoefficient(int i)
        {
            return coef[i];
        }

        public double getStandardError(int i)
        {
            return stderr[i];
        }

        public double getTStatistic(int i)
        {
            return tstat[i];
        }

        public double getPValue(int i)
        {
            return pValue[i];
        }

        private double[][] inverse()
        {
            double ad[] = new double[nVariables];
            double ad1[][] = new double[nVariables][nVariables];
            for(int i = 0; i < nVariables; i++)
            {
                ad[i] = 1.0D;
                ad1[i] = solve(ad);
                ad[i] = 0.0D;
            }

            return ad1;
        }

        private double[] solve(double ad[])
        {
            double ad1[] = new double[ad.length];
            System.arraycopy(ad, 0, ad1, 0, ad.length);
            for(int i = 0; i < nVariables; i++)
            {
                double d = 0.0D;
                for(int k = 0; k < i; k++)
                    d += matrixR[k][i] * ad1[k];

                ad1[i] -= d;
                ad1[i] /= matrixR[i][i];
            }

            for(int j = nVariables - 1; j >= 0; j--)
            {
                double d1 = 0.0D;
                for(int l = j + 1; l < nVariables; l++)
                    d1 += matrixR[j][l] * ad1[l];

                ad1[j] -= d1;
                ad1[j] /= matrixR[j][j];
            }

            return ad1;
        }

        private static final long serialVersionUID = 0x844331e377a73b5dL;
        private double coef[];
        private double stderr[];
        private double tstat[];
        private double pValue[];
        public final LinearRegression this$0;

        private CoefficientTTests()
        {
			super();
            this$0 = LinearRegression.this;
            
            coef = getCoefficients();
            double ad[] = getANOVA().getArray();
            double d = ad[4];
            double d1 = ad[1];
            stderr = new double[nVariables];
            tstat = new double[nVariables];
            pValue = new double[nVariables];
            double ad1[][] = inverse();
            for(int i = 0; i < nVariables; i++)
            {
                stderr[i] = Math.sqrt((ad1[i][i] * d) / d1);
                tstat[i] = coef[i] / stderr[i];
                pValue[i] = 2D * Cdf.complementaryStudentsT(Math.abs(tstat[i]), d1);
            }

        }

    }


    public LinearRegression(int i, boolean flag)
    {
        if(i < 1)
        {
            Object aobj[] = {
                "nVariables", new Integer(i)
            };
            System.out.println("NotStrictlyPositive"+ aobj);
        }
        hasIntercept = flag;
        if(flag)
            i++;
        nVariables = i;
        rhs = new double[i];
        sumY = 0.0D;
        sumW = 0.0D;
        sst = 0.0D;
        beta = null;
        anova = null;
        matrixR = new double[i + 1][i + 1];
        initialized = false;
        dfesv = 0.0D;
        pcmsv = 0.0D;
        pcpsv = 0.0D;
        tmsv = 0.0D;
        tpsv = 0.0D;
    }

    public void update(double ad[], double d)
    {
        update(ad, d, 1.0D);
    }

    public synchronized void update(double ad[], double d, double d1)
    {
        int i = hasIntercept ? 1 : 0;
        if(ad.length != nVariables - i)
        {
            Object aobj[] = {
                new Integer(ad.length), new Integer(nVariables)
            };
            System.out.println("LinearRegression.updateX"+ aobj);
        }
        beta = null;
        anova = null;
        if(hasIntercept)
            rhs[0] += d1 * d;
        for(int j = 0; j < ad.length; j++)
            rhs[j + i] += d1 * ad[j] * d;

        updateMatrix(ad, d, d1);
        sumY += d1 * d;
        sumW += d1;
        sst += d1 * d * d;
        nObservations++;
    }

    public void update(double ad[][], double ad1[])
    {
        int i = hasIntercept ? 1 : 0;
        if(ad.length != ad1.length)
        {
            Object aobj[] = {
                new Integer(ad.length), new Integer(ad1.length)
            };
            System.out.println("LinearRegression.updateXY"+ aobj);
        }
        for(int j = 0; j < ad1.length; j++)
            if(ad[j].length != nVariables - i)
            {
                Object aobj1[] = {
                    new Integer(j), new Integer(ad[j].length), new Integer(nVariables - i)
                };
                System.out.println("LinearRegression.updateXYrow"+ aobj1);
            }

        for(int k = 0; k < ad1.length; k++)
            update(ad[k], ad1[k], 1.0D);

    }

    public void update(double ad[][], double ad1[], double ad2[])
    {
        int i = hasIntercept ? 1 : 0;
        if(ad.length != ad1.length)
        {
            Object aobj[] = {
                new Integer(ad.length), new Integer(ad1.length)
            };
            System.out.println("LinearRegression.updateXY"+ aobj);
        }
        for(int j = 0; j < ad1.length; j++)
            if(ad[j].length != nVariables - i)
            {
                Object aobj2[] = {
                    new Integer(j), new Integer(ad[j].length), new Integer(nVariables - i)
                };
                System.out.println("LinearRegression.updateXYrow"+ aobj2);
            }

        if(ad1.length != ad2.length)
        {
            Object aobj1[] = {
                new Integer(ad2.length), new Integer(ad1.length)
            };
            System.out.println("LinearRegression.updateWY"+ aobj1);
        }
        for(int k = 0; k < ad1.length; k++)
            update(ad[k], ad1[k], ad2[k]);

    }

    public synchronized double[] getCoefficients()
    {
        if(beta == null)
            beta = solve();
        return beta;
    }

    public synchronized double[][] getR()
    {
        double ad[][] = new double[nVariables][nVariables];
        for(int i = 0; i < nVariables; i++)
            System.arraycopy(matrixR[i], 0, ad[i], 0, nVariables);

        return ad;
    }

    public synchronized ANOVA getANOVA()
    {
        if(anova == null)
        {
            double d = hasIntercept ? nVariables - 1 : nVariables;
            double d1 = nObservations - getRank();
            double d2 = sumY / sumW;
            if(beta == null)
                getCoefficients();
            double d3 = 0.0D;
            for(int i = 0; i < nVariables; i++)
                d3 += beta[i] * rhs[i];

            double d4 = sst - d3;
            if(hasIntercept)
                d3 -= (sumY * sumY) / sumW;
            d3 = Math.max(0.0D, d3);
            d4 = Math.max(0.0D, d4);
            anova = new ANOVA(d, d3, d1, d4, d2);
        }
        return anova;
    }

    private synchronized void updateMatrix(double ad[], double d, double d1)
    {
        if(d1 == 1.0D)
        {
            if(hasIntercept)
            {
                matrixR[nVariables][0] = 1.0D;
                for(int i = 1; i < nVariables; i++)
                    matrixR[nVariables][i] = ad[i - 1];

                matrixR[nVariables][nVariables] = d;
            } else
            {
                for(int j = 0; j < nVariables; j++)
                    matrixR[nVariables][j] = ad[j];

                matrixR[nVariables][nVariables] = d;
            }
        } else
        {
            d1 = Math.sqrt(d1);
            if(hasIntercept)
            {
                matrixR[nVariables][0] = d1;
                for(int k = 1; k < nVariables; k++)
                    matrixR[nVariables][k] = d1 * ad[k - 1];

                matrixR[nVariables][nVariables] = d1 * d;
            } else
            {
                for(int l = 0; l < nVariables; l++)
                    matrixR[nVariables][l] = d1 * ad[l];

                matrixR[nVariables][nVariables] = d1 * d;
            }
        }
        for(int i1 = 0; i1 < nVariables + 1; i1++)
        {
            drotg(matrixR[i1][i1], matrixR[nVariables][i1]);
            double ad1[] = matrixR[i1];
            double ad2[] = matrixR[nVariables];
            for(int j1 = 0; j1 < nVariables + 1; j1++)
            {
                double d2 = rotC * ad1[j1] + rotS * ad2[j1];
                ad2[j1] = -rotS * ad1[j1] + rotC * ad2[j1];
                ad1[j1] = d2;
            }

            if(matrixR[i1][i1] >= 0.0D)
                continue;
            for(int k1 = i1; k1 < nVariables + 1; k1++)
                matrixR[i1][k1] = -matrixR[i1][k1];

        }

    }

    private synchronized double[] solve()
    {
        double ad[] = new double[nVariables];
        for(int i = 0; i < nVariables; i++)
            ad[i] = matrixR[i][nVariables];

        int j = getRank();
        if(j < nVariables)
        {
            Object aobj[] = {
                new Integer(j)
            };
            System.out.println(this+ "LinearRegression.NotFullRank"+ aobj);
        }
        for(int k = nVariables - 1; k >= 0; k--)
        {
            if(k >= j)
            {
                ad[k] = 0.0D;
                continue;
            }
            double d = 0.0D;
            for(int l = k + 1; l < nVariables; l++)
                d += matrixR[k][l] * ad[l];

            ad[k] = (ad[k] - d) / matrixR[k][k];
        }

        return ad;
    }

    public int getRank()
    {
        int i = matrixR.length - 1;
        int j = 0;
        double d = matrixR[0][0];
        for(int k = 1; k < i; k++)
            d = Math.max(d, Math.abs(matrixR[k][k]));

        double d1 = 1E-013D * d;
        for(int l = 0; l < i; l++)
            if(Math.abs(matrixR[l][l]) > d1)
                j++;

        return j;
    }

    private synchronized void drotg(double d, double d1)
    {
        if(Math.abs(d) > Math.abs(d1))
        {
            double d2 = d + d;
            double d4 = d1 / d2;
            double d6 = Math.sqrt(0.25D + d4 * d4) * d2;
            rotC = d / d6;
            rotS = d4 * (rotC + rotC);
        } else
        if(d1 == 0.0D)
        {
            rotC = 1.0D;
            rotS = 0.0D;
        } else
        {
            double d3 = d1 + d1;
            double d5 = d / d3;
            d = Math.sqrt(0.25D + d5 * d5) * d3;
            rotS = d1 / d;
            rotC = d5 * (rotS + rotS);
        }
    }

    public CoefficientTTests getCoefficientTTests()
    {
        return new CoefficientTTests();
    }

    public CaseStatistics getCaseStatistics(double ad[], double d)
    {
        return new CaseStatistics(ad, d);
    }

    public CaseStatistics getCaseStatistics(double ad[], double d, double d1)
    {
        return new CaseStatistics(ad, d, d1);
    }

    public CaseStatistics getCaseStatistics(double ad[], double d, int i)
    {
        return new CaseStatistics(ad, d, i);
    }

    public CaseStatistics getCaseStatistics(double ad[], double d, double d1, int i)
    {
        return new CaseStatistics(ad, d, d1, i);
    }

    private final boolean r2tin(int i, int j, double ad[], int k, int l, int i1, int ai[], 
            double d, double ad1[][], int j1, double d1, double d2, double ad2[], double ad3[], int k1, int ai1[], double ad4[])
    {
        int ai2[] = new int[1];
        double ad5[][] = new double[1][1];
        boolean flag = false;
        int i3 = Math.abs(i1);
        int l2 = l + i3;
        int j2 = l + 1;
        ai1[0] = 0;
        int k2 = 0;
        double d5 = ad2[k2];
        ad3[2] = d5;
        if(Double.isNaN(d))
        {
            ai1[0] = ai1[0] + 1;
        } else
        {
            if(l == 1)
                ad4[0] = 1.0D;
            boolean flag1 = false;
            for(int l1 = 0; l1 < -i1; l1++)
            {
                ad4[l + l1] = ad[l1];
                if(Double.isNaN(ad[l1]))
                    flag1 = true;
            }

            if(flag1)
            {
                ai1[0] = ai1[0] + 1;
            } else
            {
                flag = Girts.girts(l2, ad1, j1, 1, ad4, l2, 2, ai2, ad4, 0, 1, ad5, 1);
                if(flag)
                {
                    System.out.println(this+ "LinearRegression.CoefficientsNonestimable");
                    flag = false;
                }
                ai2[0] = 0;
                for(int i2 = 0; i2 < l2; i2++)
                    if(ad1[i2][i2] <= 0.0D)
                        ad4[i2] = 0.0D;
                    else
                        ai2[0] = ai2[0] + 1;

                double d6 = d * BLAS.dot(l2, ad4, 0, ad4, 0);
                if(!Double.isNaN(d5) && d6 > 0.99999999999999778D)
                {
                    if(d6 > 1.000000000000222D)
                    {
                        Object aobj[] = {
                            new Double(d6)
                        };
                        System.out.println(this+ "LinearRegression.LeverageTooHigh"+ aobj);
                    }
                    d6 = 1.0D;
                }
                ad3[3] = d6;
                if(Double.isNaN(d5) || d1 == 0.0D || d == 0.0D || d6 == 1.0D)
                {
                    ai1[0] = ai1[0] + 1;
                } else
                {
                    double d7 = 1.0D - d6;
                    double d13 = d7 / d;
                    double d9 = d2 / d1;
                    if(d9 != 0.0D && d13 != 0.0D)
                    {
                        double d8 = c1div(d5, Math.sqrt(d9 * d13));
                        ad3[4] = d8;
                        if(ai2[0] == 0)
                        {
                            ad3[6] = (0.0D / 0.0D);
                        } else
                        {
                            double d3 = c1div((d5 * d5 * d * d6) / (double)ai2[0], d9 * d7 * d7);
                            ad3[6] = d3;
                        }
                        if(d1 == 1.0D)
                        {
                            ai1[0] = ai1[0] + 1;
                        } else
                        {
                            double d10 = (d2 - (d5 * d5) / d13) / (d1 - 1.0D);
                            double d11 = (d2 + (d5 * d5) / d13) / (d1 - 1.0D);
                            if(d10 < 2.2204460492503131E-015D * d11)
                            {
                                if(d10 < -2.2204460492503131E-013D * d11)
                                {
                                    Object aobj1[] = {
                                        new Double(d10)
                                    };
                                   System.out.println(this+ "LinearRegression.DeletedResidualMean"+ aobj1);
                                }
                                d10 = 0.0D;
                            }
                            double d12 = c1div(d5, Math.sqrt(d10 * d13));
                            ad3[5] = d12;
                            double d4 = c1div(d5 * Math.sqrt(d * d6), Math.sqrt(d10) * d7);
                            ad3[7] = d4;
                        }
                    }
                }
            }
        }
        return flag;
    }

    private double c1div(double d, double d1)
    {
        double d3 = (0.0D / 0.0D);
        double d5;
        if(Double.isNaN(d) || Double.isNaN(d1))
        {
            d5 = d3;
        } else
        {
            double d2 = Math.abs(d1);
            if(d2 <= 1.0D)
            {
                double d4 = 1.7976931348623157E+308D;
                if(Math.abs(d) >= d4 * d2)
                {
                    if(d == 0.0D)
                        d5 = d3;
                    else
                    if(d1 >= 0.0D)
                    {
                        if(d >= 0.0D)
                            d5 = (1.0D / 0.0D);
                        else
                            d5 = (-1.0D / 0.0D);
                    } else
                    if(d >= 0.0D)
                        d5 = (-1.0D / 0.0D);
                    else
                        d5 = (1.0D / 0.0D);
                    return d5;
                }
            } else
            {
                double d6 = 2.2250738585072014E-308D;
                if(Math.abs(d) < d6 * d2)
                {
                    d5 = 0.0D;
                    return d5;
                }
            }
            d5 = d / d1;
        }
        return d5;
    }

    private static final long serialVersionUID = 0x82204381338326c3L;

    private int nVariables;
    private int nObservations;
    private int intcep;
    private int ncoef;
    private boolean hasIntercept;
    private double matrixR[][];
    private double rhs[];
    private double sumY;
    private double sumW;
    private double sst;
    private double dfe;
    private double sse;
    private double dfesv;
    private double pcmsv;
    private double pcpsv;
    private double tmsv;
    private double tpsv;
    private double rank;
    private boolean initialized;
    private transient ANOVA anova;
    private transient double beta[];
    private transient double rotC;
    private transient double rotS;
































}
