
package archeopterix.util.statistics.timeseries.ARIMA;

public class Matrix
{

    private Matrix()
    {
    }

    public static void checkMatrix(double ad[][])
    {
        for(int i = 1; i < ad.length; i++)
            if(ad[i].length != ad[0].length)
               System.out.println("Matrix.Rows");

    }

    private static void checkMatrix(int ai[][])
    {
        for(int i = 1; i < ai.length; i++)
            if(ai[i].length != ai[0].length)
                System.out.println("Matrix.Rows");

    }

    /**
     * @deprecated Method CheckMatrix is deprecated
     */

    public static void CheckMatrix(double ad[][])
    {
        for(int i = 1; i < ad.length; i++)
            if(ad[i].length != ad[0].length)
                System.out.println("Matrix.Rows");

    }

    public static void checkSquareMatrix(double ad[][])
    {
        if(ad.length != ad[0].length)
            System.out.println("Matrix.NotSquare");
        for(int i = 1; i < ad.length; i++)
            if(ad[i].length != ad[0].length)
                System.out.println("Matrix.NotSquare");

    }

    /**
     * @deprecated Method CheckSquareMatrix is deprecated
     */

    public static void CheckSquareMatrix(double ad[][])
    {
        if(ad.length != ad[0].length)
            System.out.println("Matrix.NotSquare");
        for(int i = 1; i < ad.length; i++)
            if(ad[i].length != ad[0].length)
                System.out.println("Matrix.NotSquare");

    }

    public static double[][] transpose(double ad[][])
    {
        checkMatrix(ad);
        int i = ad.length;
        int j = ad[0].length;
        double ad1[][] = new double[j][i];
        for(int k = 0; k < j; k++)
        {
            for(int l = 0; l < i; l++)
                ad1[k][l] = ad[l][k];

        }

        return ad1;
    }

    private static int[][] transpose(int ai[][])
    {
        checkMatrix(ai);
        int i = ai.length;
        int j = ai[0].length;
        int ai1[][] = new int[j][i];
        for(int k = 0; k < j; k++)
        {
            for(int l = 0; l < i; l++)
                ai1[k][l] = ai[l][k];

        }

        return ai1;
    }

    public static double[] multiply(double ad[], double ad1[][])
    {
        checkMatrix(ad1);
        int i = ad1.length;
        int j = ad1[0].length;
        if(ad.length != i)
            System.out.println("Matrix.InconsistentVM");
        double ad2[] = new double[j];
        for(int k = 0; k < j; k++)
        {
            for(int l = 0; l < i; l++)
                ad2[k] += ad[l] * ad1[l][k];

        }

        return ad2;
    }

    public static double[] multiply(double ad[][], double ad1[])
    {
        checkMatrix(ad);
        int i = ad.length;
        int j = ad[0].length;
        if(ad1.length != j)
            System.out.println("Matrix.InconsistentMV");
        double ad2[] = new double[i];
        for(int k = 0; k < i; k++)
        {
            for(int l = 0; l < j; l++)
                ad2[k] += ad[k][l] * ad1[l];

        }

        return ad2;
    }

    public static double[][] multiply(double ad[][], double ad1[][])
    {
        byte byte0 = 32;
        byte byte1 = byte0;
        byte byte2 = 32;
        double ad2[][] = new double[byte2][byte0];
        checkMatrix(ad);
        checkMatrix(ad1);
        if(ad[0].length != ad1.length)
            System.out.println("Matrix.InconsistentMM");
        int i2 = ad.length;
        int j2 = ad1[0].length;
        int k2 = ad1.length;
        int k1 = i2;
        int j1 = k2;
        int l1 = k2;
        int l2 = i2;
        int i3 = k2;
        int j3 = i2;
        double ad3[][] = new double[i2][j2];
        for(int k3 = 1; k3 <= k2; k3 += byte2)
        {
            int i1 = byte2 <= (k2 - k3) + 1 ? ((int) (byte2)) : (k2 - k3) + 1;
            for(int l3 = 1; l3 <= i2; l3 += byte0)
            {
                byte byte3 = 2;
                int k = byte0 <= (i2 - l3) + 1 ? ((int) (byte0)) : (i2 - l3) + 1;
                int i = byte3 * (k / byte3);
                for(int i4 = k3; i4 <= (k3 + i1) - 1; i4++)
                {
                    for(int k4 = l3; k4 <= (l3 + k) - 1; k4++)
                        ad2[i4 - k3][k4 - l3] = ad[k4 - 1][i4 - 1];

                }

                for(int j4 = 1; j4 <= j2; j4 += byte1)
                {
                    byte byte4 = 2;
                    int l = byte1 <= (j2 - j4) + 1 ? ((int) (byte1)) : (j2 - j4) + 1;
                    int j = byte4 * (l / byte4);
label0:
                    for(int l4 = j4; l4 <= (j4 + j) - 1; l4 += byte4)
                    {
                        for(int j5 = l3; j5 <= (l3 + i) - 1; j5 += byte3)
                        {
                            double d = 0.0D;
                            double d6 = 0.0D;
                            double d4 = 0.0D;
                            double d8 = 0.0D;
                            for(int j6 = k3; j6 <= (k3 + i1) - 1; j6++)
                            {
                                d += ad2[j6 - k3][j5 - l3] * ad1[j6 - 1][l4 - 1];
                                d6 += ad2[j6 - k3][(j5 - l3) + 1] * ad1[j6 - 1][l4 - 1];
                                d4 += ad2[j6 - k3][j5 - l3] * ad1[j6 - 1][l4];
                                d8 += ad2[j6 - k3][(j5 - l3) + 1] * ad1[j6 - 1][l4];
                            }

                            ad3[j5 - 1][l4 - 1] += d;
                            ad3[j5][l4 - 1] += d6;
                            ad3[j5 - 1][l4] += d4;
                            ad3[j5][l4] += d8;
                        }

                        if(i >= k)
                            continue;
                        int k5 = l3 + i;
                        do
                        {
                            if(k5 > (l3 + k) - 1)
                                continue label0;
                            double d1 = 0.0D;
                            double d5 = 0.0D;
                            for(int k6 = k3; k6 <= (k3 + i1) - 1; k6++)
                            {
                                d1 += ad2[k6 - k3][k5 - l3] * ad1[k6 - 1][l4 - 1];
                                d5 += ad2[k6 - k3][k5 - l3] * ad1[k6 - 1][l4];
                            }

                            ad3[k5 - 1][l4 - 1] += d1;
                            ad3[k5 - 1][l4] += d5;
                            k5++;
                        } while(true);
                    }

                    if(j >= l)
                        continue;
label1:
                    for(int i5 = j4 + j; i5 <= (j4 + l) - 1; i5++)
                    {
                        for(int l5 = l3; l5 <= (l3 + i) - 1; l5 += byte3)
                        {
                            double d2 = 0.0D;
                            double d7 = 0.0D;
                            for(int l6 = k3; l6 <= (k3 + i1) - 1; l6++)
                            {
                                d2 += ad2[l6 - k3][l5 - l3] * ad1[l6 - 1][i5 - 1];
                                d7 += ad2[l6 - k3][(l5 - l3) + 1] * ad1[l6 - 1][i5 - 1];
                            }

                            ad3[l5 - 1][i5 - 1] += d2;
                            ad3[l5][i5 - 1] += d7;
                        }

                        if(i >= k)
                            continue;
                        int i6 = l3 + i;
                        do
                        {
                            if(i6 > (l3 + k) - 1)
                                continue label1;
                            double d3 = 0.0D;
                            for(int i7 = k3; i7 <= (k3 + i1) - 1; i7++)
                                d3 += ad2[i7 - k3][i6 - l3] * ad1[i7 - 1][i5 - 1];

                            ad3[i6 - 1][i5 - 1] += d3;
                            i6++;
                        } while(true);
                    }

                }

            }

        }

        return ad3;
    }

    public static double[][] multiply(double ad[][], double ad1[][], int i)
    {
        checkMatrix(ad);
        checkMatrix(ad1);
        if(ad[0].length != ad1.length)
            System.out.println("Matrix.InconsistentMM");
        if(i < 1)
            i = 1;
        double ad2[][] = new double[ad.length][ad1[0].length];
        double ad3[][] = transpose(ad1);
        class _cls1MultiplyThread
            implements Runnable
        {

            public void run()
            {
                int l = a.length;
                int i1 = c[0].length;
                int j1 = a[0].length;
                double d = (double)(l * i1) / (double)threads;
                int l1;
                int k1 = l1 = 0;
                int i2 = 0;
                do
                {
                    if(i2 >= threads)
                        break;
                    int j2 = (int)(d * (double)(i2 + 1) + 0.5D);
                    if(i2 == id)
                    {
                        l1 = j2;
                        break;
                    }
                    k1 = j2;
                    i2++;
                } while(true);
                i2 = l1 - k1;
                if(k1 == l1)
                    return;
                l1--;
                int k2 = k1 / i1;
                int l2 = k1 - k2 * i1;
                int i3 = l1 / i1;
                int j3 = l1 - i3 * i1;
                byte byte0 = 32;
                for(int k3 = k2; k3 <= i3; k3 += byte0)
                {
                    int l3 = Math.min(k3 + byte0, i3 + 1);
                    for(int i4 = 0; i4 < i1; i4 += byte0)
                    {
                        int j4 = Math.min(i4 + byte0, i1);
                        for(int k4 = k3; k4 < l3; k4++)
                        {
                            for(int l4 = i4; l4 < j4; l4++)
                            {
                                if(k4 == k2 && l4 < l2)
                                    continue;
                                if(k4 == i3 && l4 > j3)
                                    break;
                                double ad4[] = a[k4];
                                double ad5[] = transB[l4];
                                double d1 = 0.0D;
                                for(int i5 = 0; i5 < j1; i5++)
                                    d1 += ad4[i5] * ad5[i5];

                                c[k4][l4] = d1;
                            }

                        }

                    }

                }

            }

            private int id;
            private int threads;
            private double a[][];
            private double transB[][];
            private double c[][];

            public _cls1MultiplyThread(double ad[][], double ad1[][], double ad2[][], int i, int j)
            {
                a = ad;
                transB = ad1;
                c = ad2;
                id = i;
                threads = j;
            }
        }

        _cls1MultiplyThread a_lcls1multiplythread[] = new _cls1MultiplyThread[i];
        Thread athread[] = new Thread[i];
        for(int j = 0; j < i; j++)
        {
            a_lcls1multiplythread[j] = new _cls1MultiplyThread(ad, ad3, ad2, j, i);
            athread[j] = new Thread(a_lcls1multiplythread[j]);
            athread[j].start();
        }

        for(int k = 0; k < i; k++)
            try
            {
                athread[k].join();
            }
            catch(Exception exception) { }

        return ad2;
    }

    public static double[][] add(double ad[][], double ad1[][])
    {
        checkMatrix(ad);
        int i = ad.length;
        int j = ad[0].length;
        checkMatrix(ad1);
        int k = ad1.length;
        int l = ad1[0].length;
        if(i != k || j != l)
            System.out.println("Matrix.Size");
        double ad2[][] = new double[i][j];
        for(int i1 = 0; i1 < i; i1++)
        {
            for(int j1 = 0; j1 < j; j1++)
                ad2[i1][j1] = ad[i1][j1] + ad1[i1][j1];

        }

        return ad2;
    }

    public static double[][] subtract(double ad[][], double ad1[][])
    {
        checkMatrix(ad);
        int i = ad.length;
        int j = ad[0].length;
        checkMatrix(ad1);
        int k = ad1.length;
        int l = ad1[0].length;
        if(i != k || j != l)
            System.out.println("Matrix.Size");
        double ad2[][] = new double[i][j];
        for(int i1 = 0; i1 < i; i1++)
        {
            for(int j1 = 0; j1 < j; j1++)
                ad2[i1][j1] = ad[i1][j1] - ad1[i1][j1];

        }

        return ad2;
    }

    public static double oneNorm(double ad[][])
    {
        checkMatrix(ad);
        int i = ad.length;
        int j = ad[0].length;
        double d = 0.0D;
        for(int k = 0; k < j; k++)
        {
            double d1 = 0.0D;
            for(int l = 0; l < i; l++)
                d1 += Math.abs(ad[l][k]);

            if(d1 > d)
                d = d1;
        }

        return d;
    }

    public static double frobeniusNorm(double ad[][])
    {
        checkMatrix(ad);
        double d = 0.0D;
        for(int i = 0; i < ad.length; i++)
        {
            double ad1[] = ad[i];
            for(int j = 0; j < ad1.length; j++)
            {
                double d1 = ad1[j];
                d += d1 * d1;
            }

        }

        return Math.sqrt(d);
    }

    public static double infinityNorm(double ad[][])
    {
        checkMatrix(ad);
        int i = ad.length;
        int j = ad[0].length;
        double d = 0.0D;
        for(int k = 0; k < i; k++)
        {
            double d1 = 0.0D;
            for(int l = 0; l < j; l++)
                d1 += Math.abs(ad[k][l]);

            if(d1 > d)
                d = d1;
        }

        return d;
    }

    public static boolean isSymmetric(double ad[][])
    {
        checkMatrix(ad);
        int i = ad.length;
        int j = ad[0].length;
        if(i != j)
            return false;
        for(int k = 1; k < i; k++)
        {
            for(int l = 0; l < k; l++)
                if(ad[k][l] != ad[l][k])
                    return false;

        }

        return true;
    }

    public static double[][] inverseLowerTriangular(double ad[][])
    {
        checkSquareMatrix(ad);
        double d = 2.2250738585072009E-308D;
        int i = ad.length;
        double ad1[][] = new double[i][i];
        for(int j = 0; j < i; j++)
        {
            for(int i1 = j; i1 < i; i1++)
                ad1[j][i1] = ad[i1][j];

        }

label0:
        for(int j1 = 0; j1 < i; j1++)
        {
            int k = i - j1 - 1;
            if(Math.abs(ad1[k][k]) <= d)
                System.out.println("SingularMatrixException.Message");
            ad1[k][k] = 1.0D / ad1[k][k];
            double d1 = -ad1[k][k];
            if(k != i - 1)
            {
                for(int l1 = k + 1; l1 <= k + j1; l1++)
                    ad1[k][l1] *= d1;

            }
            if(k <= 0)
                continue;
            int i2 = 0;
            do
            {
                if(i2 >= k)
                    continue label0;
                double d2 = ad1[i2][k];
                ad1[i2][k] = 0.0D;
                for(int j2 = k; j2 < k + j1 + 1; j2++)
                    ad1[i2][j2] += d2 * ad1[k][j2];

                i2++;
            } while(true);
        }

        for(int l = 0; l < i; l++)
        {
            for(int k1 = 0; k1 < i; k1++)
                if(k1 >= l)
                    ad1[k1][l] = ad1[l][k1];
                else
                    ad1[k1][l] = 0.0D;

        }

        return ad1;
    }

    public static double[][] inverseUpperTriangular(double ad[][])
    {
        checkSquareMatrix(ad);
        int i = ad.length;
        double d2 = 2.2250738585072009E-308D;
        double ad1[][] = new double[i][i];
        for(int j = 0; j < i; j++)
        {
            for(int i1 = j; i1 < i; i1++)
                ad1[i1][j] = ad[j][i1];

        }

label0:
        for(int k = 0; k < i; k++)
        {
            if(Math.abs(ad1[k][k]) <= d2)
                System.out.println("SingularMatrixException.Message");
            ad1[k][k] = 1.0D / ad1[k][k];
            double d = -ad1[k][k];
            if(k > 0)
            {
                for(int j1 = 0; j1 < k; j1++)
                    ad1[k][j1] *= d;

            }
            if(i <= k)
                continue;
            int k1 = k + 1;
            do
            {
                if(k1 >= i)
                    continue label0;
                double d1 = ad1[k1][k];
                ad1[k1][k] = 0.0D;
                for(int i2 = 0; i2 < k + 1; i2++)
                    ad1[k1][i2] += d1 * ad1[k][i2];

                k1++;
            } while(true);
        }

        for(int l = 0; l < i; l++)
        {
            for(int l1 = 0; l1 < i; l1++)
                if(l1 >= l)
                    ad1[l][l1] = ad1[l1][l];
                else
                    ad1[l][l1] = 0.0D;

        }

        return ad1;
    }

}
