
package archeopterix.util.statistics.timeseries.ARIMA;


// Referenced classes of package com.imsl.math:
//            Matrix, BLAS

public class SVD
{
	    private static final double EPSILON_LARGE = 2.2204460492503E-016D;
    private static final int maxit = 30;
    private double u[][];
    private double v[][];
    private double s[];
    private int info;
    private int rank;
    public static class DidNotConvergeException extends STATException
    {

        private static final long serialVersionUID = 0x2418ff52fe8d540eL;

        public DidNotConvergeException(String s1)
        {
            super(s1);
        }

        public DidNotConvergeException(String s1, Object aobj[])
        {
            super( s1+ aobj);
        }
    }


    public SVD(double ad[][], double d)
        throws DidNotConvergeException
    {
        Matrix.checkMatrix(ad);
        double d13 = 0.0D;
        int k = ad.length;
        int l = ad[0].length;
        for(int i1 = 0; i1 < k; i1++)
        {
            double d14 = 0.0D;
            double ad1[] = ad[i1];
            for(int k1 = 0; k1 < l; k1++)
                d14 += ad1[k1];

            d13 = Math.max(d13, d14);
        }

        boolean flag = false;
        double d15 = d >= 0.0D ? d : -d * d13;
        int j1 = k;
        info = 0;
        int j = Math.min(k - 1, l);
        int i = Math.max(0, Math.min(l - 2, k));
        int l1 = Math.max(j, i);
        double ad2[] = new double[l];
        double ad3[] = new double[k + Math.max(k, l)];
        s = new double[Math.min(k + 1, l)];
        u = new double[j1][k];
        v = new double[l][l];
        double ad4[] = new double[1];
        double ad5[] = new double[1];
        double ad6[] = new double[1];
        double ad7[] = new double[1];
        double ad8[] = new double[1];
        ad = Matrix.transpose(ad);
        if(l1 >= 1)
        {
            for(int i2 = 1; i2 <= l1; i2++)
            {
                s[i2 - 1] = 0.0D;
                if(i2 <= j)
                {
                    s[i2 - 1] = BLAS.nrm2((k - i2) + 1, ad[i2 - 1], i2 - 1);
                    if(s[i2 - 1] >= 4.9406564584124654E-324D)
                    {
                        if(ad[i2 - 1][i2 - 1] != 0.0D)
                        {
                            s[i2 - 1] = Math.abs(s[i2 - 1]);
                            if(ad[i2 - 1][i2 - 1] < 0.0D)
                                s[i2 - 1] = -s[i2 - 1];
                        }
                        BLAS.scal((k - i2) + 1, 1.0D / s[i2 - 1], ad[i2 - 1], i2 - 1);
                        ad[i2 - 1][i2 - 1] = 1.0D + ad[i2 - 1][i2 - 1];
                    }
                    s[i2 - 1] = -s[i2 - 1];
                }
                if(l >= i2 + 1)
                {
                    if(i2 <= j && Math.abs(s[i2 - 1]) >= 4.9406564584124654E-324D)
                    {
                        BLAS.gemv('T', (k - i2) + 1, (l - (i2 + 1)) + 1, -1D / ad[i2 - 1][i2 - 1], ad, i2, i2 - 1, ad[i2 - 1], i2 - 1, 0.0D, ad3, k);
                        BLAS.ger((k - i2) + 1, (l - (i2 + 1)) + 1, 1.0D, ad[i2 - 1], i2 - 1, ad3, k, ad, i2, i2 - 1);
                    }
                    for(int k2 = i2; k2 < l; k2++)
                        ad2[k2] = ad[k2][i2 - 1];

                }
                if(i2 <= j)
                {
                    for(int l2 = i2 - 1; l2 < k; l2++)
                        u[i2 - 1][l2] = ad[i2 - 1][l2];

                }
                if(i2 > i)
                    continue;
                ad2[i2 - 1] = BLAS.nrm2(l - i2, ad2, i2);
                if(ad2[i2 - 1] >= 4.9406564584124654E-324D)
                {
                    if(ad2[i2] != 0.0D)
                    {
                        ad2[i2 - 1] = Math.abs(ad2[i2 - 1]);
                        if(ad2[i2] < 0.0D)
                            ad2[i2 - 1] = -ad2[i2 - 1];
                    }
                    BLAS.scal(l - i2, 1.0D / ad2[i2 - 1], ad2, i2);
                    ad2[i2] = 1.0D + ad2[i2];
                }
                ad2[i2 - 1] = -ad2[i2 - 1];
                if(i2 + 1 <= k && Math.abs(ad2[i2 - 1]) >= 4.9406564584124654E-324D)
                {
                    BLAS.gemv('N', k - i2, (l - (i2 + 1)) + 1, 1.0D, ad, i2, i2, ad2, i2, 0.0D, ad3, i2);
                    BLAS.ger(k - i2, (l - (i2 + 1)) + 1, -1D / ad2[i2], ad3, i2, ad2, i2, ad, i2, i2);
                }
                for(int i3 = i2; i3 < l; i3++)
                    v[i2 - 1][i3] = ad2[i3];

            }

        }
        int j2 = Math.min(l, k + 1);
        if(j < l)
            s[j] = ad[j][j];
        if(k < j2)
            s[j2 - 1] = 0.0D;
        if(i + 1 < j2)
            ad2[i] = ad[j2 - 1][i];
        ad2[j2 - 1] = 0.0D;
        if(j1 >= j + 1)
        {
            for(int j3 = j; j3 < j1; j3++)
                u[j3][j3] = 1.0D;

        }
        if(j >= 1)
        {
            for(int k3 = j; k3 > 0; k3--)
                if(Math.abs(s[k3 - 1]) >= 4.9406564584124654E-324D)
                {
                    if(j1 >= k3 + 1)
                    {
                        BLAS.gemv('T', (k - k3) + 1, (j1 - (k3 + 1)) + 1, -1D / u[k3 - 1][k3 - 1], u, k3, k3 - 1, u[k3 - 1], k3 - 1, 0.0D, ad3, k);
                        BLAS.ger((k - k3) + 1, (j1 - (k3 + 1)) + 1, 1.0D, u[k3 - 1], k3 - 1, ad3, k, u, k3, k3 - 1);
                    }
                    BLAS.scal((k - k3) + 1, -1D, u[k3 - 1], k3 - 1);
                    u[k3 - 1][k3 - 1] = 1.0D + u[k3 - 1][k3 - 1];
                    if(k3 - 1 >= 1)
                        BLAS.set(k3 - 1, 0.0D, u[k3 - 1], 0);
                } else
                {
                    BLAS.set(k, 0.0D, u[k3 - 1], 0);
                    u[k3 - 1][k3 - 1] = 1.0D;
                }

        }
        for(int l3 = l; l3 > 0; l3--)
        {
            if(l3 <= i && Math.abs(ad2[l3 - 1]) >= 4.9406564584124654E-324D)
            {
                BLAS.gemv('T', l - l3, (l - (l3 + 1)) + 1, -1D / v[l3 - 1][l3], v, l3, l3, v[l3 - 1], l3, 0.0D, ad3, k);
                BLAS.ger(l - l3, (l - (l3 + 1)) + 1, 1.0D, v[l3 - 1], l3, ad3, k, v, l3, l3);
            }
            BLAS.set(l, 0.0D, v[l3 - 1], 0);
            v[l3 - 1][l3 - 1] = 1.0D;
        }

        int i4 = j2;
        int j4 = 0;
        do
        {
            if(j2 != 0 && j4 <= 30)
            {
                byte byte0 = -1;
                int l4 = -1;
                int k5 = 1;
                do
                {
                    if(k5 > j2)
                        break;
                    l4 = j2 - k5;
                    if(l4 == 0)
                        break;
                    double d5 = Math.abs(s[l4 - 1]) + Math.abs(s[l4]);
                    double d16 = d5 + Math.abs(ad2[l4 - 1]);
                    flag = flag || j4 == 29;
                    if(Math.abs(d16 - d5) <= 2.2204460492503E-016D * d16 || flag && Math.abs(ad2[l4 - 1]) <= 2.2204460492503E-016D * d13)
                    {
                        ad2[l4 - 1] = 0.0D;
                        byte0 = 0;
                        break;
                    }
                    k5++;
                } while(true);
                k5 = -1;
                if(l4 == j2 - 1)
                {
                    byte0 = 4;
                } else
                {
                    int i6 = l4 + 1;
                    do
                    {
                        if(i6 > j2 + 1)
                            break;
                        k5 = (j2 - i6) + (l4 + 1);
                        if(k5 == l4)
                            break;
                        double d6 = 0.0D;
                        if(k5 != j2)
                            d6 += Math.abs(ad2[k5 - 1]);
                        if(k5 != l4 + 1)
                            d6 += Math.abs(ad2[k5 - 2]);
                        double d17 = d6 + Math.abs(s[k5 - 1]);
                        if(d17 == d6)
                        {
                            s[k5 - 1] = 0.0D;
                            break;
                        }
                        i6++;
                    } while(true);
                    if(k5 == l4)
                        byte0 = 3;
                    else
                    if(k5 == j2)
                    {
                        byte0 = 1;
                    } else
                    {
                        byte0 = 2;
                        l4 = k5;
                    }
                }
                l4++;
                switch(byte0)
                {
                case 1: // '\001'
                    ad5[0] = ad2[j2 - 2];
                    ad2[j2 - 2] = 0.0D;
                    int j6 = l4;
                    while(j6 <= j2 - 1) 
                    {
                        int i7 = (j2 - 1 - j6) + l4;
                        ad4[0] = s[i7 - 1];
                        BLAS.rotg(ad4, ad5, ad7, ad8);
                        s[i7 - 1] = ad4[0];
                        if(i7 != l4)
                        {
                            ad5[0] = -ad8[0] * ad2[i7 - 2];
                            ad2[i7 - 2] = ad7[0] * ad2[i7 - 2];
                        }
                        BLAS.rot(l, v[i7 - 1], 0, v[j2 - 1], 0, ad7, ad8);
                        j6++;
                    }
                    break;

                case 2: // '\002'
                    ad5[0] = ad2[l4 - 2];
                    ad2[l4 - 2] = 0.0D;
                    int k6 = l4;
                    while(k6 <= j2) 
                    {
                        ad4[0] = s[k6 - 1];
                        BLAS.rotg(ad4, ad5, ad7, ad8);
                        s[k6 - 1] = ad4[0];
                        ad5[0] = -ad8[0] * ad2[k6 - 1];
                        ad2[k6 - 1] = ad7[0] * ad2[k6 - 1];
                        BLAS.rot(k, u[k6 - 1], 0, u[l4 - 2], 0, ad7, ad8);
                        k6++;
                    }
                    break;

                case 3: // '\003'
                    double d1 = Math.max(Math.abs(s[j2 - 1]), Math.abs(s[j2 - 2]));
                    d1 = Math.max(d1, Math.abs(ad2[j2 - 2]));
                    d1 = Math.max(d1, Math.abs(s[l4 - 1]));
                    d1 = Math.max(d1, Math.abs(ad2[l4 - 1]));
                    double d2 = s[j2 - 1] / d1;
                    double d3 = s[j2 - 2] / d1;
                    double d7 = ad2[j2 - 2] / d1;
                    double d9 = s[l4 - 1] / d1;
                    double d10 = ad2[l4 - 1] / d1;
                    double d11 = ((d3 + d2) * (d3 - d2) + d7 * d7) / 2D;
                    double d8 = d2 * d7 * (d2 * d7);
                    double d12 = 0.0D;
                    if(d11 != 0.0D || d8 != 0.0D)
                    {
                        d12 = Math.sqrt(d11 * d11 + d8);
                        if(d11 < 0.0D)
                            d12 = -d12;
                        d12 = d8 / (d11 + d12);
                    }
                    ad5[0] = (d9 + d2) * (d9 - d2) - d12;
                    ad6[0] = d9 * d10;
                    for(int l6 = l4; l6 <= j2 - 1; l6++)
                    {
                        BLAS.rotg(ad5, ad6, ad7, ad8);
                        if(l6 != l4)
                            ad2[l6 - 2] = ad5[0];
                        ad5[0] = ad7[0] * s[l6 - 1] + ad8[0] * ad2[l6 - 1];
                        ad2[l6 - 1] = ad7[0] * ad2[l6 - 1] - ad8[0] * s[l6 - 1];
                        ad6[0] = ad8[0] * s[l6];
                        s[l6] = ad7[0] * s[l6];
                        BLAS.rot(l, v[l6 - 1], 0, v[l6], 0, ad7, ad8);
                        BLAS.rotg(ad5, ad6, ad7, ad8);
                        s[l6 - 1] = ad5[0];
                        ad5[0] = ad7[0] * ad2[l6 - 1] + ad8[0] * s[l6];
                        s[l6] = -ad8[0] * ad2[l6 - 1] + ad7[0] * s[l6];
                        ad6[0] = ad8[0] * ad2[l6];
                        ad2[l6] = ad7[0] * ad2[l6];
                        if(l6 < k)
                            BLAS.rot(k, u[l6 - 1], 0, u[l6], 0, ad7, ad8);
                    }

                    ad2[j2 - 2] = ad5[0];
                    j4++;
                    break;

                case 4: // '\004'
                    if(s[l4 - 1] < 0.0D)
                    {
                        s[l4 - 1] = -s[l4 - 1];
                        BLAS.scal(l, -1D, v[l4 - 1], 0);
                    }
                    for(; l4 != i4; l4++)
                    {
                        if(s[l4 - 1] >= s[l4])
                            continue;
                        double d4 = s[l4 - 1];
                        s[l4 - 1] = s[l4];
                        s[l4] = d4;
                        if(l4 < l)
                            BLAS.swap(l, v[l4 - 1], 0, v[l4], 0);
                        if(l4 < k)
                            BLAS.swap(k, u[l4 - 1], 0, u[l4], 0);
                    }

                    j4 = 0;
                    j2--;
                    break;
                }
                continue;
            }
            if(j4 < 30)
            {
                int k4 = Math.min(l + 1, k);
                int i5 = Math.min(l, k);
                rank = i5;
                int l5 = 0;
                do
                {
                    if(l5 >= i5)
                        break;
                    if(Math.abs(s[l5]) <= d15)
                    {
                        rank = l5;
                        break;
                    }
                    l5++;
                } while(true);
            } else
            {
                info = j2;
                Object aobj[] = {
                    new Integer(j2), new Integer(Math.min(k, l))
                };
                throw new DidNotConvergeException("SVD.DidNotConverge", aobj);
            }
            if(k < l)
            {
                double ad9[] = new double[k];
                for(int j5 = 0; j5 < k; j5++)
                    ad9[j5] = s[j5];

                s = ad9;
            }
            break;
        } while(true);
    }

    public SVD(double ad[][])
        throws DidNotConvergeException
    {
        this(ad, 2.2204460492503001E-014D);
    }

    public int getRank()
    {
        return rank;
    }

    public double[][] getU()
    {
        return Matrix.transpose(u);
    }

    public double[][] getV()
    {
        return Matrix.transpose(v);
    }

    public double[] getS()
    {
        return s;
    }

    public int getInfo()
    {
        return info + 1;
    }

    public double[][] inverse()
    {
        double ad[][] = new double[v.length][u.length];
        for(int i = 0; i < ad.length; i++)
        {
            for(int j = 0; j < ad[i].length; j++)
            {
                double d = 0.0D;
                for(int k = 0; k < rank; k++)
                    d += (u[k][j] * v[k][i]) / s[k];

                ad[i][j] = d;
            }

        }

        return ad;
    }



}
